;;;(load "initogl")
;-----------------------------------------------------------

(define  *hexa-u* 
  '( ((0 0 1)(0 1 1) )
     ((1 0 1)(1 1 1) )  ) ) 
(define  *hexa-b*
  '( ((0 0 0)(0 1 0) )
     ((1 0 0)(1 1 0) )  ) )




;----------------------------------------------------------------------
;
;
;---------------------------------------------------------------------- 
(define *poly* ())   ;;;; list of dlist number , each is surface
(define *cmds* ())
(define *dlist* 0)

(define (plot_poly path data)
  (let ((d1 0)(d2 0))
    (set! *dlist* (path 'newlist))
    (set! *cmds* ())

    (set! d1 (pop data))
    (do ()
        ((null? data))
        (set! d2 (pop data))
        (plot_poly_sub  d1 d2)
        (set! d1 d2)
    )
   (eval `(,path 'eval :newlist *dlist* 'compile ,@(reverse *cmds*)) ())
   (path 'eval :endlist)
   (push *dlist* *poly*)
))
(define (plot_poly_sub  d1 d2)
  (let ((d 0)(y 0))
    (do ((e 0)(y2 0)(ret 0))
        ((or (null? d1)(null? d2)))
        (set! d (pop d1))
        (set! y (cadr d))
        (set! ret (find-y y d2))
        (if ret 
             (when (pair? ret)
                 (set! d2 ret)
                 (set! e (pop d2))
                 (write-poly d  e d1 d2)
             )
          (set! d2 ())
        )
    )
 ))
(define (find-y y d2)
  (let ((y2 (cadar d2)))
     (cond ((= y y2) d2)
           ((< y y2) #t)
           (#t 
             (do ((e 0)(ans #f))
                 ((or ans (null? d2))  ans)
                 (set! e (car d2))
                 (if (= y (cadr e))
                      (set! ans d2)
                      (pop d2)
                 )
             )
           )
     )
))
        
(define ( write-poly   d e d1 d2  ) 
    ;;global poly
  (when (pair? d1)
    (write-poly-sub d e (car d1))
    (if (pair? d2) (write-poly-sub  e (car d2)(car d1)))
  )
)

(define (write-poly-sub d e f)
   (let ((norm 0))
	(push  :begin *cmds*)
        (push ''polygon *cmds*)
        (set! norm (normal-vec d e f))
        (push :normal *cmds*)
        (set! *cmds* (append (reverse norm ) *cmds*))
        (push :vertex *cmds*)
         (set! *cmds* (append (reverse d ) *cmds*))
        (push :vertex *cmds*)
         (set! *cmds* (append (reverse e ) *cmds*))
        (push :vertex *cmds*)
         (set! *cmds* (append (reverse f ) *cmds*))
        (push :end *cmds*)
))
(define (normal-vec d e f)
   (let ((x (-vec e d)) (y (-vec f d)))
       (gaiseki x y)
))
(define (gaiseki x y)
   (let ((x1 (car x))(x2 (cadr x))(x3 (caddr x))
         (y1 (car y))(y2 (cadr y))(y3 (caddr y)))
       (list (- (* x2 y3)(* x3 y2)) (- (* x3 y1)(* x1 y3))(- (* x1 y2)(* x2 y1)))
))
(define (-vec d e)
  (map (lambda(x y)(- x y)) d e)
)

;----------------------------------------------------------------------
;
;  rotation_bindings creates window bindings that perform rotation 
;  transformations corresponding to mouse drag actions
;
;----------------------------------------------------------------------
(define xrot 0)
(define yrot 0)
(define mouse-x 0)
(define mouse-y 0)

(define ( rotation_bindings  path ) 
    ;;global xrot yrot
    (set! xrot 0 )
    (set! yrot 0)
    (bind path "<Button-1>"  (lambda (x y) (set! mouse-x x) (set! mouse-y y )))
    (bind path "<B1-Motion>"  (lambda (x y) 
	(set! xrot (+  xrot (- x mouse-x) ))
	(set! yrot (+  yrot (- y mouse-y) ))
	(set! mouse-x x)
	(set! mouse-y y)
	(path 'eval :matrixmode 'modelview 
            :popmatrix 
	    :pushmatrix 
            :rotate yrot 1 0 0
            :rotate xrot 0 1 0)
	(path 'redraw)
     ))
)

;----------------------------------------------------------------------
;
;----------------------------------------------------------------------


(define ( polybuild  path   ) 
    (path 'eval :newlist *dlist* 'compile)
	( path 'eval
		:enable 'lighting 
		:disable 'stenciltest 
		:polygonmode 'frontandback 'fill) 
      ( foreach dl *poly* 
		(path 'eval :call dl)
      )
	
    ;;;;
    (path 'eval :endlist)
)

;(define ( redraw )   ;;;;args )
;    ;;global mode type variation dlist
;    (polybuild .gl  dlist )
;    (.gl 'redraw)
;)


;(init_polybuild)
(pack (OGLwin '.gl :aspect 1 :stencil 8) :side 'left :fill 'both :expand 'yes)
;(set! *dlist* (.gl 'newlist))

(pack (frame '.cmd) :side 'left :fill 'y)
(pack (frame '.cmd.main) :side 'top :fill 'x)

; quit button
(pack (button '.cmd.main.quit :text "Quit" :command "exit") :side 'left)




; setup of initial OpenGL display
(define (plot-polygon path . datalist)
  (foreach data datalist
    (plot_poly path data  )
  )
  (set! *dlist* (path 'newlist))
  (polybuild path  )
  (path 'eval
    :matrixmode 'projection
    :loadidentity
    :perspective 20 1 0.5 20
    :matrixmode 'modelview
    :loadidentity
    :lookat 0 0 10 0 0 0 0 1 0
    :pushmatrix
    :material 'front 'ambient 0.3 0.3 0.3
    :material 'front 'diffuse 0.5 0.5 0.5
    :material 'front 'specular 0.3 0.3 0.3
    :material 'front 'shininess 40
    :light 'light0 'position 1 1 1 0
    :light 'light0 'ambient 1 1 1
    :light 'light0 'diffuse 1 1 1
    :light 'light0 'specular 1 1 1
    :clearcolor 0 0 1
    :enable 'lighting :enable 'light0 :enable 'light1
    :enable 'depthtest
 )
  (path 'main :clear 'colorbuffer 'depthbuffer 'stencilbuffer
    :call *dlist*)
)

(plot-polygon .gl  *hexa-u*  *hexa-b* )
;(plot_poly .gl *hexa-b*  )

(rotation_bindings .gl)



