/*** func.c   ***/
/***   function object  ****/

#define  FUNC_C

#include "lisp.h"
#define prin_s(p)   lwritestr(lpath,p)
#define format(p,obj)   sprintf(iobuff,p,obj)
#define WRITE         lwritestr(lpath,iobuff)
extern ptr k_T;


/***   compiled special,lambda, macro   */
ptr make_subr(ptr (*addr)(),ptr type,ptr env){
  Reg ptr f,g;
  long ftype;
   /** printf("make_subr: addr %x type %x env %x\n",addr ,type,env); **/
  ftype=(long)type;
  f=new_cell(ftype&CLOSURE);
  //CAR(f)=type;  //FTYPE  now not used!
  //CAR(f)=ZERO;  // to be delete
  CAR(f)=env;
   CDR(f)=(ptr)addr; // binary
  EXATTR(f)=(ftype&0xffff)|(ftype&TKFUNC);   // argtype, TKFUNC  
   return f;
  /***   2019.12.31  SUBRADD deleted
  *stack++=f;
   g=new_cell(SUBRADD);  
                     //  for gbc to easy, and this informs compiled! 
   CDR(f)=g;
   CAR(g)=env;
   CDR(g)=(ptr)addr; // binary
   stack--;
  return f;
  ***/
}

/****  closure lambda whole =(args . body)****/
/***  Not used  ***/
/**
static ptr get_argtype(ptr arg){
  int n=0,m=0;
   while(CONSP(arg)){
      n++;
      arg=CDR(arg);
   }
  if(SYMBOLP(arg)) m++;
  return (ptr)MAKESINT((n<<1)+m);
}
**/


ptr subr_argtype(int n,int m){
return (ptr)MAKESINT((n<<1)+m);
}


/****  for debug     procedure information  *****/
/****     (procedure-info func)   ***/
ptr s_procedure(int narg,ptr env){
  int m,n,bin=1;
  Reg ptr q,res;
    q=*(stack-1);
    checknarg(narg-1);
    m=ATTR(q);
    //n=(long)FTYPE(q);
    n=EXATTR(q);
     if(m&LAMBDA){
       if(n&TKFUNC){
              res=a_tk;
          }
         else if(n&SRFUNC){
             if(n&SYNTAX)
               res=a_syntax_lambda;
             else
               res=a_sr2;
            bin=0;
           
         }
          else{
              res=a_system;
           }
        }
     else if(m&SPECIAL){
          res=a_special;
      }
     else
          return a_f;
     res=SCONS(res,a_nil);
     psh(res);
     if(bin){
       n&=0xffff;
       n=GETNUM(n);
       m=n&1;
       n>>=1;
       res=CDR(res)=CONS(MAKESINT(n),a_nil);
       res=CDR(res)=CONS(MAKESINT(m),a_nil);
     }
     res=CDR(res)=CONS(CAR(q),a_nil);
      if(!bin){//sr2
           CDR(res)=CONS(CDR(q),a_nil);  /***  alloc **/
      }
    res=*(stack-1);
    pull();
   return res;
}

ptr s_procedurep(int narg,ptr env){
  int m,n;
  Reg ptr q;
    q=*(stack-1);
    checknarg(narg-1);
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)) q=ATOMVAL(q);
    if(SREGP(q))  return a_f;
    m=ATTR(q);
     return PRED(m&LAMBDA);
}

ptr s_systemprocedurep(int narg,ptr env){ /*** system-procedure?  ***/
  int m,n;
  Reg ptr q;
    q=*(stack-1);
    checknarg(narg-1);
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)) q=ATOMVAL(q);
    if(SREGP(q))  return a_f;
    m=ATTR(q);
     return PRED(m==SLAMBDA);
}

ptr s_tk_procedurep(int narg,ptr env){
  int m,n;
  Reg ptr q;
    q=*(stack-1);
    checknarg(narg-1);
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)) q=ATOMVAL(q);
    if(SREGP(q))  return a_f;
    m=ATTR(q);
    n=EXATTR(q);
    if(m&LAMBDA)
        return PRED(n&TKFUNC);
        //return PRED((int)(long)FTYPE(q)&TKFUNC);
    return a_f;
}


ptr function_name(ptr q){  
    int n;
 again:
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)){
       q=ATOMVAL(q);
       goto again;
    }
    n=ATTR(q);
    if((n&CLOSURE)==0) return a_f;
    //if(ATTR(q)&MACRO) return a_f;
    q=FENV(q);
    if(n==SPECIAL) return q;
    q=assq(k_T,q);
    if(q!=a_f) return CDR(q);
    return q;
}

ptr s_function_name(int nar,ptr env){
  Reg ptr q;
   q=*(stack-1);
    checknarg(nar-1);
    return function_name(q);
}

