/***  kanji.c
     04.5.20 created
     04.11.25  conversion 
  ****/

#define KANJI_C
#include "lisp.h"
#include "kanji.h"
#include  <stdlib.h>    /**** getenv **/
#include  <string.h>    /**** getenv **/

extern ptr make_str_c();
extern ptr s_string_index();

#define CHK 16
extern ptr k_nocase,k_ascii,k_jis,k_sjis,k_euc,k_utf8;

ptr resize_str();
ptr check_jis();
ptr check_euc();
ptr check_sjis();
ptr check_utf8();
ptr kanji_type();
ptr KANJI_MODE;

ptr set_kmode(){
   char *s;
   char jp[20];
   ptr utf;
    utf=make_str_c("utf");
    psh(utf);
    s=getenv("LANG");
    if(s==NULL){  
       /*** English system HAVENOT LANG!  2014.5.17 sato   ***/
       pull();
       kanji_mode=0;
       KANJI_MODE=a_f;
       return a_f;
    }
    psh(make_str_c(s));
    psh(k_nocase);
    utf=s_string_index(3,a_nil);  /*** see str.c  ***/
    jp[0]=*s;
    jp[1]=*(s+1);
    jp[2]='\0';
    /*** if(strcmp(s,"ja_JP.UTF-8")==0){    ***  in Ubuntu ja_JP.utf8 ***/
    if(utf!=a_f){
          kanji_mode=3;
          KANJI_MODE=k_utf8;
     }
    else if(strcmp(jp,"ja")==0){
          kanji_mode=2;
          KANJI_MODE=k_euc;
    }
    else{
          kanji_mode=0;
          KANJI_MODE=a_f;
    }
  pull();
  pull();
  pull();
  return KANJI_MODE;
}
        
ptr s_kanji_mode(int narg,ptr env){
  ptr p;
  if(narg==0){
       /** return PRED(kanji_mode); **/
       return KANJI_MODE;
    }
  else if (narg==1){
      p=*(stack-1);
      if(p==a_f) {
          kanji_mode=0;
          KANJI_MODE=a_f;
         return a_f;
      }
    if(p==k_utf8){
          kanji_mode=3;
          KANJI_MODE=p;
    }
    else if(p==k_euc){
          kanji_mode=2;
          KANJI_MODE=p;
      }
      else 
         set_kmode();
   return  KANJI_MODE;
}
 else
 checknarg(narg-1);
 return a_f;
}

ptr s_kanji_error(int narg,ptr env){
  if(narg==0){
       return PRED(kanji_error);
    }
  else if (narg==1){
      kanji_error=(*(stack-1)!=a_f);
       return PRED(kanji_error);
}
 else
 checknarg(narg-1);
 return a_f;
}


/***   kanji conversion    ****/
int kuten_sjis(int n)
{
   int k,p,f,b;
    k=n>>8;
    p=n&0xff;
   if(k&1){
      if(k<=61)
           f=(k+257)/2;
      else
           f=(k+385)/2;
      if(p<=63)
            b=p+63;
      else
           b=p+64;
     }
   else{
     if(k<=62)
         f=(k+256)/2;
     else
         f=(k+384)/2;
      b=p+158;
   }
  return (f<<8)+b;
}

int sjis_kuten(int n){
  int k,p,f,b;
   f=n>>8;
    b=n&0xff;
    if(b>=159) {  /***  K even ***/
       p=b-158;
       if(f<=0x9f)  /*** 1-62 ku  ***/
           k=2*f-256;
       else
           k=2*f-384;
     }
    else{
       if(f<=0x9f)
           k=2*f-257;
       else
          k=2*f-385;
       if(b<=126)
           p=b-63;
       else
           p=b-64;
    }
   return (k<<8)+p;
}

ptr s_euc_sjis(int narg,ptr env)
{
  Reg ptr new;
  Reg Uchar *p,*q,*r;
  ptr x;
  int n,c,b,kconv_error=0;
  Uint s;
  checknarg(narg-1);
  x=*(stack-1);
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  p=get_string(x,(Uint *)&n);
  new=makestring(n);
  r=q=get_string(new,&s);
  while(n--){
    if(n<0) {
        kconv_error=1;
        break;
     }
    c=*p++;
    if(c<=0x7f) *q++=c;
    else if(c==0x8e){
        *q++=*p++;
        n--;
   }
   else if(euc_first(c)){
      b=*p++;
      n--;
      c=(c<<8)+b;
      c=kuten_sjis(c-0xa0a0);
      *q++=(c>>8);
      *q++=c&0xff;
   }
   else{
        kconv_error=1;
        if(kanji_error) break;
        *q++='?';
   }
 }
 if(kconv_error) {
    if(kanji_error) error(E_kconv,new);
    ATOMVAL(a_errno)=MAKESINT(E_kconv);
 }
 if((r+s)==q)
   return new;
 else
   return resize_str(new,q-r);
}
 
ptr resize_str(ptr x,int s){
 Reg ptr new;
 Reg Uchar *p,*q;
 Uint n;
  p=get_string(x,&n);
  new=makestring(s);
  q=get_string(new,&n);
  while(n--) *q++=*p++;
  *q++=0;
 return new;
}

      
ptr s_sjis_euc(int narg,ptr env)
{
  Reg ptr new,out;
  Reg Uchar *p;
  ptr x;
  int n,c,b,kconv_error=0,s;
  checknarg(narg-1);
  x=*(stack-1);
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  p=get_string(x,(Uint *)&n);
  new=makestring(n);
  psh(new);
  out=open_str(new,write_ac);
  *(stack-1)=out;
 
  while(n--){
    if(n<0) {
        kconv_error=1;
        break;
     }
    c=*p++;
    if(c<=0x7f) str_writec(out, c);
    else if(((c>=0x81)&&(c<=0x9f))||((c>=0xe0)&&(c>=0xef))){
        c=(c<<8)+(*p++);
        c=sjis_kuten(c);
        c+=0xa0a0;
        str_writec(out, c>>8);
        str_writec(out, c&0xff);
        n--;
   }
   else if((c>=0xa0)&&(c<=0xdf)){
        str_writec(out, 0x8e);
        str_writec(out, c);
   }
   else{
        kconv_error=1;
        if(kanji_error) break;
        str_writec(out, '?');
   }
 }
  new=close_str(out);
  pull();
 if(kconv_error) {
      if(kanji_error) error(E_kconv,new);
       ATOMVAL(a_errno)=MAKESINT(E_kconv);
  }
   return new;
}

ptr s_jis_euc(int narg,ptr env)
{
  Reg ptr new,out;
  Reg Uchar *p;
  ptr x;
  int n,c,mode=0,kconv_error=0;
  checknarg(narg-1);
  x=*(stack-1);
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  p=get_string(x,(Uint *)&n);
  new=makestring(n);
  psh(new);
  out=open_str(new,write_ac);
  *(stack-1)=out;

  while(n--){
    if(n<0) {
        kconv_error=1;
        break;
     }
    c=*p++;
    if(c==27) {  /***  esc ***/
        c=*p++;
        n--;
        if(c=='('){
             p++;   /** in ASCII  ***/
             n--;
             mode=0;
         }
        else if(c=='$'){
             p++;   /** JIS  **/
             n--;
             mode=1;
        }
        else{
          kconv_error=1;
         if(kanji_error) break;
        }
     }
    else if(mode){ /*** JIS ***/
        str_writec(out, c+0x80);
        c=*p++;
        n--;
        str_writec(out, c+0x80);
    }
    else 
       str_writec(out, c);
 }
  new=close_str(out);
  pull();
 if(kconv_error){
      if(kanji_error) error(E_kconv,new);
       ATOMVAL(a_errno)=MAKESINT(E_kconv);
  }
   return new;
}

ptr s_euc_jis(int narg,ptr env)
{
  Reg ptr new,out;
  Reg Uchar *p;
  ptr x;
  int n,c,mode=0,kconv_error=0;
  checknarg(narg-1);
  x=*(stack-1);
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  p=get_string(x,(Uint *)&n);
  new=makestring(n);
  psh(new);
  out=open_str(new,write_ac);
  *(stack-1)=out;

  while(n--){
    if(n<0) {
        kconv_error=1;
        break;
     }
    c=*p++;
    if(c<0x80) { 
        if(mode){
           str_writec(out, 27);
           str_writec(out, '(');
           str_writec(out, 'B');
           mode=0;
        }
        str_writec(out, c);
     }
    else if(euc_first(c)){
        if(mode==0){
           str_writec(out, 27);
           str_writec(out, '$');
           str_writec(out, 'B');
           mode=1;
        }
         str_writec(out, c-0x80);
        c=*p++;
        n--;
         str_writec(out, c-0x80);
    }
    else{
          kconv_error=1;
          if(kanji_error) break;
           str_writec(out, '?');
      }
  }
    if(mode){
           str_writec(out, 27);
           str_writec(out, '(');
           str_writec(out, 'B');
           mode=0;
        }

  new=close_str(out);
  pull();
 if(kconv_error) {
    if(kanji_error) error(E_kconv,new);
    ATOMVAL(a_errno)=MAKESINT(E_kconv);
 }
   return new;
}

/***  code hantei  ***/
ptr s_kanji_type(int narg,ptr env)
{
  Reg ptr new,out;
  Reg Uchar *p;
  ptr x;
  Uint n,c,mode=0;
  checknarg(narg-1);
  x=*(stack-1);
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  p=get_string(x,&n);
  return kanji_type(p,n);
}

ptr kanji_type(Uchar *p,int n)
{
  unsigned int c,m;
  Uchar *esc=NULL;
  ptr x;
   while(n){
     c=*p;
     if((c==27)&&(esc==NULL)){
             esc=p;
             m=n;
     }
     if(c>=0x80) break;
     n--;
     p++;
  }
  if(n==0){
     if(esc!=NULL) return check_jis(esc,m,CHK);
     return k_ascii;
 }
  if(n==1) return check_sjis(p,n);
  if((c==0x80)||(c==0xff)) return a_f;
  x=check_utf8(p,n);
  if(x!=a_f) return x;
  x=check_euc(p,n);
  if(x!=a_f) return x;
  return check_sjis(p,n); /*** most wide match code ***/
}

ptr check_jis(Uchar *p,int n,int ct)
{
  unsigned int c,d,mode;
  p++;
  c=*p++;
  d=*p++;
  /*** printf("check jis %c %c %d\n",c,d,ct); ***/
  if(c=='(') {
       if((d=='B')||(d=='J'))
           mode=0;
       else return a_f;
 }
 else if((c=='$')&&(d=='B'))  mode=1;
 else return a_f;
  if(ct<=0) return k_jis;
  n-=3;
  while((n>0)&&(ct>0)){
   c=*p;
   if(c==27) return  check_jis(p,n,ct-1);
   if(mode){
      if((c<0x21)||(c>0x7e)) return a_f;
      p++;
      n--;
      c=*p;
      if((c<0x21)||(c>0x7e)) return a_f;
      ct--;
  }
  p++;
   n--;
  }
  if(n<0) return a_f;
  return k_jis;
}

ptr check_euc(Uchar *p,int n)
{
  Uchar c,d,chk=CHK;
 while((n>0)&&(chk>0)){
    c=*p++;
    n--;
   if(c<0x80) continue;
    d=*p++;
    n--;
   if(euc_code(c,d)){
     chk--;
     continue;
   }
   else
    return a_f;
 }
  return k_euc;
}

int sjis_second(Uchar d)
{
   /*** assume first is checked ***/
     return (d>=0x40)&&(d<=0xfc);
}

int sjis_first(Uchar c)
{
   if((c>=0xa0)&&(c<=0xdf)) return 1;
  if(((c>=0x81)&&(c<=0x9f))||((c>=0xe0)&&(c<=0xef))){
         return 2;
    }
  return 0;
}

ptr check_sjis(Uchar *p,int n)
{
  Uchar c,d,chk=CHK;
  int k;
 while((n>0)&&(chk>0)){
    c=*p++;
    n--;
   if(c<0x80) continue;
   k=sjis_first(c);
   if(k==1) continue;
   if(k==0) return a_f;
    d=*p++;
    n--;
   if(sjis_second(d)){
     chk--;
     continue;
   }
   else
    return a_f;
 }
  return k_sjis;
}
int euc_code(Uchar b,Uchar c)
{
  if((b>=0xa1)&&(b<=0xfe)){
        if((c>=0xa1)&&(c<=0xfe)) return 1;
    }
  else if((b==0x8e)&&(c>=0xa0)&&(c<=0xdf)) /**  kana  **/
     return 1;
  return 0;
}

int euc_first(Uchar b)
{
  if((b==0x8e)||((b>=0xa1)&&(b<=0xfe))){
         return 1;
    }
  return 0;
}

int utf8_first(Uchar c)
{
   if((c>=0xc2)&&(c<=0xdf)) return 2;
   if((c>=0xe0)&&(c<=0xef)){
         return 3;
    }
   if((c>=0xf0)&&(c<=0xf7)){  /* 2019.10.3 */
         return 4;
   }
  return 0;
}

int utf8_byte(Uchar c)  /***  2nd or 3rd ***/
{
   if((c>=0x80)&&(c<=0xbf)) return 1;
  return 0;
}


ptr check_utf8(Uchar *p,int n)
{
  Uchar c,d,chk=CHK;
  int k;
 while((n>0)&&(chk>0)){
    c=*p++;
    n--;
   if(c<0x80) continue;
   k=utf8_first(c);
   if(k==0) return a_f;
    d=*p++;
    n--;
   if(k==2) {
      if(utf8_byte(d)) continue;
      return a_f;
   }
   else{
       if(!utf8_byte(d)) return a_f;
        d=*p++;
        n--;
       if(!utf8_byte(d)) return a_f;
     chk--;
   }
 }
  return k_utf8;
}

/*** jis <-> sjis  ***/
ptr s_jis2sjis(int narg,ptr env)
{
  ptr s;
  int j;
  checknarg(narg-1);
  s=*(stack-1);
  if(!SINTP(s)) error(E_notnum,s);
  j=GETNUM(s);
  j=kuten_sjis(j-0x2020);
  return MAKESINT(j);
}

ptr s_sjis2jis(int narg,ptr env)
{
  ptr s;
  int j;
  checknarg(narg-1);
  s=*(stack-1);
  if(!SINTP(s)) error(E_notnum,s);
  j=GETNUM(s);
  j=sjis_kuten(j);
  return MAKESINT(j+0x2020);
}

 

