/*** s_load.c   ***/

#define SLOAD_C
/** #define DEBUG  ***/

#include "lisp.h"
#include <stdio.h>   
#include <string.h>


static void load_sr();
static void load_sr2();

int load_verbose=YES,load_print=YES;
int search_verbose=YES;
static char *file_ext[6]={".sr2",".ss2",".ss",".scm",".lsp",".stk"};
//static char *file_ext[6]={".ss",".sr2",".ss",".scm",".lsp",".stk"};  //DEBUG
extern ptr sys_close();
extern int verbose_mode;
extern void make_prompt(void);
extern char *get_ext(char *);
static ptr filename; 
//static char pathname[500];
/*** static int ssflag; ***/

/****     load  needs catch-error  for close!
   &  t  s_load init_load ****/
 
static ptr sload(stream,env)
  Reg ptr stream;
  Reg ptr env;
{
    Reg ptr p,s;    /*** !!! ***/
    Reg ptr pack;
    extern int level;
    extern ptr k_BSR,k_ESR;
   
   //fprintf(stderr,"sload enter\n"); 
    pack=ATOMVAL(a_package);
     /** return top(stream);  ***/
            p=gread(stream); 
            if(p==a_begin_sr2) {
                 load_sr2(stream);
                 p=SEOF;
            }
         while(p!=SEOF)
          {
                /*** s=eval_one(p);       12.21  ***/
                 if(load_verbose)
                  {
                    prin1(p,STDMSG);
                   newline(STDMSG);
                 }
#ifdef DEBUG
  lwritestr(STDOUT,"load s= ");
  prin1(p,STDOUT);
   newline(STDOUT);
#endif
                 /*** s=meval(p,a_nil);    V1.99 ***/
         //debug
                // s=a_nil;
                 s=vm_eval(p,a_nil);   /** p is  psh,pull  in  vm_eval **/ 
#ifdef DEBUG
  lwritestr(STDOUT,"in load call meval returns: ");
  prin1(s,STDOUT);
   newline(STDOUT);
#endif
              if(load_print) 
                {
                 prin1(s,STDMSG);
                 newline(STDMSG);  
                }
            p=gread(stream); 
              }
        sys_close(stream); 
    ATOMVAL(a_package)=pack;
   //fprintf(stderr,"sload end\n"); 
    make_prompt();
      return a_undef;
 }
/***
static void load_sr(ptr stream){
    extern int level;
  ptr  p,m,s;
  int lev=level;
  extern ptr list_to_alloc(),s_mc_eval();
  extern ptr k_BSR,k_ESR;
    while(1)
          {
            p=gread(stream);
            if(p==SEOF) break;
            if(p==k_ESR) 
                 break;
               m=list_to_alloc(p,_length(p));
               level=0;
               psh(m);
               psh(a_nil);
              s=s_mc_eval(2,a_nil);
              sp_pull(2);
          }
   level=lev;
}
****/
/***  V2.0  sr2 **/
static void load_sr2(ptr stream){
  ptr  p,s;
  extern ptr call_vm();
    /*** prin1(stream,STDOUT);
    newline(STDOUT);
   ****/
    while(1)
          {
            p=gread(stream);
                /***
                 prin1(p,STDMSG);
                 newline(STDMSG);  
                ****/
            if(p==SEOF) break;
               /** s=eval(p,env); ***/
               psh(p);
               s=call_vm(p,a_nil);  /*** clear env  ***/
                /***
                 prin1(s,STDMSG);
                 newline(STDMSG);  
                ****/
               pull();
          }
}


ptr probe_ext(ptr file,int ssflag){
  ptr stream,s;
  char *p=iobuff,*q;
  int k;
   //fprintf(stderr,"probe_ext ssflag=%d\n",ssflag); /**  debug  ****/
  filename=file;
  stream=open_sub(file,read_ac);
  if(STREAMP(stream)) return stream;
  if(ssflag) ssflag=1;   /**  sr2  V2.0  .sr2  .ss2=1  **/
   pstrcpy(p,file);
   q=get_ext(p);
   if(q!=NULL)  return a_f;
   q=p+strlen(p);
   for(k=ssflag;k<6;k++){
      strcpy(q,file_ext[k]);
      filename=file=CMAKESTR(p);
      psh(file);
          /****
           prin1(file,STDMSG); 
          newline(STDMSG);
           ****/
      stream=open_sub(file,read_ac);
      pull();
     if(STREAMP(stream)){
   //fprintf(stderr,"probe_ext found %s\n",iobuff); /**  debug  ****/
            return stream;
     }
  }
   //fprintf(stderr,"probe_ext Not found %s\n",iobuff); /**  debug  ****/
  return a_f;
}    

static ptr search_path(ptr file,int ssflag,int only){
 ptr name,stream,new,auto_p;
 char *p,*q;
 int n;
  /**  search_verbose=1; // ***  DEBUG  ***/
 p=(char *)get_string(file,(Uint *)&n);
     /** printf("search %s \n",p); ***/
 if(*p=='/') /*** UNIX abs path ***/
    return probe_ext(file,ssflag);
 if((*p=='~')||(*p=='.')){  /*** use sspathname  ***/
      new=sspathname_base(file);
      if(new==a_f) return new;
      psh(new);
      if(search_verbose){
          prin1(new,STDMSG);
      }
      stream=probe_ext(new,ssflag);
      pull();
      return stream;
   }
    
  stream=probe_ext(file,ssflag);
  if(STREAMP(stream)||only) return stream;
  /***
      chdir version is no good because exec in load-file
      in changed  wdir
****/
  /** new=make_str_c(SSLIBDIR);***/
  auto_p=ATOMVAL(a_autopath);
  while(auto_p!=a_nil){
  /** new=a_sslib; ***/
  new=CAR(auto_p);
         /***      prin1(new,STDMSG);   DEBUG ***/
  auto_p=CDR(auto_p);
  psh(new);
  *(stack-1)=new=str_append(new,file);
  if(search_verbose)
              prin1(new,STDMSG);
  stream=probe_ext(new,ssflag);
  pull();
  if(STREAMP(stream)) return stream;
 }
 return stream;
}
   

ptr s_load(int narg,ptr env)
 {
    Reg ptr  p,stream;
    Reg ptr file;  /*** subr 1****/
     checknarg(narg-1);
     file=*(stack-1);  /*** subr 1****/
     
  if(verbose_mode){
     pr_cstr(STDOUT,"s_load : ");
     prin1(file,STDOUT);
     newline(STDOUT);
 }
     if(SREGP(file))
         error(E_open,file);
     if(STREAMP(file))
          return sload(file,a_nil);
     stream=search_path(file,0,0);
   /***
     prin1(stream,STDOUT);
     newline(STDOUT);
   ***/
     file=filename;
     if(!STREAMP(stream))  
       {
         error(E_open,file);
       }
     psh(file);    
     psh(stream);
       if(load_verbose)
        {
          prin1(file,STDMSG);
          newline(STDMSG);
        }
     p=sload(stream,a_nil); 
     sp_pull(2);
        if(verbose_mode){
     pr_cstr(STDOUT,"s_load end---");
     prin1(file,STDOUT);
     newline(STDOUT);
     }
     return file;
  }

ptr s_find_source(int narg,ptr env)
 {
    Reg ptr  p,stream;
    Reg ptr file;  /*** subr 1****/
    int memo,ssflag=0,only=0;
     if(narg==1) ssflag=0;
    /** 2010.9.19  verbose **/
     else if(narg<=3){
          p=*(stack-narg+1);
          if(p==a_f) ssflag=1;
          else if(p==a_t){
               ssflag=1; //ss2,ss etc  not sr2
               only=1;   // only search ./
          }else if(p==ONE){
                only=1;
          }else
            ;
         // p==ZERO
    }
    /** 2010.9.19  verbose if narg==3 **/
     else 
        checknarg(narg-3);
     file=*(stack-narg);
     if(SREGP(file))
         error(E_open,file);
     if(STREAMP(file))
         error(E_notstr,file);
      memo=search_verbose;
      search_verbose=(narg==3);
     // printf("serach_verbose %d\n",search_verbose);
     stream=search_path(file,ssflag,only);
      search_verbose=memo;
     file=filename;
     if(!STREAMP(stream))
       {
         return a_f;
       }
     sys_close(stream);
     return file;
}

static ptr verbose_list(){
 ptr x,res=a_nil;
 x=PRED( search_verbose);
 res=SCONS(x,res);
 x=PRED(load_print);
 res=SCONS(x,res);
 x=PRED(load_verbose);
 return SCONS(x,res);
}

ptr s_load_verbose(int narg,ptr env)
{
  ptr s;
 if(narg==0) return verbose_list();
  checknarg(narg-3);
  s=*(stack-3);
  load_verbose=(s!=a_f);
  s=*(stack-2);
  load_print=(s!=a_f);
  s=*(stack-1);
  search_verbose=(s!=a_f);
  return a_undef;
}
