#define SYSINI
#include "lisp.h"
#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <stdlib.h>
#include <setjmp.h>
#include <string.h>
#ifdef USE_TK
#include <tcl.h>
#endif

extern int init_expr(),init_spform(),car_init();
extern void init_name_char(),init_file(),init_quasi();
extern int init_comp(),init_type(),init_struct(),init_format();
extern void init_keyword(void);
extern void *Mymalloc(),*MyreallocGMP(),MyfreeGMP();
/*** #define DEBUG  ***/

/*** V2.0  ***/
extern void init_VM();
extern void init_ratio();
extern void init_heap(void);
extern void init_gread(void);
extern void init_his(void);
extern void make_boolean(void);
extern ptr set_kmode();
extern ptr makestring_p();
extern ptr make_std_readt(void);
extern void make_prompt(void);
extern void make_nil(void);
extern int tty_raw(int);
extern void init_errmsg(void);  
extern void init_makespe();
extern void init_makesub();
extern void init_car();
extern void init_big();
extern void init_math();
extern void init_rand();
extern void init_char();
extern void init_maketcl();
extern void get_win_size(void);  /* tty_raw.c*/

extern int load_verbose,load_print,gbc_verbos;
extern int search_verbose;
extern jmp_buf user_env[];
void sys_init();
void var_init();

void make_strings();
void para_init(int ,char **);
void homedir();
void init_package();

int silent_mode=0;
int verbose_mode=0;
int ctrlcexit=0;

ptr user_package;
ptr a_sys_env;
ptr a_load;

static char initss[120];

ptr setpwd();
extern ptr s_load(int,ptr);
void initload();

/** static cell nullvect;    for null vector  */

void ss_init(int argc, char *argv[]){
    Reg ptr p,q,*r,lis,env,stream;
   Reg int n;

     stack=stack_base;

    /* init_space();*/
    /**** 03.12.31   *******/
    init_heap();
    #ifdef DEBUG
      printf("init  heap suceed!\n");
    #endif

      mp_set_memory_functions(Mymalloc,MyreallocGMP,MyfreeGMP);  
    #ifdef DEBUG
      printf("GMP alloc OK!\n");
    #endif

    make_nil();
    #ifdef DEBUG
      printf("make nil OK!\n");
    #endif

    make_free_cell();
     #ifdef DEBUG
      printf("make free cell OK!\n");
    #endif
    make_boolean();
    #ifdef DEBUG
      printf("make boolean OK!\n");
    #endif
    a_all_packages=a_nil;
    make_strings();
    #ifdef DEBUG
      printf("make_strings OK!\n");
    #endif

    /** init_top_hash(); **/
    /** a_env=a_nil; ***/
    /*** scm=a_f;
    multiscm=a_f;
    ****/
    /**  printf("make_string OK!\n");  ***/

    /*** a_env_stack=CONS(a_nil,a_nil);  because CAR is accessed even if top-level  ***/
    sys_init();
    /***  V2.0  ***/
    init_VM();
    /*** clear_comp();   ** comp.c  is_special  get_ftype ***/
    //init_list_print();
     /** printf("sys_init  OK!\n"); ***/
    strcpy(initss,SSLIBDIR);
#ifdef USE_TK
    //initss="initss2";
    strcpy(initss+strlen(initss),"initss2");
#else
    //initss="initss2n";
    strcpy(initss+strlen(initss),"initss2n");
#endif
   para_init(argc,argv);  /*** 04.11.14 **/
    #ifdef DEBUG
      printf("para_init OK!\n");
    #endif
   if(silent_mode)
       istty=0;
   else{
      istty=tty_raw(0);
      /***
      if(istty==1){  //  see stream.c
           EXATTR(a_keyinput)|=istty_ac;   //ACC
      }
     ***/
   }
   /***
   if(tk_flag)
      prompt=CMAKESTR("ss> ");
    else
      prompt=CMAKESTR("sn> ");
   ***/
      prompt=CMAKESTR("> ");
   
    ATOMVAL(a_prompt)=prompt;
    sys_pro(prompt);
    error_prompt=CMAKESTR("debug> ");
    sys_pro(error_prompt);
    /** init_reverse(); **/
    a_str_slash=make_str_c("/");
    sys_pro(a_str_slash);
      //a_version=MAKEID("*version*"); ->var_init
   //  sys_pro(a_version);  // symbol is protected by gbc
       p=CMAKESTR(SSVERSION);
    sys_pro(p);
      ATOMVAL(a_version)=p;
     /*** printf("before TK  OK!\n"); ***/

#ifdef USE_TK
    init_maketcl();
    /** for TK  conversion ***/
    a_str_space=make_str_c(" ");
    sys_pro(a_str_space);
    a_str_left=make_str_c("{");
    sys_pro(a_str_left);
    a_str_right=make_str_c("} ");
    sys_pro(a_str_right);
    a_str_ss=make_str_c("ss ");
    sys_pro(a_str_ss);
    a_str_set=make_str_c("set ");
    sys_pro(a_str_set);
    a_str_percent=make_str_c(" %");
    sys_pro(a_str_percent);
    a_update=make_str_c("update");
    sys_pro(a_update);
     /*** test of gbc ***/
     //sys_pro(makevector(10,a_nil));
#endif
    /*** print_top(); debug ***/
    /*** init_MC(); ***/
    init_his();
    #ifdef DEBUG
      printf("init_his OK!\n");
    #endif
    /***  printf("init_his  OK!\n"); ***/
#ifdef USE_TK
 ATOMVAL(a_tclversion)=CMAKESTR(TCL_VERSION); /*** in tcl.h ***/
#endif
/***
     prin1(a_nil,STDOUT);
     newline(STDOUT);
***/
}
void ss_init2(){
    initload(initss);
   if(verbose_mode)   
         lwritestr(STDMSG,"initload initss  OK!\n");

    /***  change to user package ***/
#ifndef USE_TK
    ATOMVAL(a_package)=user_package;
    make_prompt();
#endif
     if(verbose_mode)   
         lwritestr(STDMSG,"sys_ini  OK!\n");
     //gbc();  //CALL before LOGIN!
    /** printf(LOGINMSG); ***/
}

/***  Not use start  v2.20
    p=make_str_c("start");
    psh(p);
    p=probe_ext(p,0);
    if(STREAMP(p)){
      sys_close(p);
      s_load(1,a_nil);
    }
    pull();
  ***/


void help()
  {
    printf("\n usage:  ss [-s|-v][-i init] [ss-file1] .... [-p p1 p2 ....][-f ss-file ...]  \n");
    printf("     -p p1 p2 ..   gives *argv* =(p1 p2 ) as list of string-data p's \n");
    printf("    -f file   will be  executed  after set *argv*\n");
    printf("    -s    silent-mode (no system-message output to stdout from ss)\n");
    printf("    -v    verbose at initialization\n");
    printf("    -q    exit if CTRL-C or Segmentation error\n");
    printf("    -i init     use init for initialize\n");
    printf("    -help   \n");
    s_bye(0,a_nil);
  }

void paraload(int argc,char **argv){
 ptr arg,tmp,s;
/*** 05.3.18 ***/
/*** 05.5.5 ***/
 while(--argc){
  argv++;
  if(strcmp(*argv,"-s")==0){
     continue;
  }
  if(strcmp(*argv,"-v")==0){
     continue;
   }
  if(strcmp(*argv,"-q")==0){
     continue;
  }
  if(strcmp(*argv,"-d")==0){
     continue;
  }
  if(strcmp(*argv,"-f")==0){
     argv--;
     break;
   }

   if(strcmp(*argv,"-i")==0){
     ++argv;
     argc--;
     continue;
   }
  if(strcmp(*argv,"-p")==0){
      /** printf("*argv*  given %d \n",--argc); **/
          break;
   }
  if(!silent_mode){
     sprintf(iobuff,"ss2 load file %s\n",*argv);
     lwritestr(STDMSG,iobuff);
  }
    initload(*argv);
 }
  argc--;  /*** ??? ****/
 tmp=arg=CONS(a_nil,a_nil);
 psh(tmp);
 while(argc-->0){
   if(strcmp(*++argv,"-f")==0) break;
   s=make_str_c(*argv);
   tmp=CDR(tmp)=SCONS(s,a_nil);
 }
 CAR(a_argv)=CDR(arg);
 pull();
 while(argc-->0){
  sprintf(iobuff,"ss2 load file %s\n",*++argv);
   lwritestr(STDMSG,iobuff);
    initload(*argv);
 }
}

/*** check only initialize parameter option ***/
/***  04.11.14  ***/
void para_init(int argc,char **argv){
 ptr arg,tmp,s,vbm;
    vbm=intern_c("verbose-mode",a_f);
 while(--argc){
  if(strcmp(*++argv,"-s")==0){
     STDMSG=ATOMVAL(a_stdnull);
     load_verbose_set(NO);
     silent_mode=YES;
     continue;
  }
  else if(strcmp(*argv,"-v")==0){
     verbose_mode=YES;
     load_verbose_set(YES);
     ATOMVAL(vbm)=a_t;
  } 
  else if(strcmp(*argv,"--help")==0) help();
  else if(strcmp(*argv,"-help")==0) help();
  else if(strcmp(*argv,"-i")==0){
      //initss=*++argv;
      strcpy(initss,*++argv);
      argc--;
  }
  else if(strcmp(*argv,"-q")==0){
      ctrlcexit=1;
  }
  else if(strcmp(*argv,"-d")==0){
      gbc_verbos=1;
  }
  else ;
 } 
}  

void load_verbose_set(int val){
   load_verbose=val;
     load_print=val;
      search_verbose=val;
 }

void sys_pro(ptr x){   /*****    protect  x  for gbc, x is constant and not symbol ***/
sysprotect[syspro++]=x;
if(syspro>=100) exit(999);
}

void initload(char *p){
  ptr x,s;
  int n,k;
  if(*p==0) return;
  s=make_str_c(p);
  psh(s);
  if(verbose_mode) prin1(s,STDMSG);
   /** s_load(1,a_nil); ***/
      funcall(ATOMVAL(a_load),1,a_nil);
    if(verbose_mode) 
         lwritestr(STDMSG,"load  OK!\n");
 pull();
 return;
}
/****  Old code initload
  k=jmp_level;
  n=calljmp();
  if(n){
         lwritestr(STDMSG,"load  Error!\n");
  }
  else{
      funcall(ATOMVAL(a_load),1,a_nil);
    if(verbose_mode)
         lwritestr(STDMSG,"load  OK!\n");
      }
 jmp_level=k;

***/

void sys_init()
 {
   extern double atan();   
   Reg ptr p,q;    

    #ifdef DEBUG
      printf("sysini enter\n"); 
    #endif
   var_init();   
    #ifdef DEBUG
      printf("var  OK\n");  
    #endif
   init_errmsg();  
    /**  printf("errormsg  OK\n"); ***/
   /** make_nullstr();  ***/
    init_keyword();
     /** printf("keyword  OK\n");  **/
    init_makespe();
    init_makesub();
    init_car();
    /*** 03.12.31  ***/
    /** mp_set_memory_functions(Mymalloc,NULL,NULL); ***/
    #ifdef DEBUG
     printf("sysini init_car OK\n");  
    #endif

    init_format();
    // printf("sysini format OK\n");
    init_big();
    init_ratio();
    init_math();
    init_rand();
    init_char();
    //init_format();
    #ifdef DEBUG
     printf("sysini init_char OK\n");
    #endif
  /*** init_read(); **/

    init_name_char();
    init_file(); /*** stream.c ***/
    init_quasi();
     #ifdef DEBUG
     printf("sysini init_quasi OK\n");
    #endif
    /*** stack initialize   ***/
     stack=stack_base+STACKSIZE;
     while(--stack>=stack_base) *stack=a_unbdd;
     stack=stack_base;
   /*** MPU initialize ***/
     mpu_stack=MPU+MPUMAX;
     while(--mpu_stack>=MPU) *mpu_stack=a_unbdd;
     mpu_stack=MPU;
     /*** init_comp(); ***/
     #ifdef DEBUG
     printf("sysini init_comp OK\n");
    #endif

    /** kanji_mode=YES;  ***/
    set_kmode();   /*** kanji.c  ***/
    kanji_error=YES;
     make_std_readt();
    init_gread();
     #ifdef DEBUG
       printf("sysini init_gread OK\n");
    #endif

  /**** 
   init_type();  ** CAUTION!!!! 先にsubr をしてないといけない, 
                   funk_kind がstatic なので! type.c 91.2.14 
    ***/

    p=intern_c("make-undef",a_undef);
    a_nop=ATOMVAL(p);

    sys_pro(a_nop);
    p=intern_c("apply",a_undef);
    a_sysapply=ATOMVAL(p);
    sys_pro(a_sysapply);
    p=intern_c("load",a_undef);
   a_load=p;
    a_sysload=ATOMVAL(p);
    sys_pro(a_sysload);
    a_eq=intern_c("eq?",a_undef);
    a_eqv=intern_c("eqv?",a_undef);
    a_equal=intern_c("equal?",a_undef);

    a_linehis=intern_c("*line-history*",a_undef);
    ATOMVAL(a_linehis)=makevector(25,a_undef);
  #ifdef DEBUG
       printf("sysini make-vector OK\n");
    #endif
    a_read=intern_c("read",a_undef);
    a_tty_read=intern_c("tty-read-char",a_undef);
    a_win_xsize=intern_c("*win-xsize*",a_undef);
    a_win_ysize=intern_c("*win-ysize*",a_undef);
    a_win_change=intern_c("*win-change*",a_undef);
    get_win_size();
 #ifdef DEBUG
       printf("sysini win-size OK\n");
    #endif
    /*** V2.0 **/
    a_begin_sr2=intern_c("BEGIN-SR2",a_undef);
    homedir();
    intern_c("*SSLIBDIR*",a_sslib);
    p=CONS(a_sslib,a_nil);
    psh(p);
    a_autopath=intern_c("*auto-path*",p);
    pull();
     #ifdef DEBUG
        printf("sysini Compile_System Ok    sys_init exit\n");  
    #endif
   /*** homedir();  **/
 }

 
void homedir()
  {
    Reg char *p;
    ptr s;
    a_home=MAKEID("*HOME*");  
    a_pwd=MAKEID("*PWD*");  
    p=getenv("HOME"); 
    s=setpwd();  /*** current dir ***/ 
    a_startdir=ATOMVAL(a_pwd);
    sys_pro(a_startdir);
    if(p)
        ATOMVAL(a_home)=GMAKESTR(p,strlen(p));
    else
        ATOMVAL(a_home)=s;
     /*** for server  **/
     a_hostname=MAKEID("*HOSTNAME*");
    p=getenv("HOSTNAME");
    if(!p) p="localhost";
        ATOMVAL(a_hostname)=GMAKESTR(p,strlen(p));
    setenv("SSLIBDIR",SSLIBDIR,1);
   }

ptr setpwd(){
    char *q;
    getcwd(q=iobuff,MAXIO);  /*** current dir ***/
     return ATOMVAL(a_pwd)=GMAKESTR(q,strlen(q));
}

/***  変数table にしよう。  ***/

struct init_var{ptr *adress;char *name;int value;int flag;};

#define C CONSTF
#define NILV  2
#define T  4
#define F  5
#define U  8
#define SELF 6
/*** value:   0 (undef)  2=nil 4=t 5 a_f  else OBJECT  ****/
struct init_var sys_vars[]={
   {&a_quote,"quote",0,0},
   {&a_lambda ,"lambda",0,0},
   {&a_sr2 ,"sr2",0,0},
   {&a_syntax_lambda ,"syntax-lambda",0,0},  /** V2.0 **/
   {&a_macro,"macro",0,0},
   {&a_macroexpand,"macro-expand-rec",0,0},
   {&a_letdefine,"let-define->rec",0,0},
   {&a_setq,"set!",0,0},
   {&a_define,"define",0,0},
   {&a_let,"let",0,0},
   {&a_let_s,"let*",0,0},
   {&a_letrec,"letrec",0,0},
   {&a_inline,"INLINE",0,0},  /** V2.0 **/
   {&a_letsyntax,"let-syntax",0,0},
   {&a_letrecsyntax,"letrec-syntax",0,0},
   {&a_begin,"begin",0,0},
   {&a_if,"if",0,0},
   {&a_special,"special",0,0},
   {&a_quasi_quote,"quasiquote",NILV,0},
   {&a_lambda_quote,"lambda-quote",NILV,0},/*** V2.0 ***/
   {&a_unquote,"unquote",0,0},
   {&a_unquote_splice,"unquote-splicing",0,0},
   {&a_dot,".",0,0},
   {&a_dot3,"...",0,0},
   {&a_append,"append",0,0},
   {&a_cons,"cons",0,0},
   {&a_list,"list",0,0},
   {&a_liststar,"list*",0,0},
   {&a_plus,"+",0,0}, /***  for TK bind ***/
   {&a_bind,"bind",0,0}, /***  for TK bind ***/
   {&a_toplevel,"toplevel",0,0}, /***  for TK toplevel check ***/
   {&a_errmsg,"*system-error-msg*",0,0},
   {&a_trace,"*trace*",NILV,0},
   {&a_apply,"apply",NILV,0},
   {&a_eval,"eval",NILV,0},
   {&a_dynamic,"*dynamic*",NILV,0},
   /** {&a_make_cc,"make-cc",NILV,0}, **/
   /** {&a_restore_cc,"restore-cc",NILV,0}, ***/
   {&a_call_cc,"call/cc",NILV,0},
   /*** {&a_call_values,"call-with-values",NILV,0}, ***/
   {&a_errno,"*errno*",NILV,0},
   {&a_errorhook,"*errorhook*",NILV,0},
   /** {&a_r_e_p,"*r-e-p*",NILV,0},***/
   {&a_syserrorhook,"*syserrorhook*",NILV,0},
   {&a_error_env,"*errorenv*",NILV,0},
   {&a_tclerror,"*tcl-error*",5,0},
   /*** for compiler ***/
   {&a_tail_call,"TAIL-CALL",NILV,0},
   {&a_load_reg,"LOAD-REG",NILV,0},
   {&a_prompt,"*prompt*",0,0},
   {&a_version,"*version*",0,0},
   {&a_eof_object,"*eof-object*",0,0},
   /*** {&a_macrohook,"*tcl-error*",NILV,0}, ***/
  /***
   {&a_prompt2,"*prompt2*",0,0},  
   {&a_evalhook,"*evalhook*",NILV,0},
   {&a_applyhook,"*applyhook*",NILV,0},
   {&a_name_char,"*name-char*",NILV,0},
   {&a_auto_case,"*auto-case*",NILV,0},
   ***/
   {&a_auto_case,"*auto-case*",F,0},
   {&a_auto_regexp,"*auto-regexp*",F,0},
   /** {&a_kanji,"*kanji*",T,0}, **/
   {&a_pi,"PI",0,C},
   {&a_pi2,"PI/2",0,C},
   {&a_imag,"IMAG",0,C},   
   {&a_log2,"LOG2",0,C},
   {&a_log10,"LOG10",0,C},
   {&a_readtable,"*read-table*",NILV,0},  
   {&a_read_base,"*read-base*",(int)(long)TEN,0},  
   {&a_stdin,"*stdin-stack*",0,0},  
   {&a_stdout,"*stdout-stack*",0,0},  
   {&a_stderr,"*stderr-stack*",0,0},  
   {&a_stdmsg,"*stdmsg*",0,0},  
   {&a_stdnull,"*stdnull*",0,0},  
   {&print_radix,"*print-base*",(int)(long)TEN,0},   
   {&a_argv,"*argv*",0,0},  
    {&a_tcl,"tcl",U,0},   
    {&a_tclversion,"*tcl-version*",F,C},   
    {&a_tk,"tk",U,0},   
    {&a_system,"system",0,0},   
   /**** for TK ***/
#ifdef USE_TK
   /** {&a_tcl,"tcl",NILV,0},  ***/  
   {&a_after,"after",0,0},   
   {&a_get,"get",0,0},   
   {&a_entry,"entry",0,0},   
   {&a_text,"text",0,0},   
   {&a_cget,"cget",0,0},   
   {&a_configure,"configure",0,0},  
   {&a_entryconfigure,"entryconfigure",0,0},  
   {&a_listbox,"listbox",0,0},   
   {&a_image,"image",0,0},   
   {&a_create,"create",0,0},   
   {&a_winfo,"winfo",0,0},   
   {&a_exists,"exists",0,0},   
   {&a_search,"search",0,0},   
   {&a_index,"index",0,0},   
   {&a_tag,"tag",0,0},   
   {&a_ranges,"ranges",0,0},   
   {&a_nextrange,"nextrange",0,0},   
   {&a_prevrange,"prevrange",0,0},   
   {&a_dump,"dump",0,0},   
   {&a_compare,"compare",0,0},   
   {&a_add,"add",0,0},   
#endif 
  /***
   {&print_base,"*print-base*",(int)TEN,0},   
   {&print_radix,"*print-radix*",NILV,0},   //see above  
    {&a_home,"*home*",0,0},  
   {&a_sysdebug,"*SYSDEBUG*",F,0},   
  ***/
   {&a_structure_inits,"*structure-inits*",NILV,0},   
   {&a_structure_offset,"*structure-offset*",NILV,0},   
   {&a_structure_size,"*structure-size*",NILV,0},   
   {&a_structure_slots_name,"*structure-slots-name*",NILV,0},   
   {&s_undef,"*undef*",0,0},   
   {&a_tracevars,"*trace-vars*",NILV,0},   
  /***  after  **/
   {&a_info,"info",0,0},   
   {&a_cancel,"cancel",0,0},   
   
 {NULL,NULL,0,0},
 };

void var_init()
 {
   Reg ptr x,*ad,y;
   Reg int n;
   Reg struct init_var *p=sys_vars;
   
     while((ad=p->adress))
      {
           n=p->value;
           if(n==NILV) y=a_nil;
           else if(n==T) y=a_t;
           else if(n==5) y=a_f;
           else if(n==U) y=a_unbdd;
           else if(n) y=(ptr)(long)n;
           else y=a_undef;
        *ad=x=intern_c(p->name,y);
           ATOMVAL(x)=y;
        if((n=p->flag))
         {
          ATTR(CDR(x))|=n;   /****  04.5.8  ***/
         }
       p++;
      }

   a_sys_env=intern_c_pack("*ENV*",a_nil,sys_package);  /*** sys:*ENV*  for SYSMACRO 5 **/
   a_r_e_p=intern_c_pack("*r-e-p*",a_nil,sys_package);  /*** sys:*r-e-p*  for read-eval-print loop 2010.9.14  **/

   ATOMVAL(a_pi)=MAKEDBL(pi=atan(1.0)*4.0);   /*****   pi=3.1416  *****/
   ATOMVAL(a_pi2)=MAKEDBL(pi2=atan(1.0)*2.0);   /*****   pi=3.1416  *****/
   ATOMVAL(a_imag)=complex(ZERO,ONE);
   ATOMVAL(a_log2)=MAKEDBL(log(2.0));
   ATOMVAL(a_log10)=MAKEDBL(log(10.0));
   /****  for error handle  ****/
   ATOMVAL(a_errno)=ZERO;
   ATOMVAL(a_eof_object)=SEOF;

   /*** intern_c("*error-user*",MAKESINT( E_user)); ***/
#ifdef WIN32
   x=CMAKESTR("win");
#else
   x=CMAKESTR("unix");
#endif
   psh(x);
   x=intern_c("*system*",x);
   pull();
   ATTR(CDR(x))|=CONSTF; 
   }
        
void make_strings(){
   a_nullstr=makestring(0);
   sys_pro(a_nullstr);
   a_package=CMAKESTR("*package*");
   a_hash=CMAKESTR("hash");
#ifdef DEBUG
      printf("start init_package\n");
#endif
   sys_pro(a_package);
   sys_pro(a_hash);
   init_package();
   a_colon=CMAKESTR(":");
   sys_pro(a_colon);
   a_none=CMAKESTR("none::");
    a_sslib=CMAKESTR(SSLIBDIR);
   sys_pro(a_none);
}

void init_package(){
  ptr c,p,x; 
   sys_package=p=c=make_package(CMAKESTR("sys"));
#ifdef DEBUG
      printf("sys package OK!\n");
#endif
   x=CADR(c);  /*** hash table **/
   c=SCONS(a_nil,c);
   c=SCONS(a_package,c);
   c=SCONS(p,c);
#ifdef DEBUG
      printf("SCONS OK!\n");
#endif
   ATTR(c)=SYMBOL;
#ifdef DEBUG
      printf("ATTR OK!\n");
#endif
   sethash(a_package,x,c);
#ifdef DEBUG
      printf("sethash OK!\n");
#endif
   a_package=c;    /***  a_package =>*package*  && current package sys ***/
   /** a_all_packages=SCONS(p,a_nil); ***/
   ss_package=make_package(CMAKESTR("ss"));
#ifdef DEBUG
      printf("ss package OK!\n");
#endif
   ATOMVAL(a_package)=ss_package;   /*** Now HPACKAGE = ss  ***/
   key_package=make_package(CMAKESTR("key"));
   a_all_packages=CDR(a_all_packages);  /*** key word package is not symbol **/
   sys_pro(key_package);
   user_package=make_package(CMAKESTR("user"));
   alias_package=make_package(CMAKESTR("alias"));
#ifdef DEBUG
      printf("alias  package OK!\n");
#endif

#ifdef USE_TK
   tk_package=make_package(CMAKESTR("tk"));
#endif 
}

ptr s_silent(int narg,ptr env){
  return PRED(silent_mode);
}
ptr s_istty(int narg,ptr env){
  if(verbose_mode){
   prin1((istty<<2)|1,STDMSG);
   lwritestr(STDMSG," = istty\n");
  }
  return PRED(istty);
}



