/***  vector.c
 ****/

#define VECTOR_C

#include "lisp.h"
extern Uchar *alloc_space(ptr ,Uint);

void checkvect(ptr x){
  if(SREGP(x)||!VECTORP(x)) error(E_notvector,x);
}

ptr  *get_vector(Reg ptr vec,int *len){
   /** org *len=(int)(long)CDR(vec);  **/
   *len=GETNUM(CDR(vec));
    vec=CAR(vec);
   return(ptr *)(vec);
   //return(ptr *)(++vec);
}

int scm_vectorcmp(Reg ptr *p,Reg ptr *q,Reg int n){
   while(n--){
     if(*p++!=*q++) return NEQ;
  }
return EQ;
}

ptr makevector(int i,ptr ini){
 int n;
      ptr c;
     ptr *p;
       psh(c=new_cell(VECTOR));
       /* org CDR(c)=(ptr)(long) i;  *** for gbc Caution!  ***/
       CDR(c)=MAKESINT(i); /*** for gbc   ***/
    p=(ptr *)alloc_space(c, i*sizeof(ptr));  /*** CAR(c) is set ***/
   /* printf("makevect %x %d\n",p,i); */
    while(i--) *p++=ini;  /*** init ***/
      pull();
   return c;
  }

ptr getvector(int i){    /*** no initialize ***/
 int n;
      ptr c;
     ptr *p;
       psh(c=new_cell(VECTOR));
       /* org CDR(c)=(ptr)(long) i;  *** for gbc Caution!  ***/
       CDR(c)=MAKESINT(i); /*** for gbc   ***/
    p=(ptr *)alloc_space(c, i*sizeof(ptr));  /*** CAR(c) is set ***/
      pull();
   return c;
  }


ptr s_makevector(int narg,ptr env){
   ptr s,ini ;
   if(narg==1) ini=a_undef;
   else if(narg==2) ini=*(stack-1);
   else 
       checknarg(narg-2);
    s=*(stack-narg);
   return makevector(GETNUM(s),ini);
}

ptr vector_ref(ptr vec,int n){
  Reg  ptr *p ;
  int m;
   p=get_vector(vec,&m);
   if(n>=m||n<0)  error(E_range,MAKESINT(n));
   return *(p+n);
}

ptr vector_set(ptr vec,int n,ptr val){
   Reg ptr *p ;
  int m;
   p=get_vector(vec,&m);
   if(n>=m||n<0)  error(E_range,MAKESINT(n));
    *(p+n)=val;
  return a_undef;
}

  
ptr s_vector_ref(int narg,ptr env){
  Reg  ptr vec,*p ;
  int n,m;
    vec=*(stack-2);
   n= GETNUM(*(stack-1));
   checknarg(narg-2);
   checkvect(vec);
   p=get_vector(vec,&m);
   if(n>=m||n<0)  error(E_range,*(stack-1));
   return *(p+n);
}

ptr s_vector_set(int narg,ptr env){
   Reg ptr vec,*p ,val;
  int n,m;
    vec=*(stack-3);
   n= GETNUM(*(stack-2));
    val=*(stack-1);
   checknarg(narg-3);
   checkvect(vec);
   p=get_vector(vec,&m);
   if(n>=m||n<0)  error(E_range,*(stack-2));
    *(p+n)=val;
  return a_undef;
}  

ptr make_vect_list(ptr x){  /****  list->vector ***/
  int n;
  Reg ptr v,*p;
   n=_length(x);
   v=makevector(n,a_nil);
   p=get_vector(v,&n);
  while(n--){
   *p++=CAR(x);
   x=CDR(x);
  }
  return v;
}

ptr s_list_vector(int narg,ptr env)
      /* (list->vector L) */
{
    Reg int s=0;
    checknarg(narg-1);
   return make_vect_list(*(stack-1));
}

static ptr vector_2list(ptr v){  /**** vector-> list ***/
  int n;
  Reg ptr x=a_nil,*p;
   checkvect(v);
   p=get_vector(v,&n);
  p+=n;
  while(n--){
   x=SCONS(*--p,x);
  }
  return x;
}


ptr s_vector_list(int narg,ptr env)
      /* (list->vector L) */
{
    Reg int s=0;
    checknarg(narg-1);
   return vector_2list(*(stack-1));
}

ptr s_vector(Reg int narg,ptr env)
      /* (vector x1 x2 ....) */
{
   Reg ptr x,*p,*sfree;
    int n;
    x=makevector(narg,a_undef);
    p=get_vector(x,&n);
    sfree=stack-narg;
    while(n--) *p++=*sfree++;
   return x;
}

ptr s_vector_length(Reg int narg,ptr env)
      /* (vector x1 x2 ....) */
{
   Reg ptr x;
    int n;
    checknarg(narg-1);
    x=*(stack-1);
   checkvect(x);
    get_vector(x,&n);
    return MAKESINT(n);
}

ptr s_vector_fill(Reg int narg,ptr env)
      /* (vector x1 x2 ....) */
{
   Reg ptr x,ini,*p;
    int n;
    checknarg(narg-2);
    x=*(stack-2);
    ini=*(stack-1);
   checkvect(x);
    p=get_vector(x,&n);
    while(n--){
    *p++=ini;
    }
    return a_undef;
}

ptr vector_copy(ptr x)
{
   Reg ptr *p,*q,y;
    int n;
    checkvect(x);
    p=get_vector(x,&n);
    y=makevector(n,a_nil);
    q=get_vector(y,&n);
    while(n--) {
        *q++=*p++;
    }
   return y;
}


ptr s_vector_copy(Reg int narg,ptr env)
      /* (vector-copy  x  [n  ini]) */
{
   Reg ptr x,*p,*q,ini=a_undef,y;
    int n,new;
    x=*(stack-narg);
    checkvect(x);
    p=get_vector(x,&n);
   if(narg==1)
       new=n;
   else if(narg==2)
       new=GETNUM(*(stack-1));
   else if(narg==3){
       new=GETNUM(*(stack-2));
       ini=*(stack-1);
  }
  else 
      checknarg(narg-3);

    y=makevector(new,ini);
    p=get_vector(x,&n);
    q=get_vector(y,&new);
    while(n--) {
        *q++=*p++;
        if((--new)==0) break;
    }
   return y;
}

void rotate_up(ptr *p,int n)
{
  Reg ptr x,last;
   p+=n;
   last=*--p;
   while(--n){
     x=*--p;
     *(p+1)=x;
   }
  *p=last;
}

void rotate_down(ptr *p,int n)
{
  Reg ptr x,first;
  first=*p;
   while(--n){
     x=*++p;
     *(p-1)=x;
   }
  *p=first;
}
  
ptr s_vector_rotate(Reg int narg,ptr env)
      /* (vector x1 x2 ....) */
{
   Reg ptr x,*p;
    int n,sh;
    checknarg(narg-2);
    x=*(stack-2);
    sh=GETNUM(*(stack-1));
   checkvect(x);
    p=get_vector(x,&n);
    sh%=n;
    if(sh==-1){
       rotate_down(p,n);
       return x;
      }
    if(sh<0) sh+=n;
    if(sh==0) return x;
    while(sh--){
      rotate_up(p,n);
    }
    return x;
}


