/****  VM2/vm-compiler.ss 
       see also vm-list-final.ss
                vm-op-table.ss
   2010.5.5
   list base
    Not support  CALL/CC
    2010.5.10 INLINE  support
    2010.5.23   CALL/CC implemented as a function!!
    2010.7.2    Let is special
    2010.8.17   compile  for sr2 is different  from vm-compile
                vm-compile is for  run-time compile! 
    2010.8.18   syntax-symbol support
                (s :T)  means top-level symbol access
***/

#include "lisp.h"
#include <stdio.h>

extern ptr reverse_list(ptr p);
extern ptr nreverse_list(ptr p);
extern ptr k_T;
static int Level;
static int label;

int run_time=1;

static ptr *sysreg;
#define ENV  *sysreg
#define Level_stack sysreg[1]
#define Com_stack sysreg[2]
#define REG_END  sysreg[3]
#define APPLY    999
#define Reverse_list(x) nreverse_list(x)

#define list1(x)  (SCONS((ptr)x,a_nil))
extern ptr list2(),list3();
extern ptr specialp();
extern ptr call_vm();
extern ptr k_macroalias;


/*** see vm.c   ***/
enum OPNUM {VLOAD,VSET,VMIMM,
LOADENV,SETENV,
MAKE_LAMBDA, MAKE_MACRO,
DEFINE,BIND,
JMP2,FALSE2,
LAMBDA_BIND,FUNC,
PUSHARG,VJSR,TAIL_JMP,RETURN,CLOSURE_ENV,LAMBDA_ARGS,
TRUE2,
    SCM_MULTI,MULTI_SCM,
    SCM_BA,BA_SCM,
     SCM_ST,SCM_ARGS, ST_SCM,
   COPY_CC,RESTORE_CC,
IMM_undef,IMM_t,IMM_f,IMM_null,
IMM_0,IMM_1,
Push_ENV,Pull_ENV,Pull_reg,Pull_PCST,
Push_ARGS,
IF_TRUE,VJMP,IF_FALSE,LABEL
,LAMBDA_LAST,ENV_SCM,ENVLOAD,SCM_ENV
   };
/***   need  LAMBDA_LAST for checkargs  ***/
/****  (ENVLOAD var key)  ***/
static long OP[50];

ptr Symbol_alias();
static  void Compile_list(ptr);
static  void Com_imm(ptr),Combi_com(ptr,ptr),Special_com(ptr,ptr,ptr),Func_com(ptr,ptr,ptr);
static void Begin_com(ptr,ptr),Begin_com_simple(ptr),Lambda_body_com(ptr);
static void tc_compile(ptr),Lambda_com(ptr,ptr),Lambda_bind(ptr,int);
static void Let_com(ptr,ptr),Lets_com(ptr,ptr),Letrec_com(ptr,ptr);
static void Bind_para_let(ptr),Bind_para(ptr),Bind_s(ptr,ptr),Bind_para_rec(ptr);
static void Define_com(ptr),Set_com(ptr),If_com(ptr,ptr),Quote_com(ptr);
static void Symbol_com(ptr),Macro_com(ptr,ptr);
static void INLINE_com(ptr);

ptr final(ptr s);
static void init_inline(),init_final();
static ptr a_INLINE;

/*** static int IMM_trans=0;  ***/

void init_vmcomp( ptr *st){
  /*** call by init  once **/
  int i;
  long k=(long) ZERO;
   sysreg=st;
   ENV=a_nil;
   Com_stack=a_nil;
   Level_stack=a_nil;
   Level=0;
   label=10;
   REG_END=NULL;
   for(i=0;i<50;i++,k+=4){
    OP[i]=k;
  }
  init_inline();
  init_final();
}
/****
ptr macro_ex2(ptr top,ptr para){
   ptr s;
   int m_Lebel=Level;
   int m_label=label;
   psh(ENV);
   psh(Com_stack);
   psh(Level_stack);
  Com_stack=a_nil;
  Macro_com(top,para);
  s=Reverse_list(Com_stack);
   psh(s);
  s=call_vm(s,a_nil);
   pull();
   Level_stack=*pull();
   Com_stack=*pull();
   ENV=*pull();
   Level=m_Lebel;
   label=m_label;
   return s;
}
***/
/***
macro_vmcomp(ptr top,ptr para){
  ptr s;
   s=macro_ex2(top,para);
   psh(s);
   Compile_list(s);
   pull();
}
***/

void clear_vmcomp(ptr env){
  /*** call by each compile **/
   ENV=env;
   Com_stack=a_nil;
   Level_stack=a_nil;
   Level=0;
   label=10;
}



void Com_out(ptr x){
   Com_stack=SCONS(x,Com_stack);
}

int Label(){
   return ++label;
}

ptr vm_compile(ptr s,ptr env){
  clear_vmcomp(env);
/***
   PRINT("vm_compile");
   prin1(s,STDOUT);
   newline(STDOUT);
***/
  Compile_list(s);
  return Reverse_list(Com_stack);
}


/***  (vm-compile s) or (vm-compile s env)   ***/
ptr s_vm_compile(int narg,ptr env){
    ptr s,v,ev=a_nil;
    if(narg==1){
        s=*(stack-1);
        psh(ev);
    } 
    else if(narg==2){
        s=*(stack-2);
        ev=*(stack-1);
     }
    else
      checknarg(narg-2);
/****
    PRINT("s_vm_compile");
    newline(STDOUT);
    lfflush(STDOUT);
***/
    v=ATOMVAL(a_macroexpand);
    if(v!=a_undef){
/**
      PRINT("macroexpand start: "); 
      prin1(v,STDOUT);
    newline(STDOUT);
***/
    s=funcall(v,2,ev);
/***
     PRINT("macroexpand END");
    newline(STDOUT);
    lfflush(STDOUT);
***/
     }
    *(stack-1)=s;
/***
      prin1(s,STDOUT);
    PRINT("compile start");
    newline(STDOUT);
    lfflush(STDOUT);
***/
    s=vm_compile(s,ev);
    *(stack-2)=s;
    *(stack-1)=ev;
/***
    PRINT("compile END");
    newline(STDOUT);
    lfflush(STDOUT);
  ****/  
     s=final(s);
     if(narg==1)  pull();
    return s;
}

static void Compile_list(ptr s){
/***
   PRINT("Compile_list");
   prin1(s,STDOUT);
   newline(STDOUT);
  ***/
   if(SREGP(s)) 
      Com_imm(s);
   else if(SYMBOLP(s))
      Symbol_com(s);
   else if(CONSP(s))
      Combi_com(s,a_f);
   else
      Com_imm(s);
}

static void Com_imm(ptr x){  
   /****
    if(IMM_trans){
      if(x==a_nil)
          Com_out(list1(OP[IMM_null]));
      else if(x==a_undef)
          Com_out(list1(OP[IMM_undef]));
      else if(x==ZERO)
          Com_out(list1(OP[IMM_0]));
      else if(x==ONE)
          Com_out(list1(OP[IMM_1]));
      else if(x==a_t)
          Com_out(list1(OP[IMM_t]));
      else if(x==a_f)
          Com_out(list1(OP[IMM_f]));
      else
          Com_out(list2(OP[VMIMM],x));
    }
   else
    ****/
    if((!SREGP(x))&&(ATTR(x)==SYNTAXSYMBOL)) x=CADR(x);
      Com_out(list2(OP[VMIMM],x));
}

void Syntax_Symbol_com(ptr s){
  ptr a,k,al;
      k=CAR(s);  /*** Now only top :freev s alias  **/
      al=CADDR(s);
      s=CADR(s);
      a=assq(al,ENV);
    if(a!=a_f)
        Com_out(list2(OP[LOADENV],al));
    else
        Com_out(list2(OP[VLOAD],s));
}

void Symbol_com(ptr s){
  ptr a;
  /***  SYSMACRO generates (:MACRO_ALIAS .  +)  , see comp.c  **/
  if(SYNTAX&ATTR(s)){
    /***
     PRINT("SYNTAX");
     newline(STDOUT);
     ***/
     Syntax_Symbol_com(s);
     return;
   }
  a=assq(s,ENV);
  if(a!=a_f)
      Com_out(list2(OP[LOADENV],s));
  else{
        /*** s=Symbol_alias(s);  ***/
      if(run_time==2){  /*** Function call on run-time  ***/
           a=SVAL(s);
           if((!SREGP(a))&&(ATTR(a)==SLAMBDA)){ /*** system function only! ***/
                /** Com_imm(a);  **/   
             /**　 prin1(s,STDOUT);**/
               Com_out(list2(OP[VLOAD],s)); 
            }
           else
              Com_out(list2(OP[VLOAD],s));
      }
      else
          Com_out(list2(OP[VLOAD],s));
      }
}

static ptr Env_special(ptr s){
/***
   PRINT("Env_special");
  newline(STDOUT);
***/
  if(assq(s,ENV)!=a_f) return a_f;
  if((s=specialp(s))!=a_f) return s;
  return a_f;
}

static ptr is_special(ptr s){
 /****
   PRINT("is_special");
   prin1(s,STDOUT);
  newline(STDOUT);
  ***/
   if(s==a_apply) return s;
   /** if(s==a_INLINE) return s; **/
   if((s=Env_special(s))!=a_f) return s;
   return a_f;
}
ptr is_macrosr2(ptr f){
   ptr s;
  int attr;
      /****
      PRINT("macrosr2");
      newline(STDOUT);
   ***/
   if(SYMBOLP(f)){
       s=assq(f,ENV);
       if(s!=a_f) return a_f;
       s=ATOMVAL(f);
       attr=ATTR(s);
    }
  return a_f;
}
/***
static ptr is_macrosubr(ptr x){
  psh(x);
  x=s_macrop(1,a_nil);
  pull();
 return x;
}
***/
static  void Combi_com(ptr s,ptr tail){
 ptr x,top;
/***
  PRINT("Combi_com");
  princ(s,STDOUT);
  newline(STDOUT);
****/
  top=CAR(s);
  if(SREGP(top)) error(E_nullfunc,top);
  if((x=is_special(top))!=a_f)  {
    /****
      PRINT("Special_com");
      prin1(x,STDOUT);
      newline(STDOUT);
    ****/
      Special_com(x,CDR(s),tail);
  }
 else{
     /***
      PRINT("Func_com");
      newline(STDOUT);
     ***/
     Func_com(top,CDR(s),tail);
  }
}

static ptr Level_dif(){
   return MAKESINT( Level-GETNUM(CAR(Level_stack)));
}

static  void Func_com(ptr top,ptr para,ptr tail){
   int narg=0;
/***
   PRINT("Func");
   prin1(para,STDOUT);
   newline(STDOUT);
   lfflush(STDOUT);
***/
   Com_out(list2(OP[FUNC],tail));
   para=reverse_list(para); 
   psh(para);
   while(CONSP(para)){
     Compile_list(CAR(para));
     Com_out(list1(OP[PUSHARG]));
     para=CDR(para);
     narg++;
   }
  pull();
   if(run_time){
      if(SREGP(top)) error(E_nullfunc,top);
      if(SYMBOLP(top)){
          run_time=2;
          Symbol_com(top);
          run_time=1;
       }
      else
         Compile_list(top);
      }
   else
      Compile_list(top);
  if(tail!=a_f)
   Com_out(list3(OP[TAIL_JMP],MAKESINT(narg),Level_dif()));
  else
   Com_out(list2(OP[VJSR],MAKESINT(narg)));
}

void Macro_com(ptr top,ptr para){   /*** sr2macro  ***/
   int narg=0;
 /***
   PRINT("Func");
   prin1(para,STDOUT);
   lfflush(STDOUT);
  ***/
   Com_out(list2(OP[FUNC],a_f));
   para=reverse_list(para);
   psh(para);
   while(CONSP(para)){
     /*** Compile_list(CAR(para));  ***/
     Com_imm(CAR(para));
     Com_out(list1(OP[PUSHARG]));
     para=CDR(para);
     narg++;
   }
  pull();
   Compile_list(top);
   Com_out(list2(OP[VJSR],MAKESINT(narg)));
}


static void Apply_com(ptr para, ptr tail){
  ptr top;
   top=CAR(para);
   para=CDR(para);
   Com_out(list2(OP[FUNC],tail));
   para=reverse_list(para); 
   psh(para);
   Compile_list(CAR(para));
   Com_out(list1(OP[SCM_ARGS]));
   para=CDR(para);
  while(CONSP(para)){
   Compile_list(CAR(para));
    Com_out(list1(OP[PUSHARG]));
    para=CDR(para);
  }
  pull();
   Compile_list(top);
  if(tail!=a_f)
     Com_out(list3(OP[TAIL_JMP],a_nil,Level_dif()));
  else
   Com_out(list2(OP[VJSR],a_nil));

}
   
static  void Special_com(ptr top,ptr para,ptr tail){
  /***
   PRINT("Special_com");
   newline(STDOUT);
***/
   if(top==a_apply) Apply_com(para,tail);
   else if(top==a_begin) Begin_com(para,tail);
   else if(top==a_let) Let_com(para,tail);
   else if(top==a_let_s) Lets_com(para,tail);
   else if(top==a_letrec) Letrec_com(para,tail);
   else if(top==a_lambda) Lambda_com(top,para);
 /***  else if(top==a_macro) Lambda_com(top,para); **/
   else if(top==a_define) Define_com(para);
   else if(top==a_setq) Set_com(para);
   else if(top==a_if) If_com(para,tail);
   else if(top==a_quote) Quote_com(para);
   else if(top==a_INLINE) INLINE_com(para);
   else{
       ;     /****  error Not support  ***/
   }
}

static void Begin_com(ptr para,ptr tail){
  if(tail!=a_f)
       Lambda_body_com(para);
  else
      Begin_com_simple(para);
}

static  void Begin_com_simple(ptr para){
  if(CONSP(para)){
    while(CONSP(CDR(para))){
        Compile_list(CAR(para));
        para=CDR(para);
     }
    // Com_out(list1(OP[MULTI_SCM]));  /*** For clear MULTI  ***/
    Compile_list(CAR(para));
   }
}

static  void Lambda_body_com(ptr para){
/****
   PRINT("Lambda_body");
   prin1(para,STDOUT);
   newline(STDOUT);
***/
   if(CONSP(para)){
     if(CONSP(CDR(para))){
         Compile_list(CAR(para));
         Lambda_body_com(CDR(para));
     }
     else{
       // Com_out(list1(OP[MULTI_SCM]));  /*** For clear MULTI  ***/
       tc_compile(CAR(para));
     }
  }
}

static void tc_compile(ptr f){
  /***
   PRINT("tc_compile ");
   prin1(f,STDOUT);
   lfflush(STDOUT);
   ***/
   if(CONSP(f))
      Combi_com(f,a_t);  /*** tail form  ***/
   else
      Compile_list (f);
}

static void Lambda_com(ptr x ,ptr para){
  ptr com,env,obj;
/***
  PRINT("Lambda_com");
  newline(STDOUT);
***/
  com=Com_stack;
  env=ENV;
  psh(com);
  psh(env);
  Com_stack=a_nil;
  Level++;
  Level_stack=CONS(MAKESINT(Level),Level_stack);
  obj=CAR(para);
  para=CDR(para);
   Com_out(list2(OP[LAMBDA_ARGS],obj));
  Lambda_bind(obj,0);
  Lambda_body_com(para);
  Level_stack=CDR(Level_stack);
  Com_out(list1(OP[RETURN]));
  Level--;
  ENV=env;
  obj=Reverse_list(Com_stack);
  Com_stack=com;
  if(x==a_lambda)
     Com_out(list2(OP[MAKE_LAMBDA],obj));
  else
     Com_out(list2(OP[MAKE_MACRO],obj));
 stack-=2;
/***
  PRINT("Lambda_com-end");
  newline(STDOUT);
***/
} 
static ptr syntax_alias(ptr x){
   if(SREGP(x)||(!SYMBOLP(x))) error(E_notsymb,x);
   if(ATTR(x)&SYNTAX)
       return CADDR(x); /*** alias  ***/
   return x;
}
static ptr syntax_symbol(ptr x){
   if(SREGP(x)||(!SYMBOLP(x))) error(E_notsymb,x);
   if(ATTR(x)&SYNTAX)
       return CADR(x); /*** original symbol name  ***/
   return x;
}


static  void Lambda_bind(ptr args,int narg){
  ptr x;
   if(CONSP(args)){
      x=CAR(args);
      args=CDR(args);
      x=syntax_alias(x);
     if(args==a_nil)
        Com_out(list3(OP[LAMBDA_LAST],x,MAKESINT(narg)));
     else
       Com_out(list3(OP[LAMBDA_BIND],x,MAKESINT(narg)));
     ENV=SCONS(CONS(x,a_undef),ENV);
     Lambda_bind(args,narg+1);
   }
  else if(SYMBOLP(args)){
     Com_out(list3(OP[LAMBDA_LAST],list1(args),MAKESINT(narg)));
     ENV=SCONS(CONS(args,a_undef),ENV);
   }
}

static void Let_com(ptr para,ptr tail){  /***  Let   ***/
 ptr env;
  env=ENV;
  psh(env);
  Level++;
     Com_out(list1(OP[Push_ENV]));  /*** BLOCK  **/
     Bind_para_let(CAR(para));
     para=CDR(para);
    Begin_com(para,tail);
     Com_out(list1(OP[Pull_ENV]));  /*** BLOCK END  **/
  Level--;
  ENV=env;
  pull();
}
     
static void Lets_com(ptr para,ptr tail){  /***  Let*   ***/
 ptr env;
  env=ENV;
  psh(env);
  Level++;
     Com_out(list1(OP[Push_ENV]));  /*** BLOCK  **/
     Bind_para(CAR(para));
     para=CDR(para);
    Begin_com(para,tail);
     Com_out(list1(OP[Pull_ENV]));  /*** BLOCK END  **/
  Level--;
  ENV=env;
  pull();
} 


/***  ONLY for Global symbol  ***/
ptr Symbol_alias(ptr s){
  ptr v;
  v=ATOMVAL(s);
  if(!SREGP(v)&&CONSP(v)&&(CAR(v)==k_macroalias))
     return CDR(v);
  else
     return s;
}

static void Bind_para_let(ptr args){
  ptr x,s;
  psh(ENV);
  while(CONSP(args)){
     x=CAR(args);
     args=CDR(args);
     Compile_list(CADR(x));
     s=CAR(x);
     s=syntax_alias(s);
     Com_out(list2(OP[BIND],s));
  *(stack-1)=SCONS(CONS(s,a_undef),*(stack-1));
  }
 ENV=*(stack-1);
  pull();
}

static void Bind_para(ptr args){
  ptr x;
  while(CONSP(args)){
     x=CAR(args);
     args=CDR(args);
     Bind_s(syntax_alias(CAR(x)),CADR(x));
  }
}
static  void Bind_s(ptr s,ptr val){
  Compile_list(val);
  /***  s=Symbol_alias(s);  ***/
  Com_out(list2(OP[BIND],s));
  ENV=SCONS(CONS(s,a_undef),ENV);
}
static  void Bind_s_rec(ptr s){
  Com_out(list2(OP[BIND],s));
  ENV=SCONS(CONS(s,a_undef),ENV);
}

static void Letrec_com(ptr para,ptr tail){  /***  letrec   ***/
 ptr env;
  env=ENV;
  psh(env);
  Level++;
     Com_out(list1(OP[Push_ENV]));  /*** BLOCK  **/
     Bind_para_rec(CAR(para));
     para=CDR(para);
    Begin_com(para,tail);
     Com_out(list1(OP[Pull_ENV]));  /*** BLOCK END  **/
  Level--;
  ENV=env;
  pull();
}
static void Bind_para_rec(ptr args){
  ptr x,memo=args;
  while(CONSP(args)){
     x=CAR(args);
     args=CDR(args);
     Bind_s_rec(syntax_alias(CAR(x)));
  }
  args=memo;
 while(CONSP(args)){
     x=CAR(args);
     args=CDR(args);
     Compile_list(CADR(x));
     /*** x=Symbol_alias(CAR(x))***/;
     x=syntax_alias(CAR(x));
     Com_out(list2(OP[SETENV],x));  /*** set!  **/
  }
}

static void Define_com(ptr para){
  ptr x,args;
  /**  2010.5.16   support (f x) in compiler  ***/
  x=CAR(para);  /*** must be symbol  ***/
  para=CDR(para);
  if(CONSP(x)){
       args=CDR(x);
       x=CAR(x);
       para=CONS(args,para);
       para=SCONS(a_lambda,para);
     psh(para);
     Compile_list(para);
     pull();
  }
 else{
  if(CONSP(para))
     Compile_list(CAR(para));
  else
     Com_imm(a_undef);  /*** error? ***/
  }
  if(Level==0){
     Com_out(list2(OP[DEFINE],x)); 
     Com_imm(x);  
  } 
  else{
     /*** Bind_s(x,a_undef);***/
     Bind_s_rec(x);
  }
}

static void Set_com(ptr para){
  ptr x,v,al;
  x=CAR(para);  /*** must be symbol  ***/
  para=CDR(para);
  if(CONSP(para))
     Compile_list(CAR(para));
  else
     Com_imm(a_undef);  /*** error? ***/
  al=syntax_alias(x);
  v=assq(al,ENV);
  if(v==a_f){
     /***  need error  if not defined  ****/
      /*** x=Symbol_alias(x);    V2.0 no need ***/
     Com_out(list2(OP[VSET],syntax_symbol(x)));
     Com_imm(a_undef);  
   }
  else{
     Com_out(list2(OP[SETENV],al));
     Com_imm(a_undef);  
  }
}

static void If_com(ptr para,ptr tail){
  ptr c,v;
  int n,nt;
   n=Label();
   c=CAR(para);
   para=CDR(para); 
   Compile_list(c);
   Com_out(list2(OP[IF_FALSE],MAKESINT(n)));
  v=CAR(para);
   para=CDR(para); 
   if(tail==a_f)
       Compile_list(v);
   else
      tc_compile(v);
   if(CONSP(para)){
      nt=Label();
      Com_out(list2(OP[VJMP],MAKESINT(nt)));
      Com_out(list2(OP[LABEL],MAKESINT(n)));
      v=CAR(para);
      para=CDR(para); 
       if(tail==a_f)
            Compile_list(v);
       else
        tc_compile(v);
      Com_out(list2(OP[LABEL],MAKESINT(nt)));
    }
  else{
      nt=Label();
      Com_out(list2(OP[VJMP],MAKESINT(nt)));
      Com_out(list2(OP[LABEL],MAKESINT(n)));
      Com_imm(a_undef);  
      Com_out(list2(OP[LABEL],MAKESINT(nt)));
  }
}
      
static void Quote_com(ptr para){
    ptr x;
      /***  need check   ***/
    x=CAR(para);
   if((!SREGP(x))&&(ATTR(x)==SYNTAXSYMBOL)) x=CADR(x);
      Com_imm(x);  
}
/****  vm-final.ss  ***/
static ptr LAB,take_label(),op_final();
static ptr jmp_count(ptr s,ptr n,ptr LABELS);

ptr final(ptr s){
   ptr x,op;
   int len;
    psh(a_nil);  /*** LABELS ***/
    psh(a_nil);  /*** OBJ ***/
  while(CONSP(s)){
      x=CAR(s);
      s=CDR(s);
      op=CAR(x);
      if(op==LAB)
         *(stack-2)=SCONS(CONS(CADR(x),take_label(s,LAB)),*(stack-2));
      else
         *(stack-1)=CONS(x,*(stack-1));
  }
  *(stack-1)=Reverse_list(*(stack-1));
   s=op_final(*(stack-1),*(stack-2));
   stack-=2;
  return s;
}
      
static ptr take_label(ptr s,ptr L){
  int cont=1;
  while(cont&&CONSP(s)){
     if(CAR(CAR(s))==L)
         s=CDR(s);
     else
        cont=0;
   }
  return s;
}
static  ptr J,F,LAM,MAC;
static void init_final(){
  J=(ptr)OP[VJMP];
  F=(ptr)OP[IF_FALSE];
  LAM=(ptr)OP[MAKE_LAMBDA];
  MAC=(ptr)OP[MAKE_MACRO];
  LAB=(ptr)OP[LABEL];
}
   
static ptr op_final(ptr s,ptr LABELS){
  ptr x,op;
  psh(a_nil);  /*** OBJ  ***/
  
 while(CONSP(s)){
   x=CAR(s);
   s=CDR(s);
   op=CAR(x);
   if(op==J)
     x=list2(OP[JMP2],jmp_count(s,CADR(x),LABELS));
   else if(op==F)
     x=list2(OP[FALSE2],jmp_count( s,CADR(x),LABELS));
   else if((op==LAM)||(op==MAC))
    x=list2(op,final(CADR(x)));
   else
      ;
   *(stack-1)=CONS(x,*(stack-1));
   }
  s=Reverse_list(*(stack-1));
  pull();
 return s;
}

static int jmp_count_aux(ptr s,ptr dest);

static ptr jmp_count(ptr s,ptr n,ptr LABELS){
   ptr dest;
   dest=assq(n,LABELS);
   if(dest!=a_f){
      if(CONSP(CDR(dest)))
        return MAKESINT(jmp_count_aux(s,CADR(dest)));
      else
        return MAKESINT(_length(s));
   }
  else
     ;    /*** SYSTEM ERROR  ***/
   return error(E_system,s);
}

static int jmp_count_aux(ptr s,ptr dest){
  int n=0;
   while(CONSP(s)){
     if(CAR(s)==dest)
          return n;
     s=CDR(s);
     n++;
   }
  /****  ERROR  ****/
  return 0;
}

static void init_inline(){
  a_INLINE=intern_c("INLINE",a_undef);
  intern_c("SETENV",OP[SETENV]);
  intern_c("SCM->BA",OP[SCM_BA]);
  intern_c("BA->SCM",OP[BA_SCM]);
  intern_c("SCM->ST",OP[SCM_ST]);
  intern_c("ST->SCM",OP[ST_SCM]);
  intern_c("SCM->MULTI",OP[SCM_MULTI]);
  intern_c("MULTI->SCM",OP[MULTI_SCM]);
  intern_c("ENV->SCM",OP[ENV_SCM]);
  intern_c("COPY-CC",OP[COPY_CC]);
  intern_c("RESTORE-CC",OP[RESTORE_CC]);
  intern_c("ENVLOAD",OP[ENVLOAD]);  /*** for syntax  V5 ***/
  intern_c("SCM->ENV",OP[SCM_ENV]);  /*** for clear ENV ***/
}

static ptr syntax_symbol_trans(ptr x){
   if(SREGP(x)||(!SYMBOLP(x))) return x;
   if(ATTR(x)&SYNTAX)
       return CADR(x); /*** original symbol name  ***/
   return x;
}

ptr syntax_symbol_list(ptr x){
 ptr y,z;
 int new=0;
   if(x==a_nil) return x;
  y=CAR(x);
    y=syntax_symbol_trans(y);
    if(y!=CAR(x)) new=1;
  if(CDR(x)==a_nil){
      if(new)
         return CONS(y,a_nil);
      else
         return x;
  }
  z=CADR(x);
    z=syntax_symbol_trans(z);
    if(z!=CADR(x)) new=2;
  if(new==0) return x;
  return SCONS(y,CONS(z,CDDR(x)));
}

void INLINE_com(ptr para){
  ptr x,n;
   x=syntax_symbol(CAR(para));
  n=ATOMVAL(x);
  x=syntax_symbol_list(CDR(para));
     Com_out(CONS(n,x));
}

/***  2010.8.17 New   ****/
ptr s_compile(int narg,ptr env){
  run_time=0;
  env=s_vm_compile(narg,env);
  run_time=1;
 return env;
}
 
