/***   write.c
***/
#define WRITE_C

#include "lisp.h"
#include <stdio.h>
#include <string.h>  // for DEBUG
#include <ctype.h>
/****  Circle print version 03.9.6   ***/
/****  stream version   03.9.9  ***/
/***  2020.1.8  circle print list, vector ***/

#define prin_s(p)   lwritestr(lpath,p)
#define format(p,obj)   sprintf(iobuff,p,obj)
#define WRITE         lwritestr(lpath,iobuff)
//#define DEBUG

#define HPACKAGE      ATOMVAL(a_package)
#define package_name(x)  CAR(x)

extern ptr error(),lfflush(),seq_print(ptr,ptr,int);   
extern char *info_hostip();
extern int info_portnumber();
extern char *Prin_sint(Long ,int ,char *); //formsk.c
//extern ptr fmopen(),fmclose(); //formsk.c  ->  change  write_str 
extern void prin_G(double ,char *);
extern ptr sys_close_str(ptr);

static void princstr(),prin_str(),prin_symbol();
ptr print( ptr , ptr , int );  /*** wflag NO=display ***/
void w_char();
void w_syntax(int attr,ptr q,ptr lpath);
//void w_vector(ptr q,ptr lpath,int wflag);
void w_matrix(ptr q,ptr lpath,int wflag);
void w_sr2(int attr,ptr q,ptr lpath);
void w_stream(ptr q,ptr lpath,int wflag);
void w_malloc(Reg ptr q,ptr lpath,int bin);
void w_package(ptr q,ptr lpath);
void w_hash(ptr q,ptr lpath);
void w_extend(ptr q,ptr lpath,int wflag);
void w_netsocket(ptr q,ptr lpath,int wflag);
//void w_subradd(ptr q,ptr lpath);
void w_closure(int m,ptr q,ptr lpath);


/*** 04.5.3  see below ***/
/*** 07.9.24  revised for  1e-05  **/
// 2020.1.2
ptr write_str=NULL;  // init by formsk.c,  str-port
/***
void right_space_off(char *p){
   char c,*q;
   q=NULL;
   while((c=*p)){
     if(q==NULL){
       if(c==' ') q=p;
     }
     else{
        if(c!=' ') q=NULL;
     }
     p++;
  }
  //  q is the top of space continue to the end of string.  
  if(q)  *q=0;
}
***/
/*** 
void cstr_right(char *p){
  char c,d;
  c=*p;
 while(c){
   d=*++p;
   *p=c;
   c=d;
}
 *++p=c;
}
***/

ptr prin1(ptr q,ptr lpath){
 print_base=GETNUM(ATOMVAL(print_radix));
 print(q,lpath,YES);
   /*** lfflush(lpath); ***/ 
  return a_undef;
}
ptr princ(ptr q,ptr lpath){  /*** display ***/
 print_base=GETNUM(ATOMVAL(print_radix));
 print(q,lpath,NO);
   /*** lfflush(lpath); ***/ 
  return a_undef;
}
ptr  pr_SINT(ptr lpath,ptr p,int radix){
      Prin_sint(GETNUM(p),radix,iobuff);
      lwritestr(lpath,iobuff);
      return a_undef;
}


ptr  pr_NUMB(ptr lpath,ptr p,int radix){
 char *pp;
 int n;
 ptr r;
    /*** printf("pr_INT %d\n",radix); ***/
   if(SINTP(p)) return pr_SINT(lpath,p,radix);
    n=TYPE(p);
      psh(p);
 if(n&BIGINT){
     pp=mpz_get_str(0,radix,BIGNUM(p));
#ifdef DEBUG
         printf("pr_INT debug %s\n",pp);
#endif
          lwritestr(lpath,pp);
          Myfree(pp);
    }
 else if(n&RATIO){ 
       pp=mpq_get_str(0,radix,RATIONAL(p));
          lwritestr(lpath,pp);
          Myfree(pp);
 }
else if(n&DOUBLE){
           prin_G(FLONUM(p),iobuff);
           // force_float(iobuff);
           /***  04.5.2  No good 2.0  ->  2
               because  OGL needs  float number Not integer!
               and compiler ouput will be 2 Not 2.0, this may cause some error!!!
          ***/
           lwritestr(lpath,iobuff);
       }
      else if(n&COMPLEX){
           /** prin_s("#c("); **/
          //if(CAR(p)!=ZERO)
              //print(CAR(p),lpath,0);
           r=CAR(p);
           if(r!=ZERO)
             pr_NUMB(lpath,r,radix);
           
          p=CDR(p);
          if(gen_eq(p,ZERO)) {
               if(r==ZERO)
                 pr_SINT(lpath,r,radix);
               goto out;
          }
           if(gsign(p))
               lwritec(lpath,'-');
           else
               lwritec(lpath,'+');
           lwritec(lpath,'i');
           psh(p=ABS(p));
            if(p!=ONE)
                 pr_NUMB(lpath,p,radix);
                // print(p,lpath,0);
               /** lwritec(lpath,')'); **/
          pull();
       }
    else
         error(E_notnum,p);
  out:
      pull();
      return a_undef;
}

/*** for debug etc, now from  only makesub.c   ***/
void pr_INTEGER(ptr lpath,Long x,int radix){
 ptr p;
   Prin_sint(x,radix,iobuff);
   lwritestr(lpath,iobuff);
}

/***  function main **/
ptr print(Reg ptr q,Reg ptr lpath,Reg int wflag) /*** wflag NO=display ***/
{   
  ptr memo;
  int n,m;
  char *pp;
  if(q==0) {
      return  prin_s("<#NULL---system---abnormal!>");
  }
  if(q==NIL) return  prin_s("()");
  //if(q==a_undef) return  prin_s("<#undef#>");
  if(q==a_undef) return  prin_s("#<>");  // change <#>
  if(q==a_unbdd) return  prin_s("#<unbdd>");  /***  to be error  Never occur for user!  ***/
  if(SINTP(q)){
       return pr_SINT(lpath,q,print_base);
     }
  if(CHARP(q)){
          w_char(q,lpath,wflag);
      goto out;
      }
    n=TYPE(q);
    /*** for debug ***/
     if(n&TKOBJ){
        /*** prin_s("write TK-OBJ\n"); ***/
           lwritestr(lpath,"#<TKLINK ");  //TKLINK
       pp=(char *)CADR(q);
       if(pp){
           lwritestr(lpath,pp);
       }
           lwritestr(lpath,">");
         // format("<#TKLINK %s#>","");
         //WRITE;
       goto out;
      }
         
  if(n&NUMBER){
       return pr_NUMB(lpath,q,print_base);
    }
  else if(n&STRING)
   {
    if(wflag) lwritec(lpath,'\"');
    if(wflag) prin_str(q,lpath);
    else
       princstr(q,lpath);
    if(wflag) lwritec(lpath,'\"');
   }
  else if((n&SYMBOL)||(n&KEYWORD)){
      if(n&SYNTAX)  w_syntax(n,q,lpath);
     else{
      if(wflag) 
         prin_symbol(q,lpath,n&KEYWORD);
      else
         princstr(PNAME(q),lpath);
       }
    }
  else if(n==BOOLEAN)
   {
      if(q==a_t) prin_s("#t");
       else
           prin_s("#f");

   }
 else if(n==CELL||n==VECTOR)
    {
      return seq_print(q,lpath,wflag);
    }
     else if(n&MATRIX)
   {
    w_matrix(q,lpath,wflag);
    }    

  else if(n&CLOSURE)
   {
      if(n&SYNTAX)
           w_syntax(n,q,lpath);
      else if(n&SRFUNC)  // EXTEND change
           w_sr2(n,q,lpath);
      else
           w_closure(n,q,lpath);
    }
   else if (n==STREAM)
   {
     w_stream(q,lpath,wflag);
   }
   else if (n&SYNTAX)
   {
     w_syntax(n,q,lpath);
   }
   else if (n&MALLOC)
  {
     w_malloc(q,lpath,n&MALLOC_BIN);
  }
   else if (n&SSPACKAGE){
       w_package(q,lpath);
  }
  else if (n&HASH){
       w_hash(q,lpath);
  }
   else if (n&STRUCTURE){
           w_extend(q,lpath,wflag);
   }
  else if (n&NETSOCKET){
      w_netsocket(q,lpath,wflag);
  }
/***
  else if (n&SUBRADD){
      w_subradd(q,lpath);
  }
***/
  else
  {
   err:
   printf("unprintable obj %lx attr %x\n",(UL)q,n);
   printf("nil %lx undef %lx\n",(UL)a_nil,(UL)a_undef);
    return error( E_unprint,q);
   }
 out:
 return a_undef;
}

static void princstr(ptr q,ptr lpath)
 {
   Uint n;
   unsigned char *p,c;
   p=get_string(q,&n);
   while(n--){
      c=*p++;
      lwritec(lpath,c);
   }
}


static void prin_str(ptr q,ptr lpath)
 {
   Uint n;
   unsigned char *p,c;

   p=get_string(q,&n);
   while(n--){
      c=*p++;
      if((c=='\"')||(c=='\\'))   /*** 2004.10.22 **/
          lwritec(lpath,'\\');
      lwritec(lpath,c);
   }
}


static void prin_symbol(ptr q,ptr lpath,int key)
 {  
   int n,m,esc=0;
   unsigned char *p,*r,c;
   ptr pk,sym;
   /*** package ***/
    sym=q;
    q=PNAME(q);
    if(key)
       pk=sym;
    else
       pk=ss_find_symbol(q,HPACKAGE);
    /*** printf("pk %x HPACKAGE %x\n",pk,HPACKAGE); ***/
     
   if(sym==a_dot) esc=1;
   r=p=get_string(q,(Uint *)&n);
   m=n;
  
   while(m--){
      c=*r++;
      if(c==' '||c=='#'||c==39||((c>=91)&&(c<=93))||c==96||c>=123){
          esc=1;
          break;
       }
   }
   if(esc)
      lwritec(lpath,'|');
   if(pk!=sym){
      pk=CDDDR(sym);  /*** symbol 's original package **/
      /** if(pk!=ss_package){   * maybe ss:symbol is shadowed ***/
      /***  need print ss: if it is shadowed! ***/
        if(pk!=a_f)
           pk=package_name(pk);
        else
           pk=a_none;  /*** ghost symbol ***/
         princstr(pk,lpath);
         lwritec(lpath,':');
      /*** }  ***/
    }
   while(n--){
      c=*p++;
      if(esc&&(c=='|'))
         lwritec(lpath,'\\');
      lwritec(lpath,c);
   }     
   if(esc)
      lwritec(lpath,'|');
  }

//  next not include sr2
void w_closure(int m,Reg ptr q,ptr lpath){
//  ptr memo=q;
  int n;
  char *r;
     //n=(long)FTYPE(q);
     n=EXATTR(q);
     if(m&LAMBDA){
         if(n&TKFUNC)
              prin_s("#[TK ");
         else if(m&SUBR){
                 prin_s("#[closure system ");
          }
          else
              prin_s("#[closure ");
       }
     else if(m&SPECIAL)
          prin_s("#[special ");
     else{  // Never???
              prin_s("#[macro ");
     }

     n&=0xffff;
     n=GETNUM(n);
     m=n&1;
     n>>=1;
     prin1(MAKESINT(n),lpath);
          lwritec(lpath,' ');
     prin1(MAKESINT(m),lpath);
          lwritec(lpath,' ');
     // r=Prin_sint((long)q,16,iobuff);  //debug

      /*** prin1(CAR(q),lpath); ***/
             /**** env  this may be includes self,
                       because   env is included in closure **/ 
         prin1(CAR(q),lpath);  /*** recursive list , check ***/ 
            lwritec(lpath,']');
}
/***
void w_subradd(ptr q,ptr lpath){
    char *r;
     prin_s("#[0x");
    r=Prin_sint((long)q,16,iobuff);  //debug
      *r++=']';
      *r='\0';

           WRITE;
}
***/


void w_malloc(Reg ptr q,ptr lpath,int bin){
       if(bin)
         prin_s("#[alloc-bin ");
        else
         prin_s("#[alloc ");
     //sprintf(iobuff," %p . %p",CAR(q),CDR(q));
     sprintf(iobuff," %p  %ld",CAR(q),GETNUM(CDR(q)));
       WRITE;
         prin_s("] "); /***  **/
}

static Uchar charw[16]={'#','\\'};

void set_charw(int n){
 Uchar *p=charw+2;
  p=set_char(n,p); // str.c
  *p='\0';
}

void w_char(Reg ptr q, ptr lpath,int flag){
  Reg int n,m;
    if(q==SEOF){
       prin_s("#<eof>");
       return;
     }
   n= CHAR_CODE(q);
   set_charw(n);
      /***  printf("prin1 char %x char_code %x\n",q,n);  ***/
  if(flag){
        q=rassq(q,CAR(a_name_char));
        if(q!=a_f){
            prin_s("#\\");
            princstr(CAR(q),lpath);
        }
       else{
              prin_s(charw);
            }
   }
   else{
          prin_s(charw+2);
   }
}

void newline(ptr lpath){
  lwritec(lpath,'\n');
}
/***
void w_vector(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n;
 p=get_vector(q,&n);
  prin_s("#(");
  while(n--){
    print(*p++,lpath,wflag);
    lwritec(lpath,' ');
  }
  lwritec(lpath,')');
}
***/

void w_matrix(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n,m,m2;
  extern ptr *get_matrix();

 p=get_matrix(q,&n,&m);
 /** printf("vect q %x p %x n=%d\n",q,p,n); **/
  prin_s("#a(");
  m2=m;
  while(n--){
    m=m2;
    prin_s("(");
    while(m--){
       print(*p++,lpath,wflag);
       lwritec(lpath,' ');
    }
  prin_s(")");
  }
  lwritec(lpath,')');
}


void w_stream(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n;
 /** printf("stream  q %x \n",q); ***/
  //n=(long)CAR(q);
  //n=ACC(q);
  n=EXATTR(q);
  if(n&SOCKET_PORT)prin_s("#[network-port ");
  else if(n&write_ac){
       if(n&read_ac)
            prin_s("#[read-write-port ");
        else
            prin_s("#[write-port ");
  }
  else  if(n&append_ac){
       if(n&read_ac)
          prin_s("#[read-append-port ");
       else
           prin_s("#[append-port ");
   }
  else prin_s("#[input-port ");
 if(n&CLOSED) prin_s("closed ");
 else{
       if(n&STR_PORT) prin_s("str "); 
       else if(n&FUNC_PORT) prin_s("func "); 
       else  if(n&SOCKET_PORT){
              if(n&listen_ac)
                 prin_s("listen ");
              else
                 prin_s("connect ");
        }
       else  prin_s("file ");
      /**  print(MAKESINT(n&0xf),lpath,wflag); **/
    }
  //
 q=CDR(q); 
  print(MAKESINT((long)CAR(q)),lpath,wflag); /***  RLOC ***/
    lwritec(lpath,' ');
  q=CDR(q);
  print(MAKESINT(CAR(q)),lpath,wflag);  /***   WLOC print as SINT  **/
    lwritec(lpath,' ');
  print(CDR(q),lpath,wflag);  /***  (UNREADC .  body),  can 't  write LOC  **/
  lwritec(lpath,']');
}

/***
w_multi(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n;
  while(q!=a_nil){
  print(CAR(q),lpath,wflag);
  newline(lpath);
 q=CDR(q);
 }
}
***/
void w_package(ptr q,ptr lpath){
 /** printf("stream  q %x \n",q); ***/
   prin_s("#[package ");
  print(CAR(q),lpath,NO); /*** location ***/
  /**  lwritec(lpath,' ');
      print(CDR(q),lpath,YES);  ***/
  lwritec(lpath,']');
}
void w_hash(ptr q,ptr lpath){
 /** printf("stream  q %x \n",q); ***/
   prin_s("#H(");
  print(CAR(q),lpath,NO); /*** location ***/
    lwritec(lpath,' ');
    lwritec(lpath,'.');
    lwritec(lpath,' ');
  print(CDR(q),lpath,NO); /*** location ***/
  lwritec(lpath,')');
}

void w_sr2(int attr,ptr q,ptr lpath){
      prin_s("#[closure sr2 ");
   print(FENV(q),lpath,YES); /*** information ***/
  lwritec(lpath,']');
}

void w_syntax(int attr,ptr q,ptr lpath){
  if(attr&LAMBDA){
      prin_s("#[syntax-transformer sr2 ");
      //format("%8lx ",(UL)q);
      //Prin_sint((long)q,16,iobuff);  //debug

      //WRITE;
       print(FENV(q),lpath,YES); /*** information ***/
  }
  else{
     if(attr&SYMBOL)
        prin_s("#[syntax-symbol  ");
     else
        prin_s("#[syntax  ");
      print(CAR(q),lpath,YES); /*** information ***/
      print(CDR(q),lpath,YES); /*** information ***/
  }
   lwritec(lpath,']');
}
  
void w_extend(ptr q,ptr lpath,int wflag){
  ptr *p,name,x;
  int n;
 /** printf("stream  q %x \n",q); ***/
   prin_s("#s(");
  print(name=CAR(q),lpath,wflag); /*** structure name ***/
    lwritec(lpath,' ');
  /*** print(CDR(q),lpath,NO); 
  lwritec(lpath,']');
   ***/
  /*** name=assq(name,ATOMVAL(a_structure_inits));  ****/
  name=assq(name,ATOMVAL(a_structure_slots_name));
  if(name!=a_f) name=CDR(name);
 p=get_vector(CADR(q),&n);
  while(n--){
    if(CONSP(name)){
      /*** x=CAR(CAR(name));   ***/
      x=CAR(name);
      name=CDR(name);
      print(x,lpath,wflag);
    lwritec(lpath,' ');
     /***  2014.5.28  ***/
      print(name,lpath,wflag);
   }
    /*** print(*p++,lpath,wflag);    2010.5.1 Circle print not supported  ****/
    lwritec(lpath,' ');
  }
  lwritec(lpath,')');

}

void w_netsocket(ptr q,ptr lpath,int wflag){
  int attr;
  struct sockaddr_in *net;
   attr=(long)CAR(q);
   if(attr!=(long)sock_addr){
      prin_s("#<socket ");
      attr=(long)CDR(q);
      print(MAKESINT(attr),lpath,wflag);
    }
   else{
      prin_s("#<netport ");
      net=(struct sockaddr_in *)CDR(q);
      print(MAKESINT(info_portnumber(net)),lpath,wflag);
      lwritec(lpath,' ');
      prin_s(info_hostip(net));
    }
    lwritec(lpath,'>');
}
/****  for Debug ***/
Uchar *dbp(ptr p){
   ptr f;
   Uint n;
   Uchar *r;
   // f=fmopen();
    f=reopen_str(write_str,0);
   princ(p,f);
   // f=fmclose();
   f=sys_close_str(f);   // not copy str, so this does not call gbc!
   r=get_string(f,&n);
  return r;
}

