#include "lisp.h"
#include <stdio.h>
/****  Circle print  2020.1.5  new   see circle.ss   ***/
/***    we support for list and vector               ***/
/****   05.10.8   separated from write.c  ***/
/****   07.1.16  Bug fix of
         previous version can not print
            a=(.. a .. a ...)
        this cause infinite loop by simple Mark-method only
        Therefore we make the list of table 
****/
/***  07.3.22  print_list must re-entrant because (a b #((cd ...)   ***/



#define prin_s(p)   lwritestr(lpath,p)

#define circle_list  *(stack-2)
#define circle_list_first  *(stack-1)
extern ptr print(ptr,ptr,int);
extern ptr princ(ptr,ptr);   // wflag=NO
extern ptr copy_list(),memq();
static int nc;
static void docp(ptr ,ptr , int );
static void docp_list(ptr ,ptr ,int );
static void docp_vec(ptr ,ptr ,int);
static void docp_aux(ptr  ,ptr  , int  );
static void cc_aux(ptr );
static void cc(ptr );
static void list_print_simple(ptr ,ptr,int);
static ptr cc_vec_check(ptr ,ptr );
static ptr cc_check(ptr ,ptr );
static void clear_circle(ptr );
static char dotp[]=" . ";


static ptr circle_first(ptr q){
 ptr as;
  /*** n=safe_assq(q,circle_list); ***/
   as=assq(q,circle_list); 
  if(as!=a_f){
     if(memq(q,circle_list_first)!=a_f)
        return CDR(as);
     q=CONS(q,circle_list_first);
     circle_list_first=q;
     return as;  //first return pair
  }
 return as;
}


void print_circle_def( ptr n,ptr lpath){
  prin_s("#=");
  princ(n,lpath);
    lwritec(lpath,' '); //  need space because   #=0#  read |0#| must be#=0 #(...)
}

void print_circle_ref( ptr n,ptr lpath){
  prin_s("#-");
  princ(n,lpath);
    lwritec(lpath,' '); //  need space because   #=0#  read |0#| must be#=0 #(...)
}


static void vec_print_simple(Reg ptr x,Reg ptr lpath,Reg int wflag){
      int s,i,n;
      ptr *p;
        p= get_vector(x,&s);
     prin_s(" #(");
       for(i=0;i<s;i++){
         x=*p++;
        if(SREGP(x))
          print(x,lpath,wflag);
        else{
           n=ATTR(x);
           if(n==CELL)
             list_print_simple(x,lpath,wflag);
            else if(n==VECTOR)
             vec_print_simple(x,lpath,wflag);
            else
              print(x,lpath,wflag);
       }
       if(i<s-1) lwritec(lpath,' ');
     }
    lwritec(lpath,')');
}


static void list_print_simple(Reg ptr q,Reg ptr lpath,Reg int wflag) /*** wflag NO=display ***/
{
  ptr car;
      lwritec(lpath,'(');
      while(1)
       {
         car=CAR(q);
         if(SREGP(car)||ATOM(car))
              print(car,lpath,wflag);
         else
              list_print_simple(car,lpath,wflag);
        q=CDR(q);
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
               lwritec(lpath,' ');
           }
          else
           {  /***  dot   pair  ***/
            prin_s(dotp);
              print(q,lpath,wflag);
            break;
           }
        }
      lwritec(lpath,')');
}

static void docp_list(ptr x ,ptr lpath , int wflag ){
  ptr as;
  int n;
   if(SREGP(x)){
            prin_s(dotp);
            print(x,lpath,wflag);
            return;
   }
  if(x==a_nil) return;
  n=ATTR(x)&CIRCLECLR;
    if(n==CELL){
       docp(CAR(x),lpath,wflag);
     lwritec(lpath,' ');
      x=CDR(x);
     as=circle_first(x);
     if(as!=a_f){
       if(SINTP(as)){
            prin_s(dotp);
            print_circle_ref( as,lpath);
       }
       else{
            prin_s(dotp);
            print_circle_def( CDR(as),lpath);
            //  may be vector   !!! 
            //docp_list(x,lpath,wflag);
            docp_aux(x,lpath ,wflag );
       }
      }else
            docp_list(x,lpath,wflag);
   }
  else{
            prin_s(dotp);
            docp(x,lpath,wflag);
  }
}   

static void docp_vec(ptr x,ptr lpath,int wflag){
      int s,i;
      ptr *p;
        p= get_vector(x,&s);
       for(i=0;i<s;i++){
         docp(*p++,lpath,wflag);
         lwritec(lpath,' ');
        }
}
//  not SREG  & def is already written
static void docp_aux(ptr q ,ptr lpath , int wflag ){
  int  n;
   n=ATTR(q)&CIRCLECLR;
    if(n==CELL||n==VECTOR){
       if(n==VECTOR) lwritec(lpath,'#');
            lwritec(lpath,'(');
       if(n==CELL)
            docp_list(q,lpath,wflag);
       else
            docp_vec(q,lpath,wflag);
        lwritec(lpath,')');
   }
   else
     print(q,lpath,wflag);        
}
  
  
     
static void docp(ptr q ,ptr lpath , int wflag ){
   ptr as;
   int n;
   if(SREGP(q)){
     print(q,lpath,wflag);
     lwritec(lpath,' ');
     return;
   }
   as=circle_first(q);
   if(as!=a_f){
      if(SINTP(as)){
            print_circle_ref( as,lpath);
            return;
       }
      else{
            print_circle_def( CDR(as),lpath);
      }
   }
  docp_aux(q ,lpath ,wflag );
}
        
//    from write.c
ptr seq_print(Reg ptr q,Reg ptr lpath,Reg int wflag) /*** wflag NO=display ***/
{
  /***  2020.1.5   for list &vector **/
  ptr x;
  psh(NIL);
  psh(NIL);
   nc=0;
   cc(q);
   x=circle_list; 
   if(x==NIL){
           if(ATTR(q)==CELL)
              list_print_simple(q,lpath,wflag);
           else
              vec_print_simple(q,lpath,wflag);
     }
   else
    docp(q ,lpath , wflag );
  stack-=2;
   return a_undef;
}

/***  07.3.21  New!  ***/

static void regist_circle(ptr x){
  ptr q;
   q=CONS(x,MAKESINT(nc));
   q=SCONS(q,circle_list);
   circle_list=q;
   nc++;
}


static void cc_vec(ptr x){
      int s,i;
      ptr *p;
        p= get_vector(x,&s);
         SETCIRCLE(x);
       for(i=0;i<s;i++)
         cc_aux(*p++);
}

static void cc_aux(ptr x){
    int n;
     if(SREGP(x)) return;
     n=ATTR(x);
     if(n&CIRCLEMARK) {
          regist_circle(x);
         return;
      }
     if(n==CELL){
         SETCIRCLE(x);
         cc_aux(CAR(x));
         cc_aux(CDR(x));
         return;
     }
     if(n==VECTOR)
        cc_vec(x);
}
// check true circle
static void cc_true(ptr root){
  ptr x,c,as,lis=circle_list,*res=stack;
  psh(a_nil);
  while(lis!=a_nil){
    c=CAR(lis);
    x=CAR(c);
    if(x==root)
         *res=CONS(c,*res);
    else{
         as=cc_check(x,x);
         if(as!=a_f)
            *res=CONS(c,*res);
          clear_circle(x);
        }
    lis=CDR(lis);
   }
   x=*res;
   pull();
   circle_list=x;
}
static ptr cc_check(ptr root,ptr x){
    ptr as;
    int n;
    if(SREGP(x)) return a_f;
    n=ATTR(x);
    if(n&CIRCLEMARK)
        return (x==root)?a_t:a_f;
    else{
      if(n==CELL){
        SETCIRCLE(x);
        as=cc_check(root,CAR(x));
        if(as!=a_f) return as;
         return cc_check(root,CDR(x));
      }
      else if(n==VECTOR)
         return cc_vec_check(root,x);
      else
         return a_f;
    }
}

static ptr cc_vec_check(ptr root,ptr x){
      int s,i;
      ptr *p,as;
    if(ATTR(x)&CIRCLEMARK)
        return (x==root)?a_t:a_f;
        SETCIRCLE(x);
        p= get_vector(x,&s);
       for(i=0;i<s;i++){
         as=cc_check(root,*p++);
         if(as!=a_f) return as;
       }
   return a_f;
}
        

static void clear_vec(ptr x){
      int s,i;
      ptr *p;
        p= get_vector(x,&s);
       for(i=0;i<s;i++)
         clear_circle(*p++);
}


static void cc(ptr root){
   cc_aux(root);
   clear_circle(root);
   //  true check
   if(circle_list!=a_nil)
         cc_true(root);
}

static void clear_circle(ptr x){
    int n;
     if(SREGP(x)) return;
     n=ATTR(x);
     if(n&CIRCLEMARK) {
         n&=CIRCLECLR;
         ATTR(x)=n;
      }
    else
      return;
     if(n==CELL){
         clear_circle(CAR(x));
         clear_circle(CDR(x));
         return;
     }
     if(n==VECTOR)
        clear_vec(x);
}


