;;;  html-font.ss
;;;;    2005.1.13
;;;
(in-package "http")
(require "http-base")

(define *font-vector* #(0 H8 H7 H6 H5 H4 H3 H2 H1))  ;;; size order

(define (create-font)
  (font 'create  'default :family 'Courier :size 12)
  (font 'create  'H1 :family 'Courier :size 20)
  (font 'create  'H2 :family 'Courier :size 18)
  (font 'create  'H3 :family 'Courier :size 16)
  (font 'create  'H4 :family 'Courier :size 14)
  (font 'create  'H5 :family 'Courier :size 13)
  (font 'create  'H6 :family 'Courier :size 12) ;;; default
  (font 'create  'H7 :family 'Courier :size 11)
  (font 'create  'H8 :family 'Courier :size 10)
)
;;; define font tag in text widget
(define (init-font-def  text)
  (funcall text 'tag 'configure 'H1 :font 'H1) 
  (funcall text 'tag 'configure 'H2 :font 'H2) 
  (funcall text 'tag 'configure 'H3 :font 'H3) 
  (funcall text 'tag 'configure 'H4 :font 'H4) 
  (funcall text 'tag 'configure 'H5 :font 'H5) 
  (funcall text 'tag 'configure 'H6 :font 'H6) 
  (funcall text 'tag 'configure 'H7 :font 'H7) 
  (funcall text 'tag 'configure 'H8 :font 'H8) 
  ;;;;
  (funcall text 'tag 'configure 'center :justify 'center) 
  (funcall text 'tag 'configure 'super  :offset 6) 
  (funcall text 'tag 'configure 'sub  :offset -6) 
  (funcall text 'tag 'configure 'underline  :underline #t) 
  (funcall text 'tag 'configure 'raised  :relief 'raised) ;;; dame
  (funcall text 'tag 'configure 'solid  :relief 'solid) 
 ;;;  bg color
  (funcall text 'tag 'configure 'bg-snow  :background 'snow) 
 ;;;  fg color
  (funcall text 'tag 'configure 'fg-gray  :foreground 'gray) 
)

(create-font)

(define (init-tag-def  html)
   (let* ( (popup (SWEB-popup *active-web*)) (func 0) (s 0))
  (format #t "init-tag popup ~s~%" popup)
    (funcall html 'tag 'configure 'href_relative  :foreground 'brown :underline 'true)
    (funcall html 'tag 'configure 'href_abs :foreground 'blue :underline 'true)
    (funcall html 'tag 'configure 'popup )
    (funcall html 'tag 'configure 'error   :foreground 'white :background 'red)
    (set! func  (lambda(X Y) ;;;;(format #t "tag-popup ~s~%" popup)
                 (popup-configure popup)(tk_popup popup X Y))
    )
    (set! s (SWEB-popupfunc *active-web*))
    (push func s)
    (set-SWEB *active-web* :popupfunc s)   ;;;  Why we need this?????
    (funcall html  'tag 'bind  'popup  "<Button-3>" func)
))
;;;
(define (make-popup-menu sweb)
   (let* ( (p  0)(pro 0)(n 0)(popup (SWEB-popup sweb)))
      (menu popup :tearoff 'no)
      (funcall popup 'add 'command :label "DL" :command
           (lambda()(set! *active-web* sweb)
              (http-get *URL*)
             ))
      (funcall popup 'add 'command :label "Open New window" :command
           (lambda()(write "test 1")(write *URL*)
               (gen-web)
               (funcall (SWEB-url  *active-web* ) 'insert 'insert *URL*)
               (http-get-force *URL*)
             ))
     ;;; (bind win "<Button-3>" (lambda(X Y) (tk_popup  popup  X Y)))
))

(define (popup-configure popup)
  (format #t "popup ~s~%" popup)
  (funcall popup 'entryconfigure 0 :label *URL*)
)

