(in-package "tty")
#|
(define (test1)
  (let* ((a #t)(x 0))
    (while a
    (set! x (inkey #f))
    (if (eq? x #\q) (set! a #f))
    (format #t "~s  ~s~%" x (char->integer x))
   )
 ))
|#

;;;  can not Down if located lowest line

;;(exec "infocmp")
;;;(exec "infocmp -I vt100")
;;;
(load "readchk")                              
;;;  we assume   locate at bottom
(define ESC (string #\escape))

(define *cont* #t)
(define *cur-x* 0)   ;;;  x of in *scr*  ---   logical position                        
(define *cur-y* 0)
(define *real-x* 0)  ;;;; x of real-cursor                        
(define *real-y* 0)                        
(define *begin-x* 0)  ;;;; x of begin at the first line                        
(define *cur-bottom* 0)
(define *real-bottom* 0)
(define *max-xscr* 50)
(define *max-yscr* 30)
(define *scr* (make-matrix *max-yscr* *max-xscr*  #\null))  ;;;ss input
                    ;; we can edit 300 line
;;; change table for reflesh
(define *scr-change* (make-matrix *max-yscr* *max-xscr*  #\null))  ;;;
  ;;;backup for current
(define *scr2* ())  ;;;
(define *tty-history* -1)
(define *read-chk* #f)

;;;  make *scr*
(define (make-scr)
  (let* ((c 0))
     (if *win-change*
        (begin
         (set! *max-xscr* (- *win-xsize* 1))
         (set! *max-yscr* 5)   ;;;; initial ysize 
         (set! *scr*
             (make-matrix *max-yscr* *max-xscr*  #\null))  ;;;ss input
         (set!  *scr-change* 
             (make-matrix *max-yscr* *max-xscr*  #\null))  ;;;
         (set! *win-change* #f)
        )
       (begin
          (matrix-fill! *scr* #\null)
          (matrix-fill! *scr-change* #\null)
       )
     )
))

;;;  element *scr* is
;;;  #\null   initial
;;;  #f        protected
;;;  #t        right-end
;;;  newline  (symbol)  end-of-line && don't continue next
;;;  char      normal
;;;  (char . attr)  normal extended

;;;  Never locate on #\null
;;;  every time  insert mode for newline
;;;  if newline is inserted in a line, then divide the line !!!
;;;  the last of continue line is of the form   char #t

(define *tty-buff* ())

(define (tty-read-char)
   (if (pair? *tty-buff*)
         (pop *tty-buff*)
       (begin
         (flush)
         (set! *tty-buff* (line-ed))
          (tty-read-char)
       )
   )
)

(shadowing-intern "tty-read-char" "alias")

(intern "tty" "ss")
(define (tty  . x)    ;;;  ss symbol!!!
   (if (or (null? x)(car x)) 
        (set! tty-read-char alias:tty-read-char)
        (set! tty-read-char (make-undef))
   )
) 
   
(define (test-tty)
   ;;;(inkey-esc)   ;;; take newline
   ;;(newline)
   ;;;(display "test> ")
   (flush)
   (line-ed)
)

(define (line-ed)
  (let* ((x 0)(c 0)(ct 0) )
    (init-scr)
      (reflesh)
   (while *cont*
      (if (or (> *cur-bottom* (+ ct 5))(not (char-ready?)))
          (begin  (set! ct *cur-bottom*)
              (reflesh-chk))  ;;;char-ready?r
       )
      ;;(if (not (char-ready?)) (reflesh))  ;;;char-ready?r
      ;;;(reflesh)
      ;;;;(update)        ;;;;  not need  in tty_raw.c included!!!
      (set! x (inkey-esc))
      (cond ((eq? x #\newline)
               ;;;(if (and (end-point?) (not (char-ready?))))
               ;;(if  (not (char-ready?))
               (if  (not (char-ready?))
                       (set! *cont* #f)
                       (if (end-point?)
                          (cur-down)
                          (scr-insert 'newline)
                       )
                )
                (if (>= *cur-bottom* *win-ysize*)
                      (set! *cont* #f)
                )
              )
            ;;((eq? x #\enq)   ;;; CTRL-E  for debug
            ;;    (format #t "getch ~s" (getch))
            ;;   )
           ;;; ((eq? x #\P)       ;;;;for debug
           ;;;    (print-scr) )
           ((eq? x #f)   )    ;;; unknown control
            ((char? x)
               (scr-insert-char x)
             )
           (else
               (apply x ())
               (set! ct -10)
           )
      )
    )
   (cur-end)
   (reflesh)
  (display #\newline)
  (set-bg white)
  (set-fg black)
  (line-ed-str )
))

(define (reflesh-chk)
    (if *read-chk*
         (begin (read-chk) (set! *read-chk* #f)))
    (reflesh)
)


(define (read-end)
    (set! *cont*  #f))

(define (cur-begin-end)
    (if (= *cur-bottom* 0)
        (if (> *cur-x* *begin-x*)
            (cur-begin)
             (cur-end)
        )
        (if (> *cur-y* 0)
            (cur-begin)
            (cur-end)
        )
    )
)

(define (his-up) 
   (let* ((x 0))
      (if (= *tty-history* -1)
           (set! *scr2*   (line-ed-str)) ;;;(matrix-copy *scr*)
       )
      (inc *tty-history*)
      (if (>= *tty-history* (vector-length *line-history*))
          (dec *tty-history*)
          (begin
             (real-locate 0 0)
             (set! x  (vector-ref *line-history* *tty-history*))
             (if (string? x)
                  (tty-hotstart (string->list x))
                  (dec *tty-history*)
              )
          )
      )
))

(define ( his-down)
   (let* ((x 0))
    (when (> *tty-history* -1)
         (dec *tty-history*)
          (real-locate 0 0)
          (if (=  *tty-history* -1)
              (begin
                  ;;; (format #t "Pdown to -1 ~%")
                  ;;;(set! *scr* *scr2*)
                   (tty-hotstart  *scr2*);;;; (line-ed-str)
               )
              (begin
                (set! x  (vector-ref *line-history* *tty-history*))
                (tty-hotstart (string->list x))
              )
         )
   )
))

(define (scr-hotstart)
     (tty-hotstart   (line-ed-str))
)

(define (scr-insert-char x)
  (let* ((c 0))
      (set! c (char->integer x))
        (cond ((< c 32))    ;;; undefined-control are omitted
              ((< c 256)
                 (scr-insert  x)
                   (if (or (eq? x #\( )(eq? x #\)) (eq? x #\"))
                     (set! *read-chk* #t)
                   )
                 )
              (else
                      ;;;(set! x (integer->char (ash c -8)))
                  (set! x (cons #\bell x))
                  (scr-insert  x)
                      ;;;(set! x (integer->char (logand  c 255)))
                  (set! x (cons #\bell #f))
                  (scr-insert  x)
               )
        )    
))

(define (end-point?)
   (and (eq? *real-y* *cur-bottom*)
        (eq? (getch) 'newline)
   )
)

(define (init-scr)
   (set! *tty-history* -1)
   (make-scr)
   (set! *cur-x* (get-line-pos))
   (when (>= *cur-x* (- *max-xscr* 3))
        (display #\newline)
        (set! *cur-x* 0)
   )
   (set! *real-bottom* 0)
  (hot-scr)
)

(define (hot-scr)
   (clear-scr *scr*)
   (clear-scr *scr-change*)
   (set! *cur-y* 0)
   (set! *cur-bottom* 0)
   (set! *real-y* 0)
   (set! *real-x* *cur-x*)
   (set! *begin-x* *cur-x*)
   (scr-set-top #f)
   (scr-set-boundary)
   ;;;(matrix-set! *scr* 0 *cur-x* 'newline)  ;;;New!
   (scr-set 'newline)
   (set! *cont* #t)
)

(define (scr-set-boundary)
   (do ((i 0 (+ i 1)))
       ((= i *max-yscr*))
        (matrix-set! *scr* i (- *max-xscr* 1) #t)
   )
)


(define (scr-set-top data)
  (do ((i 0  (+ i 1)))
      ((= i *cur-x*))
      (matrix-set! *scr* *cur-y* i data)
  )
)

(define (clear-scr scr)
   (matrix-fill!  scr #\null)
)

(define (backspace)
  (let* ((c 0))
   (if (= *cur-x* 0)
      (if (> *cur-y* 0)
          (begin
             (cur-up)
             (cur-last)
             ;;;(backspace)
             (set! c (getch))
             (erase1)
             (if (kanji-1st? c) (kanji-bs))
           )
          #f
      )
     (begin
        (if (kcur-left)
           (begin
             (set! c (getch))
             (erase1)
             (if (kanji-1st? c) (kanji-bs))
           )
            #f
        )
      )
   )
))

(define (kanji-bs)
   ;;;(when (and (> *cur-x* 0)
    (when (kanji-2nd? (getch))
         ;;;(cur-left)
         (erase1)
   )
)

;;; erase1
;;;  ab...N...#t => b...N...#t
;;;  ab......c#t       b....cd#t
;;;  d....         =>  erase1 d....   (even if d is N)
;;;  N...         =>  nothing
;;;  i.e.    N is terminate
;;;
(define (erase1)
   (let* ((x 0)(locx 0)(locy 0))
     (set! x (getch))
     (cond ((eq? x #f)
                (cur-right))  ;;;;error
           ((eq? x 'newline) )
           (else
             (set! locx  *cur-x*)
             (set! locy  *cur-y*)
             (do ((c 0))
                 ((or (eq? c 'newline) (eq? c #\null))
                   (if (eq? c 'newline) (scr-put #\null))  ) 
                 (set! c (getch-next))
                 (if (eq? c #t)
                   (begin
                      (set! c (getch-nextline))
                      (if (not (eq? c #\null))  ;;; next  exist
                        (scr-put c) 
                        (set! *cur-x* 0)
                        (inc  *cur-y*)
                        (erase1)
                        (set! c '#\null)  ;;;end
                      )
                    )    
                   (begin
                     (scr-put c) 
                   )
                 )
             )
            (locate locx locy)
           )
     )
))

(define (delete)
  (when (kanji-1st? (delete1))
      (delete1)
  )
)

(define (delete1)
  (let* ((x (getch)))
   (if (eq? x 'newline)
       (if (< *cur-y* *cur-bottom*)
           (delete-new)
           #f
       )
      (begin
         (erase1)
         x
      )
   )
))

(define (delete-new)
  (let* ((n 0) (locx *cur-x*)(locy *cur-y*))
     (if (< *cur-y* *cur-bottom*)
       (begin
         (set! n (copy-line-from-next))
         (locate 0 (+ *cur-y* 1)) 
         (while (> n 0)
            (erase1)
            (dec n)
         )
         (if (eq? (getch) 'newline)
             (delete-line)
         ) 
          (locate locx locy)
          (cur-last)
          (cur-adjust-last)
        )
       #f
     )
))
        
#|
(define (delete-new)
   (let* ((x 0) (locx *cur-x*)(locy *cur-y*))
      (locate 0 (+ *cur-y* 1))
      (set! x (delete1))
      (locate locx locy)
      (when  x 
           (scr-set x)  
           (if (not (eq? (getch-next) #t))
               (scr-set-loc (+ locx 1) locy 'newline)
           )
          (cur-right)
       )
    x
))  
|#
(define (delete-line) 
  (if (> *cur-y* 0) 
    (begin
      (up-matrix *scr* *cur-y* *cur-bottom*)
      (change-all)
      (if (= *cur-bottom* *cur-y*)
           (cur-up)
           (cur-top)
      )
      (reflesh)
      (dec *cur-bottom*)
    )
   (clear-1st-line)
 )
)
     
(define (getch)
   ;;;  Debug
   (if (eq? *cur-x* *max-xscr*)
      (begin
         (format  #t "key abnormal x~%")
         #t
      ) 
     (matrix-ref *scr* *cur-y* *cur-x*)
   )
)

(define (getch-loc x y)
   (matrix-ref *scr* y x)
)

(define (getch-next)
   (matrix-ref *scr* *cur-y* (+ *cur-x* 1))
)  
                   
(define (getch-prev)
   (matrix-ref *scr* *cur-y* (- *cur-x* 1))
)  

(define (scr-put c)
    (if (eq? (getch) #t)
        (cur-right)
    )
    ;;;(scr-fill-space)
    (matrix-set! *scr* *cur-y* *cur-x* c)    
    (matrix-set! *scr-change* *cur-y* *cur-x* #t)    
    (if (pair? c) (set! c (car c)))
    (if (eq? c #\null)(set! c #\space))
    ;;;(display c)
    (inc *cur-x* )
    (set! c (getch))
   ;; (if (eq? c #t)
   ;;     (cur-right))
)

(define (real-put-kanji c)
  (let* ((w 2))
     (set! c (cdr c))
     (if (and c (not (eq? c #t)))
         (begin
              (display c)
              (inc *real-x* w)
              (when (>= *real-x* *max-xscr*)
                   (display #\space)
                   (inc *real-x*)
                    (real-left)
               )
          )
         (begin
              (if (= *real-x* 0)
                  (begin
                     (display #\space)
                     (inc *real-x*)
                  )
                  (real-right)
              )
         )
      )
 ))

(define (real-put c)
  (let* ((d  0))
    (cond ((char? c) 
             (if (eq? c #\null) (set! c #\space))
             (display c) (inc *real-x*))
          ((pair? c)
              (set! d (car c))
              (if (eq? d #\bell)   ;;; kanji
                 (real-put-kanji c)
                 (begin
                    (attr-display  c) 
                    (inc *real-x*))
              )    )
          ((eq? c 'newline) 
              (set-bg gray)
              (display #\space) 
               (set-bg white)
              (inc *real-x*))
          (else
                 )
   )
))

(define (attr-display cc)
  (let* ((c (car cc)) (attr (cdr cc)))
    (cond ((>= attr -1000) (attr-display-nest c attr))
          ((>= attr -2000) (attr-display-comment c attr))
          ((>= attr -3000) (attr-display-str c attr))
          ((>= attr -4000) (attr-display-escape c attr))
    )
))

(define (attr-display-nest c attr)
     (set! attr (modulo attr 4))
     (set-fg (+ attr 1))
     (display c)
     (set-fg black)
)

(define (attr-display-comment c attr)
     (set-bg  blue)
     (display c)
     (set-bg white)
)   

(define (attr-display-str c attr)
     (if (= attr -2999)
        (begin
          (set-fg  blue)
          (display c)
        )
       (begin
          (display c)
         (set-fg black)
       )
    )
)

(define (attr-display-escape c attr)
     (if (= attr -3999)
        (begin
          (set-bg  mazenda)
          (display c)
        )
       (begin
          (display c)
         (set-bg white)
       )
    )
)

(define (scr-set c)
    (matrix-set! *scr* *cur-y* *cur-x* c)    
    (matrix-set! *scr-change* *cur-y* *cur-x* #t)    
)    

(define (scr-set-loc x y  c)
    (matrix-set! *scr* y x  c)
    (matrix-set! *scr-change* y  x #t)
)

(define (locate-x loc)   ;;;; logical
    (set! *cur-x* loc)
)

(define (locate-y loc)
    (set! *cur-y* loc)
)     

(define (locate x y)
    (set! *cur-x* x)
    (set! *cur-y* y)
)

(define (real-locate-x loc)
   (if (> loc *real-x*)
         (while (> loc *real-x*) (real-right))
         (while (< loc *real-x*) (real-left))
   )
)

(define (real-locate-y loc)
   (if (> loc *real-y*)
         (while (> loc *real-y*) (real-down))
         (while (< loc *real-y*) (real-up))
   )
)

(define (real-locate x y)
   (real-locate-y y)
   (real-locate-x x)
)
#|
(define (scr-fill-space)
  (do ((i  *cur-x*)(c 0))
      ((= i 0))
      (dec i)
      (set! c (matrix-ref *scr* *cur-y* i))
      (if (eq? c #\null) (matrix-set! *scr* *cur-y* i #\space)
             (set! i 0)
      )
   )
)
|#
(define (real-left)
      (display Left)
      (dec *real-x*)
)
      
(define (cur-left)
 (let*  ((c 0))
   (if (= *cur-x* 0)
      (if (> *cur-y* 0)
         (begin
            (cur-up)
            (cur-last)
            (cur-adjust-last)
         )
         #t
     )
    (begin
      (set! c (getch-prev))
      (if (eq? c #f)
           #f
        (begin
          (dec *cur-x*)
        )
      )
    )
  )
))

(define (kcur-left)
 (let*  ((c 0))
   (if (= *cur-x* 0)
      (if (> *cur-y* 0)
         (begin
            (cur-up)
            (cur-last)
            (cur-adjust-last)
         )
         #t
     )
    (begin
      (set! c (getch-prev))
      (if (eq? c #f)
           #f
        (begin
          (dec *cur-x*)
          (set! c (getch))
          (if (kanji-2nd? c)
             (cur-left)
          )
        )
      )
    )
  )
))

(define (real-right)
   (display Right)
   (inc *real-x*)
)

(define (kanji-char? c)
   (cond ((pair? c)
            (eq? (car c) #\bell))
        ;; ((char? c)
        ;;;    (> (char->integer c) 127))
         (else #f)
))

(define (kanji-2nd? c)
   (and  (pair? c)
           (eq? (car c) #\bell) (eq? (cdr c) #f))
)

(define (kanji-1st? c)
   (and  (pair? c)
           (eq? (car c) #\bell)  (cdr c) (not (eq? (cdr c) #t) ))
)
(define (kanji-3rd? c)
   (and  (pair? c)
           (eq? (car c) #\bell) (eq? (cdr c) #t))
)


(define (cur-right)
  (let* ((c (getch-next)))
    (if (eq? c #t)
        (begin
          (cur-down)
          (cur-top)
        )
      (begin
         (set! c (getch-next))
         (if (or (eq? c #\null) (eq? c #t))  ;;; Never on #t
              #f
           (begin
              (inc *cur-x*)
           )
        )
      )
   )
))

(define (kcur-right)
  (let* ((c (getch-next)))
    (if (or (eq? c #\null) (eq? c #t))
        (if (< *cur-y* *cur-bottom*)
          (begin
           (cur-down)
           (cur-top)
          )
         #f
        )
      (begin
              ;;; kanji
           (set! c (getch))
           (inc *cur-x*)
           (when (kanji-1st? c)
                  ;;;(inc *cur-x*)
                (cur-right)   ;;;last char may be first char of kanji 
          )
      )
   )
))


(define (real-up)
      (display Up)
      (dec *real-y*)
)

(define (cur-up)
   (if (eq? *cur-y* 0)
       #f
    (begin
      (dec *cur-y*)
      (cur-adjust)
    )
  )
)

(define (getch-nextline)
  (let* ((c 0))
   (if (< *cur-y* *cur-bottom*)
     (begin
        (getch-loc 0 (+ 1 *cur-y*))
     )
    #\null
  )
))

(define (real-down)
    (display Down)
    (inc *real-y*)
)

(define (scr-resize n)
      (set! *max-yscr* (+ *max-yscr* n))
       (set! *scr* (matrix-resize *scr* *max-yscr* *max-xscr* #\null))
       (set! *scr-change* (matrix-resize *scr-change* *max-yscr* *max-xscr* #\null))
       (scr-set-boundary)
)

(define (cur-down)
   (if  (= (+ *cur-y* 1) *max-yscr*)   ;;; auto-resize
       (scr-resize 5)
   )
   (if (= *cur-y* *cur-bottom*)
         (begin 
            (if (= *cur-bottom* *real-bottom*)
              (begin
                (real-locate 0 *cur-y*)
                (display #\newline)    ;;;;  special!!!
                (set! *real-x* 0) 
                (inc  *real-y* ) 
                 (set! *cur-x* 0)
                 (inc *cur-y*)
                 (set! *cur-bottom* *cur-y*)
                 (set! *real-bottom* *cur-y*)
              )
             (begin
                 (set! *cur-x* 0)
                 (inc *cur-y*)
                 (set! *cur-bottom* *cur-y*)
              )
            )
           (scr-set 'newline)
         )
     (begin 
        (inc *cur-y*)
        (cur-adjust)
     )
  )
)

(define (cur-adjust)
   (let* ((c (getch)))
      (if (or (eq? c #t) (eq? c #\null))
           (cur-adjust-last)
           (cur-adjust-top)
      )
))
           

(define (cur-adjust-last)
   (let* ((c (getch)))
      (if (eq? c #t)
           (cur-left)
      )
      (while  (eq? (getch) #\null)
            (cur-left)
      )
      ;;;(if (eq? (getch) 'newline) (cur-left))
    (if (kanji-2nd? (getch)) (cur-left))
))

(define (cur-adjust-top)
   (let* ((c (getch)))
        (if (eq? c #f)
            (while (eq? (getch) #f)
                  (cur-right)
             )
        )
   (if (kanji-2nd? (getch)) (cur-right))   ;;; 2nd may be top
))



(define (cur-top)
      (set! *cur-x* 0)
      (cur-adjust-top)
)

(define (cur-begin)
      (locate 0 0)
      (cur-adjust-top)
)

(define (cur-end)
      (set! *cur-y* *cur-bottom*)
      (cur-last)
)  

(define (cur-last)
      (set! *cur-x* (- *max-xscr* 2))  ;;;  Never on #t
      (cur-adjust-last)
)


(define (cur-right-word)   
   (let* ((c 0))
      (if (eq? (getch) #\space)
          (while (eq? (getch) #\space)
              (cur-right)
           )
      )
))

;;; insert s (!=N)  at a,   K=#\null,  N=newline
;;;  a...bK...#t   =>  sa...b...#t
;;;  a...bc#t  =>      sa...b#t,  insert c top of Next  (c may be  N )
;;;  insert N  at b
;;;     if b=N    => Do nothine
;;;     a...b...d#t =>   a...N
;;;                       insert from d to b next line                   
;;;     a...b..N#t       a..N
;;;                      b...N       (divide )

(define (scr-insert ch)
     ;;;(format #t "~s ~s~%" ch locx)
     (if (eq? ch 'newline)
            (scr-insert-new)
            (scr-insert-sub ch)
     )
)

(define (scr-insert-sub  ch)
   (let* ((locx *cur-x*)(locy *cur-y*))
     ;;;(format #t "scr-insert-sub ~s~%" ch)
     (do ((x 0)(y 0))
         ((eq? y #\null))
         (set! y (getch))
     ;;;(format #t "scr-insert-sub ~s ~s~%" ch y)
         (cond ((eq? y #\null)
                   (scr-set ch))
               ( (and (eq? ch 'newline)(eq? y ch))
                  (set! y #\null)  )  ;;; end
               ((eq? y #t)
                   (cur-down)
                   (set! *cur-x* 0)
                   (scr-insert ch)
                   (set! y #\null)  ;;; end
                  )
               (else
                  (scr-put ch)
                  (set! ch y)
               )
          )
     )
     (locate locx locy)
     (when (eq? (getch) #t)
           (cur-down)       ;;;; insert to nexline top
           (set! *cur-x* 0)
     )
     (cur-right)
))

(define (scr-insert-new)
    (let* ((x (getch)) (y 0) )
       (if (not (eq? x 'newline))
         (if (exists-new?)
             (begin
                (line-divide)
                (locate 0 (+ 1 *cur-y*))
              )
             (begin
               (set! x *cur-x*)
               (set! y *cur-y*)
               (locate 0 (+ y 1))  
               (do ((i (- *max-xscr* 2) (- i 1)))
                   ((< i x))
                   (scr-insert-sub (getch-loc i y))
                   (cur-left)
                   (scr-set-loc i y #\null)
               )
              (scr-set-loc x y 'newline)
           ) 
        )
        (begin
                (line-divide)
                (locate 0 (+ 1 *cur-y*))
        )
     )
 ))

(define (exists-new?)
   (do ((i *cur-x* (+ i 1))(ans #f) )
       ( (or ans (= i *max-xscr*)) ans)
       (if (eq? (getch-loc i *cur-y*) 'newline)
            (set! ans #t)
       )
   )   
)

(define (line-divide)
    (when  (= *cur-bottom* *real-bottom*)
       (real-locate 0 *cur-bottom*)
       (display #\newline)  ;;;;  special!!!!
       (inc *real-bottom*)
       (inc *real-y*)
    )
    (insert-line *cur-y* )  ;;; +1 ???
    (copy-line-to-next)
    (scr-set  'newline)
    (scr-clean-line)
    (change-all)
)

(define (scr-clean-line)   ;;; make   newline  null ...
  (do ((j (+ *cur-x* 1) (+ j 1)) )
      ((>= j (- *max-xscr* 1))) 
      (matrix-set! *scr* *cur-y* j #\null)
  )
)

(define (change-all)
   (let* ((v *scr-change*) (mx (- *max-xscr* 1)))
     (do ((i *cur-y* (+ i 1)))
         ((> i *cur-bottom*))
         (do ((j 0 (+ j 1)))
             ((= j mx))
             (matrix-set! v i j #t)
         )
     )
))

(define (insert-line i)
    (if (= *cur-bottom* (- *max-yscr* 1)) (scr-resize 5))
    (down-matrix *scr* i *cur-bottom*)
    (down-matrix *scr-change* i *cur-bottom*)
    (real-locate 0 *cur-bottom*)
    (display #\newline)
    (inc *cur-bottom*)
    (set! *real-y* *cur-bottom*)
)

(define (copy-gyo mat dest source)
    (matrix-map-2 mat (lambda(x y) x) source dest)
)

(define (down-matrix mat i end)
    (matrix-rotate  mat 1 i (+ end 2))
    (copy-gyo  mat i (+ i 1))
)

(define (up-matrix mat i end)
  (matrix-rotate  mat -1 i (+ end 1))
  (clear-line mat end)
)

(define (clear-line mat i)
  ;;;(format #t "clear ~s~%" i)
  (do ((j 0(+ j 1))) 
      ((= j *max-xscr*))
      (matrix-set! mat i j #\null)
  )
)

(define (clear-1st-line)
  ;;;(format #t "clear ~s~%" i) 
  (do ((j 0(+ j 1))(c 0))
      ((= j *max-xscr*))
         (set! c (getch-loc j 0))
         (when (not (eq? c #f))
             (scr-set-loc j 0 #\null)
         )      
         (if (= j *begin-x*) (scr-set-loc j 0 'newline))
  )      
  (locate *begin-x* 0)
)


(define (copy-line-to-next)
  (let* ((v *scr*)(i  *cur-y*) (i+ (+ i 1)) (x 0) (prev 0))
      (do ((j *cur-x*(+ j 1) ) (k 0 (+ k 1)))
        ((= j *max-xscr*) 
             (while (< k *max-xscr*)
                  (matrix-set! v i+ k #\null)
                  (inc k)
             )
             (matrix-set! v i+ (- j 1) #t)
           )
        (set! prev x)
        (set! x (matrix-ref v i j ))
        (if (eq? x #t) 
            (if (or (eq? prev #\null)(eq? prev 'newline))
                 (set! x #\null)
                 (set! x 'newline)
            )
        )
        (matrix-set! v i+ k x)
     )
))
 
(define (copy-line-from-next)
  (let* ((v *scr*)(i  *cur-y*) (i+ (+ i 1)) (x 0) (prev 0))
      (do ((j *cur-x*(+ j 1) ) (k 0 (+ k 1)))
        ( (or (= j *max-xscr*) (eq? x 'newline))
            (if (eq? x 'newline) (dec  k ))
             k  ;;;;   return bytes (copied data  except newline)
           )
        (set! prev x)
        (set! x (getch-loc k i+  ))
        (scr-set-loc   j i  x)
     )
))

 

(define (reflesh)
   (let* ((v *scr-change*)(x 0) (locx *cur-x*)(locy *cur-y*))
      (do ((i 0(+ i 1)))
         ((> i *cur-bottom*))
         (set! *cur-y* i)
         (do ((j 0(+ j 1)))
             ((= j *max-xscr*))
             (set! *cur-x* j)
             (set! x (matrix-ref v i j))
             (when (not (eq? x #\null))
                (real-locate j i)
                (real-put (getch))
             )
         )
       )
   (real-locate locx locy) 
   (locate locx locy) 
   (clear-scr *scr-change*)
   (flush)
))    

(define (line-ed-str )
  (let* ((res (cons #t #t))(memo res) (x 0)(y 0))
     (do ((i 0 (+ i 1)))
         ((> i *cur-bottom*))
        (do ((j 0 (+ j 1)))
            ((>= j *max-xscr*))
            (set! x (getch-loc j i))
            (cond ((eq? x #f))
                  ((eq? x #t) (set! x #f))
                  ((eq? x 'newline)
                      (set! x #\newline)
                      (set! j *max-xscr*)
                     )
                  ((pair? x)
                      (set! y (car x))
                      (if (eq? y #\bell)
                             (set! x (cdr x))
                           (set! x y))
                      )
                  (else
                          )
            )
           ;;; (format #t "~s ~%" x)
            (when x
              (set-cdr! res (cons x ()))
              (set!  res (cdr res))
            )
       )            
     )
     ;;;(list->string (cdr memo))  ;;; string    list of char
      (cdr memo)  ;;;  list of char
))
#|
(define (print-scr)
      (let* ((res (cons #t #t))(memo res) (x 0)(y 0))
     (do ((i 0 (+ i 1)))
         ((> i *cur-bottom*))
            (format #t "~%" x)
        (do ((j 0 (+ j 1)))
            ((>= j *max-xscr*))
            (set! x (getch-loc j i))
            (format #t "~s " x)
       )
     )
))
|#

(define (tty-hotstart x)
  (let* ((c 0)(memo 0))
   (cur-begin)
   (real-locate *cur-x* *cur-y*)
   (hot-scr)
   (while (pair? x)
      (set! c (pop x))
      ;;;;(if (< (char->integer c) 32) (format #t "code-char ~s" c))
      (if (eq? c #\newline)
            ;;(scr-insert 'newline)
            (if (pair? x) (cur-down))
            (scr-insert-char c)
      )
   )
   (matrix-fill! *scr-change* #t)
   (set! memo *cur-bottom*)
   (set!  *cur-bottom* *real-bottom*)
   (reflesh)
   (set!  *cur-bottom* memo)
))

(load "keycontrol")                              

(define *uname* (car (string-split  (exec "uname"))))

(define  *term* (getenv "TERM")) 
(begin
   (cond ( (equal? *uname* "Darwin") (set! *term* "macxterm" ) )
         ( (equal? *term* "cygwin") )
         ( (equal? *term* "xterm") )
         (else (set! *term* "rxvt")  )   ;;;;default
   )
   (load *term*)                              
)

