;;;  For regexp  debug
;;;;
(in-package "regexp")

(define *nfa-function* #f)
(define *debug-depth* 0)

(define (init-R-debug)
   (set! *nfa-function* regexp-nfa)
)

(define (R-set-debug)
   (set! regexp-nfa debug-regexp-nfa)
   (set!  *debug-depth* 0)
)

(define (R-reset-debug)
   (set! regexp-nfa *nfa-function*)
)

(define  (debug-regexp-nfa  state )
 (let* ((trans  (Rstate state))(stack (list trans))(kstack '(()))
           (A 0) (op 0)(orgstate state) (new 0) )
  (while (and state (pair? stack))
     (set! trans (pop stack))
      (if (eq? trans 0) (R-debug 0 0 state)) ;;;; debug
     ;;;(format #t "nfa  trans ~s stack ~s ~%" trans  stack)
    (when (not (eq? trans 0))
         (set! new  (get-trans trans))
    (R-debug trans new state) ;;;; debug
         (set! trans  new)

       (when (not (eq? trans 0))
               (set! A (car trans))
             ;;; (format #t "main trans ~s   car  ~s ~%" trans A)
         (cond ( (symbol? A)
                   (set! state (regexp-nfa-atom trans state)))
               ( (number? A)
                   (push (cdr trans) stack)
                   (push A stack)
               )
       ;;; ((:or C D))  A=(:or C D)   etc.
           (else
              (set! op (car A))
              (cond ((eq? op :or)
                       (push (caddr A) stack)
                       (push-state state stack)
                       (push :or stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
           ;;;   (format #t "or state  ~s   stack  ~s ~%" state stack)
                       )
                    ((eq? op :forward)
                       (push-Rindex state stack)
                       (push op stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
                     )
                    (  (eq? op :not)
          ;;;;(or (eq? op :not)(eq? op :try))
                       (push-state state stack)
                       (push op stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
                     )
                    ((eq? op :if)
                        (set! kstack (nfa-if (cdr A) state stack kstack))
                        (set! stack (pop kstack))
                      )
                (else
                     (error 543 A)
                    ;;; (set! state  (regexp-nfa-pat A state))
                )
              )
           )
         )
      )
     )
   (R-debug-result state)
     (if state
          (when (and  (pair? stack) (eq? stack (car kstack)))
         ;;; (when (and  (pair? stack)(keyword? (car stack)))
             (set! kstack (key-true-stack state stack kstack))
             (set! state (pop kstack))
             (set! stack (pop kstack))
          )
          (begin
             (set! kstack (key-false-stack orgstate stack kstack))
             (set! state (pop kstack))
             (set! stack (pop kstack))
          )
     )
  )
 state
))


(define (R-debug s new state)
  (let* ((pos (Rindex state)) (gr (get-group state))
         (spos (get-start-pos state)) (str (state->string state)))
     (debug-indent)
     (format #t "~a State ~a->~a Pos(~s.~s) " str s new spos pos  )
     (debug-group)
     (newline)
))

(define (R-debug-result state)
     (debug-indent)
  (if (vector? state)
    (let* ((s (Rstate state)) (pos (Rindex state)) (gr (get-group state))
         (spos (get-start-pos state)) (str (state->string state)))
       (format #t "  ->~a Success~%" str)
    )
       (format #t "  ->  Fail~%")
  )
)
   
(define (debug-group)
    (let* ((s *group-num*)(res ())(x 0))
     (when (> s 0)
      (do ((i 1 (+ i 1))) 
          ((> i s))
           (set! x (match-string i))
           (if x 
               (push (cons i x) res)
           )
      )
       (when (pair? res)
           (set! res (reverse res))
           (display "Group ")
           (while (pair? res)
                (set! x (pop res))
               (format #t "~a:~a " (car x) (cdr x))
            )
       )
    )
))

(define (debug-indent)
  (when (> *debug-depth* 0)
   (do ((i 0 (+ i 1)))
       ((= i *debug-depth*))
       (display "    ")
   )
   (display "NFA ")
  )
)
