;;; 2004.3.27
;;;  make-match-data
;;;
;;; from data , make more simple dot-database

(in-package "macro")

(define *match-data-org* ())
(define *match-data* ())
(define *match-dot-data* ())

(define (make-match-data p f env)
  (let ((s (match p f env)))
    (set! *match-data-org* s)
    (set! *match-data* ())
    (set! *match-dot-data* ())
    (if (pair? s)
      (begin 
         (make-match-data-main s)
         (set! *match-dot-data* (tree-up *match-dot-data*))
         *match-dot-data*
      )
      #f
    )
   
))

(define  (make-match-data-main s)
  (if (pair? s)
    (let* ((top (car s)))
       (cond  
          ((symbol? top)
             (push s *match-data*))
          ((null? top) (make-match-data-main (cdr s)))
          ( (eq? (car top)  '...)
             (push (make-dot-env top (cdr s))  *match-dot-data*))
          (else
            (make-match-data-main top)
            (make-match-data-main (cdr s))
          )
       )
    )
))

(define (make-dot-env top args)
  (cons (cons 'dot... (modify-dot-pat top))    ;;;; make  (dot... (... b) ........)
    (map  make-env    args) )
)

(define (make-env  x)  ;;;   x is data for s
  (if (pair? x)
      (let* ((top (car x)))
       (cond
          ((symbol? top)
                x)
          ( (and (pair? top ) (eq? (car top)  '...))
             (make-dot-env top (cdr x)))
          (else
            (cons (make-env  (car x))
               (make-env (cdr x)))
          )
       )
      )
   ()
))

;;;  
(define (tree-up s)
  (if (pair? s)
     (let* ((top (car s)))
       (cond ((symbol? top)
               ;;(list  s)
               s
               )
          ( (and (pair? top) (eq? (car top)  'dot...))
             ;;;(cons (cons top (map tree-up (cdr s)))  ())    
             (cons top (map tree-up (cdr s))  )    
             )
          (else
            (if (null? (cdr s))
                (tree-up top)
                ;;(append (tree-up top) (tree-up (cdr s)))
                ;;;(cons  (tree-up top) (tree-up (cdr s)))
                (map tree-up s)
            )
          )
       )
      )
   ()
))

;;; from data , make more simple dot-database
;;;   (... P) ->((... (... b)) (... c)     ....)
(define (modify-dot-pat pat)
  (let ( (p pat) )
    (if (pair? pat)
       (begin
           (set! p (car pat))
           (if (eq?  p 'pat)
               (cdr pat)
                  (if (eq? p '...)
                      (map (lambda (x) (list '... x)) 
                                     (modify-dot-pat (cadr pat)))
                     (append (modify-dot-pat p) (modify-dot-pat (cdr pat)))
                  )
           )
       )
      ()
   )
)) 
      

#| test
  (define (test p f env) (make-match-data p f env)
       (format #t "data-org: ~s~%" *match-data-org*)
       (format #t "data: ~s~%" *match-data*)
       (format #t "dot-data: ~s~%" *match-dot-data*))

  (define p (pat-trans '(do ((var init step ...) ...)
         (test expr ...)
         command ...)   ()))

  (test p  '(do ((i 0 (+ i 1)) (j 5)) ( (= i 0)(write a )) h (yo s)) ())
  (test p  '(do ((i 0 (+ i 1)) (j 5) (k 7 (- k 1) foo)) ( (= i 0)(write a )) h (yo s)) ())

  (define (ttt )(dot-data-trans *match-dot-data*))

  (ttt)

  (define q  '((( b ...) (c ...)...)...))
  (define p (pat-trans q ()))
  (test p '((x 8 7 (s a)()(u)) (b c) (d (e)))  ())
 
  (ttt)

  (test p '(((x 8 7) (s a)(x )(u)) ((b)( )) ((d) (e)))  ())
  
  (test p '(((x 8 7) (s a)(x )(u)) (()( )) ((d) (e)))  ())

  (ttt)

 |#

        
