;;;;  s-stream.ss
;;;; 05.10.16 created
;;;;
;;;;  s-stream can be read as a stream for any S-expression.
;;;; 
(define *s-stream* ())
(define *right-mark* '(S-read-right))
(define *vector-right* '(S-read-vector-right))
(define *dot-mark* '(S-read-dot))

                                                                                    
;;;(define *eof-object* (integer->char -1))

(define (pair-null? x)
   (or (pair? x)(null? x))
)
;;;  read S 
(define (S-read )
   (if (null? *s-stream*)
                   *eof-object*
                 (S-check (pop *s-stream*))
             )
)

;;;;  request to read pair
(define (S-read-left)
      (if (null? *s-stream*)
                #f
           (let* ((x (pop *s-stream*)))
              (if (and (pair-null? x)    ;;;;;;  may be ()
                      (eq?   (S-check x) x))
                  (push-stream x)
                      #f
              )
            )
        )
)

;;;;  request  right-par
(define (S-read-right)
  ;;; (format #t "read-right ~s~%" *s-stream*)
   (if (null? *s-stream*)
                   #f
           (eq? (pop *s-stream*) *right-mark*)
    )
)

;;;;  request  dot

(define (S-read-dot)
  ;;;; (format #t "read-dot ~s~%" *s-stream*)
    (if (null? *s-stream*)
                   #f
         (if (eq? (car *s-stream*) *right-mark*)
                (begin
                   (push () *s-stream*) ;;; This needs!
 ;;;;  (format #t "read-dot true ~s~%" *s-stream*)
                    #t
                )
           (S-read-dot-aux)
        )
     )
 )

(define (S-read-dot-aux)
   (let* ((x (pop *s-stream*)) (res ()) (ans #f))
       (if  (eq? x *dot-mark*)
                 x  ;;; true
          (begin
              (while (and (pair? *s-stream*) (not (eq? x *right-mark*))
                     (not (eq? x *dot-mark*)))
                   (push x res)
                   (set! x (pop  *s-stream*))
              )
              (if  (eq? x *dot-mark*)
                 (begin
                   (set! x (pop  *s-stream*))
                   (push x res)
                   (set! ans #t)
                 )
                (begin
                   (push x  *s-stream*)    ;;;;  *right-mark*
                   (push () res)   ;;;; for reverse*
                   (set! ans #t)
                )
              )
             (push (reverse* res)  *s-stream*)
             ans
         )
    )
)) 

;;;;   request to read vector
(define (S-read-vector-left)
      (if (null? *s-stream*)
                #f
           (let* ((x (pop *s-stream*)))
              (if (vector? x)
                  (push-vector-stream x)
                      #f
              )
            )
        )
)

;;; request end of vector
(define (S-read-vector-right)
       (if (null? *s-stream*)
                   #f
           (eq? (pop *s-stream*) *vector-right*)
       )
)

;;;;  get stream stack
(define (S-read-get)
       *s-stream*
)

;;;;  set stream stack
(define (S-read-set stream)
       (set! *s-stream* stream)   ;;; for reset or Back-track
)

;;;;  init
(define (S-read-init  s)
       (set! *s-stream* (cons s ()))    ;;; for init by s-expression
)

(define (S-read-eof?)
       (null? *s-stream*)
)

;;;;   subroutines
(define (push-stream x)
  (let* ((res ())(memo x))
     (push *right-mark* *s-stream*)
     (while (pair? x)
        (push (pop x) res)
     )
    (if (null? x)
        (set! *s-stream* (append memo *s-stream*))
       (begin
           (push x *s-stream*)
           (push *dot-mark*  *s-stream*)
           (set! *s-stream* (append (reverse res) *s-stream*))
       )
   )
  #t
))

(define (push-vector-stream x)
  (let* ((z (vector->list x)))  
     (push *vector-right* *s-stream*)
     (set! *s-stream* (append z *s-stream*))
  #t
))

(define (S-check x)
  ;;; (format #t "S-check x ~s~%" x)
  (if (pair? x) 
     (if (or (eq? x *right-mark*)(eq? x *dot-mark*)
           (eq? x *vector-right*))
          *eof-object*   ;;;; illegal request!!! for S-read
                         ;;;  can not use #f because, #f may be true object
        x
      )
    x
  )
)


