;;;
;;; Min count
;;;    optimize
;;;
(in-package "regexp")

(define *fail-exp* (list *fail*))
(define *for-cnt* 0)
(define *back-cnt* 0)

(define (R-mincount  exp)
   (set! *for-cnt* #f)
   (set! *back-cnt* #f)
   (cons (R-minct exp) (R-check-top exp))
)

(define (R-minct exp)
  (let* ((n 0)(m 0)(for #f))
   (if (pair? exp)
      (begin
         (set! n (R-minct-pat (car exp)))
         (when *for-cnt* 
              (set! for *for-cnt*)
              (set! *for-cnt* #f)
         )
         (set! m (R-minct (cdr exp)))
        (if for
           (max for m)
           (+ n m)
       )
      )
    0
   )
))
                                                                                               
(define (R-minct-pat  pat)
  (let* ((top (pop pat)))
     (cond ((keyword? top) (R-minct-key top  pat))
           ((eq? top 'string) (length  pat))
           ((eq? top 'pure-string) (string-length  (car pat)))
          ;;;; ((eq? top 'nfa-ref) 0)  ;;;; may be change so 0
           (else 0)
      )
))

(define (R-minct-key top  pat)
  (let* ((n 0)(m 0))
     (cond ((eq? top :or)
               (set! n (R-minct  (car pat)))
                (set! m (R-minct  (cadr pat)))
                (min n m)
            )
          ((eq? top :back)
               ;;;(R-count   (car pat))    ???
              0)
          ((eq? top :?)
                0)
          ((or (eq? top :+) (eq? top :+?)(eq? top :++) (eq? top :atomic))
            ;;;(format #t "minct-key top ~s cat pa ~s~%" top (car pat))
               (R-minct (car pat))
                )
           ((eq? top :forward)
               (set! *for-cnt* (R-minct (car pat)))
               0
             )
           ((eq? top :range)
                (set! n (car (pop pat)))
                (set! m (R-minct   (car pat)))
                (* n m)
             )
          ( (eq? top :begin)
              (R-minct   pat))
          ((eq? top :if)
               (if (equal? (cadr pat) *fail-exp*)
                    (set! n #f)
                    (set! n  (R-minct (cadr pat)))
               )
              (set! pat (cddr pat))
              (if (pair? pat)
                   (if (equal? (car pat) *fail-exp*)
                        (if n n 0)
                        (if n
                            (min n  (R-minct (car pat)))
                            (R-minct (car pat))
                        )
                   )
                   0   ;;;;  may be skip
               )
            )
          (else  ;;;;  :not allowes FAIL so min=0
           ;;;; (format #t "minct-key Not supported ~s ~s~%" top pat)
             0
          )
    )
))
;;;; check /g, /G,^,\A
(define (R-check-top exp)
   (let* ((top 0)(op 0))
      (if (pair? exp)
         (begin
            (set! top  (car exp)) 
            (if (pair? top)
               (begin
                  (set! op (car top))
                  (cond ((or (eq? op 'g-pos) (eq? op 'G-pos) ) op)
                        ((eq? op 'r-pos)
                              (set! op (cadr top))
                            (if (or (eq? op 'top)(eq? op 'abs-top)(eq? op 'end )(eq? op 'abs-end))
                                    op
                                    #f
                            )
                         )
                        (else #f)
                   )
                )
                #f
            )
          )
         #f
     )
))

;;;; check $, \z  in the last exp
(define (R-check-end exp)
   (let* ((top 0)(op 0))
      (if (pair? exp)
         (begin
            (set! top  (car (reverse exp)))
            (if (pair? top)
               (begin
                  (set! op (car top))
                  (cond ;;;((or (eq? op 'g-pos) (eq? op 'G-pos) ) op)
                        ((eq? op 'r-pos)
                              (set! op (cadr top))
                            (if (or (eq? op 'end )(eq? op 'abs-end))
                                    op
                                    #f
                            )
                         )
                        (else #f)
                   )
                )
                #f
            )
          )
         #f
     )
))
;;;;   check pure-string
(define (R-check-str  exp)
   (if (pair? exp)
         (R-check-str-main  exp)
         #f
   )
)

(define (R-check-str-main  exp)
  (let* ((pat (car exp)) (n 0))
     (while (and (pair? exp)  (begin (set! n (R-count-pat pat)) n) (eq? n 0))
        (set! pat (pop exp))
     )
    (if n
       (cond ((eq? (car pat) 'pure-string) (cadr pat))
             ((eq? (car pat) :forward)
                   (R-check-str (cadr pat))
             )
             (else  #f)
       )
       #f
   )
))


