(define-syntax or
   (syntax-rules ()
     ((or) #f)
     ((or x) x)
     ((or x y ...)
       (let* ((temp x))
         (if temp
              temp
              (or y ...)
         ))
     )
   ))

(define-syntax cond
  (syntax-rules (else)
    ((cond) #f)
    ((cond (else y ...)) (begin y ...))
    ((cond (test y ...)) (if test (begin y ...)))
    ((cond (test y ...) clause ...)
       (if test (begin y ...)
            (cond clause ...)
        )
      )
))

(define-syntax plus
  (syntax-rules ()
    ((plus x ...) (+ x ...))
  )
)

