;;;  2010.7.2
;;;
(define *key-macro* #f)    ;;;;  macro for key.   see psyntax.ss
(define macro-key  '(:macro))    ;;; for macro-alias

(define (syntax-alias s)
  (let* ((a (assq s *alias-name*)))
     (if a 
         (cdr a)     ;;;; r already registered!
        (begin
          (if (symbol-bind? s)
            (if (special? (symbol-value s)) 
                  ;;;(symbol-value s)
                  (special-alias s)
               (begin
                 (set! a (gensym))
                 (set! *alias-name* (cons (cons s a) *alias-name*))
                 (push  (cons a (symbol-value s)) *macro-env*) 
                 a
               )
            )
          (begin
             (set! a (gensym))
             (set! *alias-name* (cons (cons s a) *alias-name*))
             a
          )
        )
     )
   )
))

(define (template-exec form)
   (dot-env)
   (init-read-env)
   (get-true-value (template-do form 0))
)

;;;  env is of the syntax-rules
(define (template-trans  form )
      (cond ((symbol? form)
                 (template-symbol-change form ))
           ((pair? form)
                 (template-list-change form ))
           (else form)
       )
)

(define   (template-symbol-change form )
  (let* ((x 0))
             (set! x (assq form *vars*))
             (if x 
                  (list patvar form) 
                 (cond   ((eq? form *macro-key*) macro-key) ;;;New!!
                       ((assq form  *literal*)
                              form)
                       (else
                           (if (assq form *local-env*)
                                 (syntax-alias form)
                                 form
                           )
                        )
                 )
             )  
))


(define   (template-list-change form )
  (let* ((P (car form)) (Q (cdr form)))
     (cond 
          ((and (pair? Q) (eq? (car Q ) '...))
              (set! P (list dot (template-trans P )))
              (cons P (template-trans (cdr Q) ))
              )
          ((eq? P '...)  ;;;  (... A) means A
              (car Q))     
          (else
            (cons (template-trans P )(template-trans Q ))
          )
    )
))
;;;;;;

(define-macro (true-value f)
  `(cons patvar ,f)
)
(define (get-true-value f)
   (if (and (pair? f) (eq? (car f) patvar))
       (cdr f)
        f
   )
)

(define (template-do form level)
   (let* ((x 0))
      (if (pair? form)
          (if (eq? form macro-key)
              *macro-key*
              (template-list form  level)
          )
          ;;;;  form may be #f!!!
         (true-value  form)
      )
))

(define (template-list form level)
  (let* ((x #t)(y #t)(P (car form)) (Q (cdr form))(res ()))
    (if (and (pair?   P) (eq? (car P) dot))
        (begin
           (inc level)
           (while x
             (set! x (template-do (cadr P)  level))
             (when x 
                (push (get-true-value x) res)
                (set! x  (read-env-next level))
             )
           )
           (dec level)
           (set! x  (template-do Q level))
           (if (= level 0) (read-env-clear))
           (if x
              (append (reverse res) (get-true-value x))
               #f
           )
        )
       (if (eq? P patvar)
          (begin
             (set! x (read-env (car Q)))
             (if x (true-value (cadr x)) #f)
           )
          (if (pair? P)
             (begin
                (set! x  (template-do P level))   ;;;  may be #f if ...
                (if x
                   (begin 
                      (set! y  (template-do Q level))
                      (if (or y (not (pair? Q)))
                         (cons (get-true-value x) (get-true-value y)) 
                       #f)
                   )
                   #f   ;;; (template-do Q level)
                )
             )
             (begin
                      (set! y  (template-do Q level))
                  (if (or y (not (pair? Q)))
                    (begin
                      (set! x  (get-true-value (template-do P level) ))
                      (cons x  (get-true-value y))
                    )
                    #f
                  )
             )
          )
       )
    ) 
))
