;;;  2010.7.2
;;; 2010.7.23
;;;2010.8.10

(define *syntax-loads* ())   ;;; for syntax-load  (alias var key)

(define (template-exec form)
   (dot-env)
   (init-read-env)
   (set! form (get-true-value (template-do form 0)))
   (if (null? *syntax-loads*)
         form
      (begin
         (if *local-syntax*
           ;;;;(list 'let-syntax-environment *syntax-loads* form)
            form
           (begin
             (set! form (list 'syntax-environment *syntax-loads* form))
             (set! *syntax-loads* ())
             form
           )
         )
      )
   )
)

;;;;;;

(define-macro (true-value f)
  `(cons patvar ,f)
)
(define (get-true-value f)
   (if (and (pair? f) (eq? (car f) patvar))
       (cdr f)
        f
   )
)

(define (template-do form level)
   (let* ((x 0))
      (if (pair? form)
          (if (eq? form macro-key)
              *macro-key*
              (template-list form  level)
          )
          ;;;;  form may be #f!!!
        (if (syntax-obj? form)
              (template-syntax form  level)
              (true-value  form)
        )
      )
))

(define (template-list-dot P Q level)
   (let* ((x #t) (res ()))
         (inc level)
           (while x
             (set! x (template-do (cadr P)  level))
             (when x
                (push (get-true-value x) res)
                (set! x  (read-env-next level))
             )
           )
           (dec level)
           (set! x  (template-do Q level))
           (if (= level 0) (read-env-clear))
           (if x
              (append (reverse res) (get-true-value x))
               #f
           )
))

(define (template-list-local  Q level)
  (if (eq? (caddr Q) (assq (car Q) *local-env*))
          (car Q)
      (begin
         ;;;(push (list (cadr Q) (car Q) (caddr Q))  *syntax-loads* );;; incomplete
         (cadr Q)
       )
  )
)

(define (template-list-freev  Q level)
      (cadr Q)   ;;;; always alias
)
(define (template-list-bound  Q level)
  (if (assq (car Q) *local-env*)
      (begin
         (push (list (cadr Q) (car Q) *macro-key*)  *syntax-loads* )
         (push (cons (car Q) (caddr Q)) *macro-env*) 
         (format #t "template-exec list-bond: macro-env  ~s~%" *macro-env*)
         (cadr Q)
      )
      (car Q)
  )
)

(define (template-list-macro  Q level)   ;;;; mada
    (if (assq (car Q) *local-env*)
           (begin
             ;;;(push (list (cadr Q) (car Q) (car Q))  *syntax-loads* )
             (cadr Q)
            ;;; (cdr (caddr  Q))
           )
         (car Q)
    )
)

(define (template-list-pairP P Q level)
   (let* ((x 0)(y 0)) 
       (set! x  (template-do P level))   ;;;  may be #f if ...
       (if x
           (begin
               (set! y  (template-do Q level))
               (if (or y (not (pair? Q)))
                    (cons (get-true-value x) (get-true-value y))
                #f)
           )
                   #f   ;;; (template-do Q level)
      )
))

(define (template-list form level)
  (let* ((x #t)(y #t)(P (car form)) (Q (cdr form))(res ()))
    (if (and (pair?   P) (eq? (car P) dot))
           (template-list-dot P Q level)
       (cond ( (eq? P patvar)
             (set! x (read-env (car Q)))
             (if x (true-value (cadr x)) #f)
               )
          ( (pair? P)
                (template-list-pairP P Q level))
           (else
                      (set! y  (template-do Q level))
                  (if (or y (not (pair? Q)))
                    (begin
                      (set! x  (get-true-value (template-do P level) ))
                      (cons x  (get-true-value y))
                    )
                    #f
                  )
          )
       )
    )
) )

(define (template-syntax form level)
  (let* ((x #t)(y #t)(P (syntax-car form)) (Q (syntax-cdr form))(res ()))
     (cond   ( (eq? P *local*)
                     (template-list-local  Q level))
             ( (eq? P *freev*)
                     (template-list-freev  Q level))
             ( (eq? P *bound*)
                     (template-list-bound  Q level))
             ( (eq? P *macro*)   ;;;; mada
                     (template-list-macro  Q level)   ;;;; mada
                   )
             (else  (error E_illegal form))
      )
))

