;;;  2010.7.2
;;; 2010.7.23
;;;  2010.8.10  template2.ss
;;;  2010.8.15  macro-key   deleted
(in-package "macro")
(define *macro-key* #f)    ;;;;  macro for key.   see psyntax.ss
;;;;(define macro-key  '(:macro))    ;;; for macro-alias
(define *local*  '(:local))    ;;; for local var
(define *macro*  '(:syntax))    ;;; for syntax-macro
(define *freev*  '(:freev))    ;;; for free var
(define *bound*  '(:bound))    ;;; for free var && bound var
(define *syntax-loads* ())   ;;; for syntax-load  (alias var key)


(define syntax-transformer? 
   syntax-lambda? 
)

(define (syntax-alias s)
  (let* ((a (assq s *alias-name*))(b 0))
     (if a 
         (cdr a)     ;;;; s already registered!
        (begin
          (set! b (assq s *macro-env*))
          (set! a (assq s *local-env*))
          (if (and a  (eq? a b))
             (begin
                (set! a (cdr a))
                (cond ((special? a )(special-alias s))
                      ((macro? a)   ;;; incomplete, for classic-macro
                                    ;;;  to be symbol as alias name!!!
                          ;;;(alias-name s)  
                           (push (cons s a) *alias-name*)
                           a    
                          )
                      (else  s )   ;;;(alias-name s)
                )
              ) 
            (syntax-alias-aux s)
          )
        )
      )
))
(define  (syntax-alias-aux s)   ;;;; not local-env or local-env != macro-env
  (let* ((a ())(v 0))
       (if (symbol-bind? s)
          (begin
            (set! v (symbol-value s))
            (if (special? v) 
                  ;;;(symbol-value s)
                  (special-alias s)
               (if (or (classic-macro? v)(syntax-lambda? v))
                    v
                (begin
                   (set! a (alias-name s))
                   ;;;;(push  (cons a (symbol-value s)) *macro-env*) 
                   a
                )
               )
            )
          )
          (begin
             (alias-name s )
          )
        )
))

(define  (alias-name s )
   (let* ((x (gensym)))
         (set! *alias-name* (cons (cons s x) *alias-name*))
    x
 ))    

;;;  env is of the syntax-rules
(define (template-trans  form )
    (template-trans-do form)
)

(define (template-trans-do  form )
     ;;; (format #t "template-trans:local-env ~s~%" *local-env*)
      (cond ((symbol? form)
                 (template-symbol-change form ))
           ((pair? form)
              ;;(if (and (eq? (car form) 'quote) (not (assq form *macro-env*)))
              ;;   form 
                 (template-list-change form )
              ;;; )
            )
           (else form)
       )
)

(define   (template-symbol-change form )
  (let* ((x 0)(a 0))
             (set! x (assq form *vars*))
             (if x 
                  (list patvar form) 
               (begin
                  ;;(format #t "template-symbol-change macro-env:~s~%" *macro-env*)
                  (set! x (assq form *macro-env*))
                  (cond  ;;; ((eq? form *macro-key*) macro-key) ;;;New!!
                          ((member form  *literal*)  ;;;literal check is
                                                     ;;; done in pat-match
                              form)
                          (x  
                              (set! a (syntax-alias form))
                              (if (syntax-lambda? (cdr x))
                                 (->syntax (
                                    list *macro* form  (cdr x)))
                                 (->syntax (list *local* form a x))
                              )
                           )
                          (else
                              (template-symbol-change-aux form )
                          )
                 )
               )
             )  
))

(define (template-symbol-change-aux form )
   (let* ((x (macro? form)) (v 0) )
     ;;; (format #t "local-env ~s~% macro-env ~s~%" *local-env* *macro-env*)
       
       (if  x
             (->syntax (list *macro* form  x))
            (if (special? form)
                 (special-alias form)
                 ;;;form
              (begin
               (set! x (syntax-alias form))
               (if (symbol-bind? form)
                 (begin
                     (set! v (symbol-value form))
                    ;;;; (push (cons form v) *bind-env*)
                     (->syntax (list *bound* form  x v))
                 )
                  (->syntax (list *freev* form  x ))
               )
              )
            )
        )
))


(define   (template-list-change form )
  (let* ((P (car form)) (Q (cdr form)))
     (cond 
          ((and (pair? Q) (eq? (car Q ) '...))
              (set! P (list dot (template-trans-do P )))
              (cons P (template-trans-do (cdr Q) ))
              )
          ((eq? P '...)  ;;;  (... A) means A
              form)   ;;;;  change A  at the last    
          (else
            (cons (template-trans-do P )(template-trans-do Q ))
          )
    )
))
