;;;;   chk syntax-case
;;;;
(syntax-case '(test (+ 2 3)) () ((_ x)(syntax x))) 
;;;     (+ 2 3)

(define g (lambda(x)
       (syntax-case x ()
        ((_) (syntax #f))
        ((_ x) (syntax x))
        ((_ x y ...) (syntax (letrec ((t x)) (if t t (or y ...)))))
      )
  )
)

(g '(or x t))    ;;;; OK!
;;; but
(define x #f)
(define t 999)
(g '(or x t))  ;;;  OK!

;;;
(define h (lambda(x)
       (syntax-case x ()
           ((_ x ...) (syntax (begin (do (test x) (print x)) ... )))
        )
))

(h '(or u x z))
    ;;;; Not work!
;;;;
(define-syntax  unless
   (syntax-rules ()
      ((_ cond x ...) (when (not cond) x ...))
   )
)

(f '(let* ((when 0)(not 999)) (unless when  h not))())  

(s '(let* ((when 0)(not 999)) (unless when  h not)))  

(s '(lambda(h) (let* ((when 0)(not 999)) (unless when  h not))))  
;;;
(let-syntax ((when (syntax-rules ()
                      ((when test stmt1 stmt2 ...)
                        (if test (begin stmt1 stmt2 ...))))))
   (let* ((if #t))
     (when if (set! if 'now))
     if))
;;;;   now

;;;   let   ----  mada
(let* ((x 'outer))
  (let-syntax ((m (syntax-rules () ((m) x))))
     (let* ((x 'inner))
        (m))))
;;;;  outer

(let* ()
  (let-syntax 
      ((def (syntax-rules ()
                ((def stuff ...) (define stuff ...)))))
       (def foo  42))
     foo)
;;;;  No good!   ss2.0 unrecognize define  in let*-block
;;;;  OK  vm_comp.c を修正。
;;;;    42

(let* ()
   (let-syntax ())
   5)
;;;  OK
(define-macro (setf  .  x)
  (syntax-case  x ()
     (((s v) val)  (eq? (syntax s)  'car)  (syntax (set-car! v  val)))
     (((s v) val)  (eq? (syntax s)  'cdr)  (syntax (set-cdr! v  val)))
     (((s x i) val) (eq? (syntax s) 'vector-ref )  (syntax (vector-set! x i val)))
  )
)
;;;P.186
(let* ((f (lambda(x) (+ x 1))))
  (let-syntax ((f (syntax-rules ()
                      ((_ x) x)))
               (g (syntax-rules ()
                      ((_ x) (f x)))))
          (list (f 1)(g 1)))
)
;;;  (1 2)
(let* ((f (lambda(x) (+ x 1))))
  (letrec-syntax ((f (syntax-rules ()
                      ((_ x) x)))
               (g (syntax-rules ()
                      ((_ x) (f x)))))
          (list (f 1)(g 1)))
)
;;;; (1 1)
(let* ((f (lambda(x) (+ x 1))))
  (let-syntax ((g (syntax-rules ()
                      ((_ x) (f x)))))
    (let-syntax ((f (syntax-rules ()
                      ((_ x) x))))
          (g 1))
))
;;; 2
(let* ((f (lambda(x) (+ x 1))))
  (let-syntax ((g (syntax-rules ()
                      ((_ x) (f x)))))
    (fluid-let-syntax ((f (syntax-rules ()
                      ((_ x) x))))
          (g 1))
))
;;;1
;; P.193
(let* ((p (cons 0 #f)))
   (define-syntax pcar
     (lambda (x)
       (syntax-case x ()
         (_ (identifier? x) (syntax (car p)))
         ((_ v) (syntax (set-car! p v))))))
   (let ((a pcar))
      (pcar 1)
      (list a pcar)))
;;;  (0 1)    dame

(let* ((p (cons 0 #f)))
   (let-syntax ((pcar
     (lambda (x)
       (syntax-case x ()
         (_ (identifier? x) (syntax (car p)))
         ((_ v) (syntax (set-car! p v)))))))
   (let ((a pcar))
      (pcar 1)
      (list a pcar)))
)
;;;  (0 1)  dame

