;;;  2010.7.3
;;;   read-env from dot-env
;;;
(define *read-env* ())
(define *read-hash* ())

(define (init-read-env)
   (let* ((x 0) (res ())(d 0)(vars *vars*)(data *dot-env*))
     (while (pair? vars)
       (set! x (pop vars))
       (if (> (cdr x) 0)
          (begin
            (set! d (env-find (car x) data))
            (set! d (choose-var d (car x) (cdr x)))
            (if (pair? d) (set! d (car d)))  ;;; at most ONE
            (push (cons (car x) d) res)
          )
       )
     )
   (set! *read-env* res)
   (set! *read-hash* (make-hash-table eq? (* 2 (length *vars*))))
   ;;(format #t "dot-env:~s~%~%" *dot-env*) 
   ;;(format #t "read-env:~s~%~%" *read-env*) 
))
(define (choose-var d  var level )
  (let* ((x 0)(res ()))
   (if (= level 1)
      (begin
        (while (pair? d)
           (set! x (car d))
           (set! x  (level-1 var x ))
           (if x
              (push x  res)
           )
          (set! d (cdr d))
        )
       (reverse res)
      )
     (begin
        (while (pair? d)
           (set! x (choose-var (car d) var (- level 1)))
           (if (pair? x) (push x res)) ;;; at most ONE occur! in top level
           (set! d (cdr d))
        )
       (reverse res)
    )
  )
))
(define (level-1 var x)
  (if (pair? x)
    (begin
      (set! x (map (lambda(y) (and (pair? y) (eq? (car y) var) y)) x))
      (set! x (remove #f x))
      (if (pair? x) x #f)
    )
   #f
  )
)

(define (env-find v data)
 (let* ((x 0))
   (if (pair? data)
      (begin
         (set! x (env-find-aux v (car data)))
         (if x 
            (car data)
            (env-find v (cdr data))
         )
      )
     ()
   )
))
(define (env-find-aux v data)
   (if (pair? data)
      (if (eq? v (car data))
             v
           (or (env-find-aux v (car data)) (env-find-aux  v (cdr data)))
      )
    #f
   )
)

(define (read-env-top v )
  (let* ((x 0))
    (set! x (assq v *top-env*))
       (if x
           x
           (error E_illegal v)
       )
))

(define (read-env v )
  (let* ((x 0)(d 0)(dlist ()) (level (cdr (assq v *vars*))))
   (if (= level 0)
      (read-env-top v )
     (begin
       (set! x (get-hash *read-hash* v))
       (when (not x)
           (init-set v level)
           (set! x (get-hash *read-hash* v))
       )
         (if (and (pair? x) (pair? (car x)))
             (begin
                (set! dlist (pop x))
                (set! d (pop dlist))
                (set! x (cons dlist x))
                (set-hash *read-hash* v x)
                d
                ;;; for empty
                (if (pair? (cdr d))
                   d
                   #f
                )
              )
              #f
         )
      )
   )
))
                  
(define (init-set v level)
    (let* ((d (cdr (assq v *read-env*))))
       (init-set-aux v level ()  d)
))

(define (init-set-aux  v level stack d)
  (let* ((x 0)(ans #f))
       (if (= level 1)
         (begin
          (set-hash *read-hash* v (cons d stack))
           d
         )
       (begin
         (set! stack (cons d stack))
         (if (pair? d)
           (begin
            (set! d (car d))  ;;; select the most left branch
            (set! ans d)
           )
          )
         (set! x( init-set-aux v (- level 1) stack d))
         (and ans d)         
       )
      )
))

(define (read-env-next-var v level)
   (let*  ((x 0)(k level) (stack ())(Level (cdr (assq v *vars*))))
     (if (> Level level)
      (begin
        (set! x (get-hash *read-hash* v))
        (while (> Level k) 
          (inc k)
          (set! x (cdr x))
        )
        (set! stack (cdr x))
        (set! x (car x))
        (if (pair? x) (set! x (cdr x)))  ;;; next!
        (init-set-aux v (- Level level -1) stack x)
      )
     (= level Level)    ;;;;  #f
    )
))   

(define (read-env-next level)
  (let* ((ans #f)(x 0))
   (map-hash (lambda (v val)
     (set! x  (read-env-next-var v level)) 
     (set! ans (or ans x)))  *read-hash* )
    ans
))

(define (read-env-clear)
   (clear-hash *read-hash*)
)
             

