;;; 2010.9.18
;;;   see P.99
;;;
(define-syntax let-values
  (syntax-rules ()
    ((_ ((form expr) ...) body1 body2 ...)
       (let ((all (list (values->list expr) ...)))
         (letvalues-vars (form ...) all 
            body1 body2 ...
         )
       )
    )))

(define-syntax letvalues-vars
  (syntax-rules ()
    ((_ () lis body ...) (begin body ...))
    ((_ ((v  ...) rest ...) lis body ...)
      (let* ((temp (car lis)) 
          ( v (pop temp)) ...) (set! lis (cdr lis) )
          (letvalues-vars (rest ...) lis body ...)
        )
      )
    ((_ ( v rest ...) lis body ...)
      (let* ((v (car lis)) )
           (set! lis (cdr lis) )
          (letvalues-vars (rest ...) lis body ...)
        )
       )
))

(define-syntax let*-values
  (syntax-rules ()
    ((_ () body ...) (begin body ...))
    ((_ ((form expr) rest  ...) body1 body2 ...)
       (let* ((temp (values->list expr)))
           (let*values-vars form temp
             (let*-values (rest ...) 
               body1 body2 ...
              )
           )
       ))
 ))

(define-syntax let*values-vars
  (syntax-rules ()
    ((_ (v  ...) lis body)
      (let*
          ((v (pop lis)) ... ) body
      ))
    ((_ v lis body)
     (let* ((v lis)) body))
))

