;;;;define libraly function
;;;;
(define (in-package  name)
  (let* ((new #f))
    (if (string? name)
           (begin
             (set! new (find-package name))
             (if (not new) (set! new (make-package name)))
            )
            (begin
              (set! new name)
              (set! name (package-name new))
            )
    )
   (set! sys:*package* new)
  (set! *prompt* (string-append name "> "))
  )
)


(define (fact n) 
    (if (= n 1) n
       (* n (fact (- n 1)))
    )
) 

#|   ---> map.c
(in-package "sys")
(define (map-car lists)
    (let* ((v (cons ()())) (res v))
      ;(format #t "-> map-car ~s" lists)
    (while (pair? lists)
       (set-cdr! res
          (cons (caar lists) ()))
       (set! res (cdr res))
       (set! lists (cdr lists))
    )
      ;(format #t "<- map-car ~s" (cdr v))
  (cdr v)
))

(define (map-cdr lists)
    (let* ((v (cons ()())) (res v))
    (while (pair? lists)
       (set-cdr! res
          (cons (cdar lists) ()))
       (set! res (cdr res))
       (set! lists (cdr lists))
    )
  (cdr v)
))

(in-package "ss")

(define (map  func .  lists)
  (let* ((v (cons ()())) (res v))
    (while (pair? (car lists))
       (set-cdr! res
          (cons (apply func  (sys:map-car lists))()))
       (set! res (cdr res))
       (set! lists (sys:map-cdr lists))
    )
  (cdr v)
))


(define (for-each  func .  lists)
    (while (pair? (car lists))
       (apply func  (sys:map-car lists))
       (set! lists (sys:map-cdr lists))
    )
)
|#

;;;;;;    apply can be traced by the following
;;;;; if you don't need ,   delete these
;;;;;     since some overhead exists.
#|
  (define sys-apply  apply)
  (define (trace-apply func . lists) (sys-apply  func  (sys-apply list* lists)))
|#
;;;;;;
(define (end-of-file? port)
  (and (char-ready? port)
       (eof-object? (peek-char port)) )
)
;;;;
;;;; use (exec-thunk read) or  (exec-thunk '(read))
(define-macro  (exec-thunk  thunk)
   `(if (procedure? ,thunk)
           (funcall ,thunk)
           (eval ,thunk )
    )
)
       
;;;;;;
(define (call-with-input-file file proc)
   (let ((port 0)(res 0))
     (set! port(open-input-file file))
     (set! res (funcall proc port))
     (close-input-port port)
     res
))

(define (call-with-output-file file proc)
   (let ((port 0)(res 0))
     (set! port(open-output-file file))
     (set! res (funcall proc port))
     (close-output-port port)
     res
))
 
(define (with-input-from-file file proc)
   (redirect proc file #f #f)
)
#|
(define (with-input-from-file file proc)
   (let ((port 0)(res 0))
     (set! port(open-input-file file))
     (stdio-push! 0 port)
     (set! res (exec-thunk proc))
     (close-input-port (stdio-pull! 0))
     res
))
|#

(define (with-output-to-file file proc)
   (redirect proc #f file  #f)
)

(define (call-with-input-str str proc)
   (let ((port 0)(res 0))
     (set! port(open-input-str str))
     (set! res (proc port))
     (close-input-port port)
     res
))

(define (call-with-output-str str proc)
   (let ((port 0)(res 0))
     (set! port(open-output-str str))
     (set! res (proc port))
     (close-output-port port)
))


#|   don't move why?  04.8.30   ---> syntax.ss
;;;;;;;  dynamic wind
(define (dynamic-wind before thunk after)
  (let ((res 0))
     (before)
     (set! *dynamic* before)
     (set! res (exec-thunk thunk))
     (set! *dynamic* ())
     (after)
     res
))
|# 
;;;;   timer
(define-macro  (timer  s)
  (let ((v (gensym)))
    `(let ((,v (times)))
        (eval ',s ())
        (- (times) ,v)
     )
)) 

;;;;;   exec  
(define (exec com)
   (let ((temp (make-temp-file)))
      (set! com (string-append com ">" temp))
      (system com)
      (set! com (file->string temp))
      (remove-file temp)
      com
))


#|
(define (copy-file file1 file2)
     (if (not (file-exists? file1)) (error E_open file1))
     (if  (file-exists? file2) (error E_open file2))
    (run-process "cp"  file1  file2 :wait)
)
|#
#|
(define (remove-file file)
    (run-process "rm" "-f"  file :wait)
)
|#

(define (file->string file)
  (call-with-input-file file port->string)
)

(define (port->string port)
   (call-with-output-str (make-string 64) (lambda(out) (copy-port port out)))
)
#|
(define (copy-port in out)
  (let ((x (read-char in)))
     (while (not (eof-object? x))
        (write-char x out)
        (set! x (read-char in))
     )
))
|#
(define (copy-port in out)
   (let ((x ()) (cont #t))
     (while  cont
        (if (char-ready? in)
             (begin
                (set! x (read-char in))
                (if (eof-object? x)
                    (set! cont #f)
                    (write-char x out)
                )
             )
             (update)
         )
     )
))


(define (do-read proc)
   (let ((x ()) (cont #t))
     (while  cont
        (if (char-ready?)
             (begin
                (set! x (read))
                (if  (eof-object? x)
                     (set! cont #f)
                      (proc x))
             )
             (update)
         )
     )
))

(define (do-read-line  proc)
   (let ((x ()) (cont #t))
     (while  cont
        (if (char-ready?)
             (begin
                (set! x (read-line))
                (if  (eof-object? x)
                     (set! cont #f)
                      (proc x))
             )
             (update)
         )
     )
))


;;;;;;;;;;;;;
#|
(define (getenv str)
  (let ((s 0))
    (set! s (exec (string-append "printenv " str)))
    (if (string=? s "") #f
        (remove-str #\newline s)
    )
))
|#

(define (remove-str char  s)
    (let ((res (string->list s)))
       (set! res (remove char res))
       (list->string res)
))

;;;;;;;
;;;;;;  depend on bits/stat.h
#|
(define (file-is-directory? file)
  (let ((s (file-stat file)))
     (if s
        (begin
           (set! s (car s))
            (= (logand s #o0170000) #o040000)
        )
       #f
     )
))

(define (file-is-regular? file)
  (let ((s (file-stat file)))
     (if s
        (begin
           (set! s (car s))
            (= (logand s #o0170000) #o0100000)
        )
       #f
     )
))
|#

(define (file-size  file)
  (let ((s (file-stat file)))
     (if s
        (cadr s)
        #f
     )
))

(define (file-time  file)
  (let ((s (file-stat file)))
     (if s
        (caddr s)
        #f
     )
))

(define (file-date  file)
  (let ((s (file-stat file)))
     (if s
        (cadddr s)
        #f
     )
))
#|
(define (file-is-executable? file)
  (let ((s (file-stat file)))
     (if s
        (begin
           (set! s (car s))
            (> (logand s #o111) 0)
        )
       #f
     )
))
|#
;;;;  04.5.1 revised
;;;
(define (string-split str . bag)
  (let*  ((res ()) (c 0)(n 0) (m 0) (end 0))
    (if (null? bag)
         (set! bag (list #\space #\tab #\newline))
         (set! bag (car bag))
    )
    (if (string? bag ) (set! bag (string->list bag)))
    (set! end (string-length str))
    (while (< n end)
       (set! c (string-ref str n))
       (when  (memq c bag) ;;;(or (eq? c #\space) (eq? c #\newline))
           (if (< m n)
             (set! res (cons (substring str m n) res))
           )
           (set! m (+ n 1))
       )
      (set! n (+ n 1))
    )
   (if (< m end)
     (set! res (cons (substring str m end) res))
   )
   (reverse res))
)
(define split-string string-split)

;;;  (string-split  "/usr/local/env" '(#\/))
;;;  (string-split  "sato foo piyo   what" )

#|   ---> syntax.ss
;;;;  catch-error
;;;; proc ϰʤ
;;;  error-procϣδؿǤ롣
;;;;  ͤϡprocޤerror-procε

(define (catch-error proc error-proc)
   (let ((c (cons ()()))(ex 0)(memo *errorhook*))
       (set!  ex (call/cc (lambda(p) p)))
       (if (eq? ex c)
           (begin
            (format #t "error caught!~%")
            (set! c (error-proc (car c)(cdr c)))
            (format #t "error caught returns ~s~%" c)
           )
           (begin
              (set! *errorhook* 
                  (lambda (enum p) (set-car! c enum)(set-cdr! c p) (ex c)))
              (set! c (exec-thunk proc))
           )
       )
      (set! *errorhook* memo)
    c
))
;;;;  STk catch
(define-macro  (catch . forms)
  `(catch-error (lambda () ,@forms #f) (lambda(e p) #t))
)

|#

;;; example
;;; (catch-error (lambda() (write foo)) (lambda (enum p) (print-error  enum p)))

;;;;   tcl error , returns top level immediately!
;;;  OK! the below  does same thing system default
;;;;   
; (set! *errorhook* (lambda (e obj) 
;           (if (eq? e 255)        ;;;E_tcl
;                     (print-error e obj 10)
;                     (system-error e obj)
;           )
;         )
; )

;;;;  macro-expand ->traceable  , if you need
;(define sys-macro-expand macro-expand)
;(define macro-expand
;     (lambda (x) (catch-error (lambda() (sys-macro-expand x))
;                    (lambda (enum p env)(print-error enum p))))
;)

;;;;
;;;  glob
;;;;    turbo linux     system   glob command exists
;;;;     but
;;;;;    Redhat     not exist
#|
(define  glob
   (if (equal? "" (exec "glob *"))
          #f     ;;;;   then use tk:glob  see tkinit.ss
          #t    
   )
)

(if   glob
  (define (glob . patterns)
    (let ((s ""))
      (while (pair? patterns)
       (set! s (string-append s (car patterns) " "))
       (set! patterns (cdr patterns))
      )
   ;(sort
      (string-split (exec (string-append "glob " s)))
    ;  string<?
    ;)
   ))
)
|#

;;;;  Not only Tk
(define (tk-name . args)
    (string->symbol (apply tk-string args)))

(define (tk-string . args)
   (do ((s "") (x ()))
        ( (null? args) s)
      (set! x (pop args))
      (cond ((string? x ))
            ((symbol? x) (set! x (symbol->string x)))
            ((keyword? x) (set! x (keyword->string x)))
            ((number? x)(set! x (number->string x)))
            ((char? x)(set! x (string x)))
            (#t)
      )
     (set! s (string-append s x))
    )
 )

(define (man x)
  (system (tk-string "man " x))
)

(define (call-with-values vproc cproc)
   (apply cproc (values->list (vproc)))
)

;;;;;   logical function
(define (lowest-bit x)
  (logand x (logxor x (- x 1)))
)

(define (highest-bit x)
  (if (eqv?  x 0)
      x
     (if (positive? x)
         (ash 1 (- (integer-length x) 1))
         (highest-bit (lognot x))
    )
  )
)

#|
(shadowing-intern "load" "alias")

(define (load file)
    (alias:load file)
    (set! *prompt* (string-append (package-name sys:*package*)  "> "))
)
|#

(define (list-procedure  . pack)
  (if (null? pack)
         (list-procedure sys:*package*)
       ;;;(list-all-symbol procedure? )
     (let* ((res ()) (p 0))
       (while (pair? pack)
         (set! p (car pack)) 
         (if (string? p) (set! p (find-package p))) 
         (set! res (append res(list-package-symbol p procedure?  )))
         (set! pack (cdr pack))
       )
      res
     )
  )
)

(define (list-all-symbol . selfn)
  (let* ((allp (list-all-packages)) (al ())(pack 0)(func 0)  )
    (if (pair? selfn) 
        (set! selfn (car selfn))
        (set! selfn (lambda(x) #t))
    )
    (while (pair? allp)
       (set! pack (car allp))
       (set! func (lambda(x) (if (external? x pack) #f (funcall selfn x))))
       (set! al (append al (list-package-symbol pack  func) ))
       (set! allp (cdr allp))
     )
    al
))

(define (list-package-symbol . pack-selfn )
  (let* ((res ()) (pack 0)(fn ()))
    (if (null? pack-selfn)
         (set! pack sys:*package*)
         (begin
           (set! pack (car pack-selfn))
           (if (pair? (cdr pack-selfn)) (set! fn (cadr pack-selfn)))
         )
    )
    (map-package (lambda(x) (if (null? fn) (push x res)
                                (if (funcall fn  x) (push x res))))
                          pack)
    res
))


(define (list-tk-procedure)
  (list-all-symbol tk-procedure?)
)

(define (find-all-symbols s)
  (let* ((allp (list-all-packages)) (res ())(x 0) )
    (if (symbol? s) (set! s (symbol->string s))) 
    (while (pair? allp)
       (set! x (find-symbol s (car allp)))
       (if x 
          (if (not (memq x res)) (push x res)))
       (set! allp (cdr allp))
     )
    res
))
  
(define (list-export-symbol . pack)
  (if (null? pack)
        (set! pack  sys:*package*)
        (set! pack (car pack))
  )
  (list-package-symbol pack (lambda(x) (export? x pack)) )
)

;;;;
;;;  history
(define ( his . n)
 (let* ((temp 0)(mx (vector-length *line-history*)))
  (if (pair? n) (set! n (car n)))
  (if (or (not (number? n)) (>= n mx))
      (set! n (his-aux mx))
   )
     (set! temp (open-input-str (vector-ref *line-history* n) ))
     (set! n (load temp)) 
     (close-port temp)
     n
))

(define (his-aux mx)
   (do ((i 1(+ i 1)))       
       ((= i mx))
       (format #t "~s: ~a~%" i  (vector-ref *line-history* i))
   )
   (display "number? ")
   (flush)
   (read)
)
;;;
#|
(define (last-pair s)
  (cond ((null? s) s)
        ((null? (cdr s)) s)
        (else (last-pair (cdr s)))
   )
)
|#
;;;
(define (pwd)
    *PWD*
)
;;; signal 
(define SIGTERM 15)
(define SIGKILL  9)
(define SIGHUP   1)
(define SIGINT   2)
(define SIGQUIT  3)
(define SIGTRAP  5)


