;;; 2004.11.16
;;; module  system
;;; 2005.3.21  revised  complete
;;;  chdir is no good for ssweb
;;;  But chdir needs for load in a Directory.
;;;      require may be exec some program in other place 
;;;      However this problem is solved by use of *STARTDIR*
;;;      in the application!
;;;      In general, such an application must be   require some modules
;;;      and then  (chdir *STARTDIR*)   and  start a program.
;;;   So module should not include (start)!
;;;   Then require preserve the STARTDIR.

(in-package "module")
(define sys:*modules* ())
(define *module-verbose* #f)

(define (provide module)
   (if (symbol? module)(set! module (symbol->string module)))
   (set! sys:*modules* (cons (cons  module *PWD*) sys:*modules*))
 )

(define (remove-module module)
  (let* ((x 0))
   (if (symbol? module)(set! module (symbol->string module)))
   (set! x (assoc module sys:*modules*))
   (if x (set! sys:*modules* (remove x sys:*modules*))) 
 ))

(define (module-dir  module)
  (let* ((x 0))
   (if (symbol? module)(set! module (symbol->string module)))
   (set! x (assoc module sys:*modules*))
   (if x (cdr x) #f)
 ))

(define (require module . sdir)
   (if (symbol? module)(set! module (symbol->string module)))
  (if *module-verbose*
         (format #t "require ~s ~s~%" module sdir)
  )
  (if (not (assoc module sys:*modules*))
    (let* ((cwd (pwd)) (verb (load-verbose))(dir cwd))
       (if *module-verbose*
            (load-verbose #t #t #t)   ;;;;!!!
            (load-verbose #f #f #f)   
       )
        (if (pair? sdir) (set! sdir (car sdir)) (set! sdir "./"))
       ;;; (if (get-module module "./")
       ;;;      #t
            (require-aux module (cons sdir *auto-path*)  verb)
       ;;; )
       (apply load-verbose verb)
       (set! dir *PWD*)
       (set! sys:*modules* (cons (cons  module dir) sys:*modules*))
      (chdir cwd)
      dir
    )
  )
)

(define (require-aux module path verb)
  (if *module-verbose*
         (format #t "reauire-aux ~s ~s~%" module path)
  )
   (if (pair? path)
         (if (get-module module (car path))
              #t
             (require-aux module (cdr path) verb)
         )
     (begin
       (apply load-verbose verb)
       (error E_open module)
     )
   )
)

(define (get-module m dir)
  (if *module-verbose*
      (format #t "get-module  ~s ~s~%" m dir)
  )
  (let* ((f (string-append dir m)) (dirs 0)) 
     (chdir dir)
     (if (load-ss f)
             dir
        (begin
          (set! dirs (glob-dir (string-append f "*") (string-append dir (string-upcase m) "*")))
          (if (pair? dirs)
             (begin
              (chdir  (car (reverse dirs)) )
              ;;;(load-ss (string-append (car (reverse dirs)) "/" m))
                (load-ss  m)  
              )
               #f
          )
        ) 
     )
))

(define (load-ss f)
  (let* ((ss (string-append f ".sr")))
      (if *module-verbose*
           (format #t "load-ss  ~s ~s ~s~%" f ss *PWD*)
      )
    (if
       (file-exists? ss) 
          (begin
                (if *module-verbose*
                  (format #t "exists  sr  ~s ~s ~s~%" f ss *PWD*)
                )
             (load ss) 
          )
       (begin
           (set! ss (string-append f ".ss"))
           (if (file-exists? ss) (load ss) #f)
       )
    )
))


(export '(require provide remove-module module-dir))

(use-package "module" "ss")


