;;;;  vector shuffle
;;;

(define (shuffle-vector v)
   (shuffle-vector! (vector-copy  v))
)
  
(define (shuffle-vector! v)
  (let* ((n (vector-length v))(k 0)(z 0))
     (while (> n 1)
        (set! k  (random n) )
        (set! z (vector-ref v k))
       (dec n)
       (vector-set! v k (vector-ref v n))
       (vector-set! v n z)
     )
    (shuffle-vector-rev! v)
))

(define (shuffle-vector-rev! v)
  (let* ((n (vector-length v))(k 0)(b 0)(z 0))
     (while (> n 1)
       (set! k  (+ b (random n) ))
       (set! z (vector-ref v k))
       (dec n)
       (vector-set! v k (vector-ref v b))
       (vector-set! v b z)
       (inc b)
     )
  v
))

(define (shuffle-list lis)
  (vector->list
      (shuffle-vector (list->vector lis)))
)

(define (shuffle-input)
   (let* ((res ())(x 0) )
         (set! x (read-line ))
      (while (not (eof-object? x))
         (push x res)
         (set! x (read-line ))
      )
     (set! res (shuffle-list res))
     (while (pair? res)
        (display (pop res))
        (newline)
     )
))
         
(define (shuffle-file in out)
   (redirect '(shuffle-input) in out #f)
)

#|
(define (test n)
  (let* ((v (make-vector n)))
    (do ((i 0 (+ i 1)))
        ((= i n))
        (vector-set! v i i)
    )
   (shuffle-vector! v)
))
|#
