;;;;   3D graphics
;;;   2002.7.26  by S.Sato
;;;   2002 9. 26  OGl version start

;;;  view setting
;;;  basic functions
;;;
;(load "init")
(load "mydemo")
(load "mypoly")
(load "proj")
(load "3df")
(load "save")
;;;(load "get-file")
(load "entry-get")
(load "3dfunc")
(load "toko")
;;;(load "zoom")
(load "psview")
(load "fonts")

(define *data* () )
(define *data-history* () )
(define *line* 1)
(define *toko* #f)
(define *mode* #f)  ;;; data file or function
(define *polymode* #f)  ;;;

(define *xmin* -1)
(define *xmax* 1)
(define *ymin* -1)
(define *ymax* 1)
(define *width* 750)
(define *height* 650)



(define  (view xmin xmax ymin ymax)
   (set! *xmin* xmin)
   (set! *xmax* xmax)
   (set! *ymin* ymin)
   (set! *ymax* ymax)
 )

(define (pos x y)
  (cons
     (floor (* *width*  (/ (-  x  *xmin*) (- *xmax* *xmin*))))
     (floor (* *height*  (/ (-  *ymax*  y) (- *ymax* *ymin*))))
  )
)



;(define (add-label)
;  (let ((s 0))
;     (set! s (entry-get ""))
;     (if (not(equal? s ""))
;        (.my.gl 'create 'text 
;           (/ *width* 2) 32  :text  s  :fill 'black
;           :tags  '(text line move)   :anchor 'sw :font '(courier 18) )
;      )
;))


(define (make-canvas)
  (toplevel '.ctl)
    
    (wm 'geometry .ctl "610x490+50+50")
   (label '.ctl.file :text "file name")
     (grid .ctl.file :sticky 'w  :columnspan 2)

;  (button '.ctl.print :text "Print"
;     :borderWidth  4 :activeBackground 'blue  :command '(ps-print))
;  (grid  .ctl.print :row 1 :column 1 :sticky 'w)
   (button '.ctl.getf :text "Read data"
     :borderWidth  4 :activeBackground 'blue  :command '(get-file))
  (grid .ctl.getf :row 1 :sticky 'w)
  
 ;  (button '.ctl.rewrite  :text "Rewrite"
 ;    :borderWidth  4 :activeBackground 'blue  :command '(rewrite))
 ; (grid  .ctl.rewrite :sticky 'w)
    (button '.ctl.func  :text "Function"
     :borderWidth  4 :activeBackground 'blue  :command '(3dfunc))
  (grid .ctl.func :sticky 'w)
 ;  (button '.ctl.save :text "Save PS"
 ;    :borderWidth  4 :activeBackground 'blue  :command '(ps-save))
 ; (grid .ctl.save :column 1 :row 2 :sticky 'w)
  (button '.ctl.savedata :text "Save Data"
     :borderWidth  4 :activeBackground 'blue  :command '(save-data))
  (grid .ctl.savedata :column 1 :row 3 :sticky 'w)
  (label '.ctl.lab1  :text "Input: ")
  (grid .ctl.lab1 :sticky 'e) 


    (checkbutton '.ctl.line  :variable '*line*
               :offvalue  #f 
            :text "line"    )
    (grid  .ctl.line :sticky 'w)
    (checkbutton '.ctl.toko  :variable '*toko*
               :offvalue  #f
            :text "tokosen"    )
    (grid .ctl.toko :sticky 'w)
     (checkbutton '.ctl.poly  :variable '*polymode*
               :offvalue  #f
            :text "polygon"    )
    (grid .ctl.poly :sticky 'w)

    (set! *line* #t)
    (.ctl.line 'configure :command '(line-check))
    (.ctl.toko 'configure :command '(toko-check))
    (.ctl.poly 'configure :command '(poly-check))

   (scale '.ctl.scaletk :from 10 :to 80 :length 200 :variable '*tokon*
    :label " Number of Tokosen"  :orient 'horizontal :tickinterval 10 :showvalue 'true)
   (grid   .ctl.scaletk :row 7 :rowspan 2 :column 1)
      (entry '.ctl.width  :bg 'snow :width 15)
     (.ctl.width  'insert 0 (tk-string *width*))
    (grid  .ctl.width :row 9 :column 1 :sticky 'w)
      (bind .ctl.width "<Return>" (lambda()(entry-width)))
      (label '.ctl.lab_w :text "width")     
      (grid  .ctl.lab_w  :row 9 :column 0 :sticky 'w)
       (entry '.ctl.height  :bg 'snow :width 15)
     (.ctl.height  'insert 0 (tk-string *height*))
      (grid  .ctl.height :row 10 :column 1 :sticky 'w)
      (bind .ctl.height "<Return>" (lambda()(entry-width)))
      (label '.ctl.lab_h :text "height")
      (grid  .ctl.lab_h  :row 10 :column 0 :sticky 'w)
   ;     (button '.ctl.label :text "Add label" :borderWidth  4 
    ;       :activeBackground 'blue   :command '(add-label))
   ;(grid .ctl.label :column 0 :row 11  :sticky 'e)
   (button '.ctl.exit :text "Exit" :borderWidth  4 :activeBackground 'red
             :command '(exit-ctl))
   (grid .ctl.exit :column 1 :row 4 :sticky 'e)
  (make-ogl)
   (focus .ctl) 
 )
(define (entry-width)
     (let ((w (.ctl.width 'get))(h (.ctl.height 'get)))
    (destroy .my)
    (set! *width* (string->number w))
    (set! *height* (string->number h))
    (make-ogl)
    (rewrite)
))   
(define (exit-ctl)
  (destroy .my)
  (destroy .ctl)
  (bye)
)
(define (line-check)
  ;(format #t "line check ~s~%" *line*)
  (clear_poly .my.gl)
  (clear)
  (set! *polymode* #f)
  (3d-display *data*)
) 
(define (toko-check)
  ;(format #t "toko check ~s~%" *toko*)
   (clear_poly .my.gl)
   (clear)
  (set! *polymode* #f)
  (3d-display *data*)
)
(define (poly-check)
  (if (not *polymode*)
   (begin
    (set! *line* #t)
    (line-check)
   )
  (begin
    (format #t "poly check ~s~%" *polymode*)
    (clear)
    (set! *toko* #f)
    (set! *line* #f)
    (plot-polygon .my.gl  *data*)
    (redraw)
  )
 )
)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (start)
  (make-canvas)
  (view -5.0  5.0  -5.0 5.0 )
  (set-fonts)
 ; (3df (lambda (x y)(+ (* x x)(* y y))) -1.0 1.0 -1.0 1.0)
 )


;;

(define (get-file)
  (let ((f 0))
    (set! f (get-file-name "*.dat3"))
    (if (and f (not (equal? f "")))
      (read-data f)
    )
))
(define (read-data file)
  (let ((s 0)(data ()))
       (clear_poly .my.gl)
    (set! *mode* (list  'data  file))
    (.ctl.file 'configure :text (tk-string (getcwd) #\/ file))
    (set! s (open-input-file file))
    (do ((ans ()) (x 0)(y 0)(z 0))
        ( (eof-object? x) (close-port s))
        (set! x (peek-char  s))
       (if (or (eq? x #\newline)(eq? x #\s)(eq? x #\#) (eof-object? x)) 
           (begin
             (when (not  (eq? x #\newline))
                (if (> (length ans) 0) (push (reverse ans) data))
                 (set! ans ())
              )
              (read-line s)
           )
           (begin 
             (set! x (read s))
             (set! y (read s))
             (set! z (read s))
             (push (list x y z) ans)
             
             (format #t "~s ~s ~s  ~%" x y z )	
           )
      )       
    )
  (set! *data* (reverse data))
  (set! *data-history* ())
  (if *line*
      (3d-display data)
      (begin 
        (clear_poly .my.gl)
        (screen-size data)
       (poly-check)
     )
  )
))
(define (3d-display data)
   (set! *data* data)
    ; (set-proj-base)
   (screen-size data)
   (when *line*
     (line-data data)
      (line-data (make-y-data data))
  )
  (if *toko*
    (toko-data data)
 )
 (write-axis)
 (redraw)
)
(define (3df f xmin xmax ymin ymax)
  (let ((x 0))
    (3d-display (3df-data  f xmin xmax ymin ymax))
))
(define (rewrite)
    (if (not (null? *data-history*))
        (set! *data* (pop *data-history*))
    )
     (3d-display *data*)
)
(start)







