package require Tkogl

proc compute_picture {} {
    global nedge nvtx edge vtx picture
    lappend l\
	    -clear colorbuffer depthbuffer \
	    -shademodel flat \
	    -begin lines
    for {set i 0} {$i < $nedge} {incr i} {
	eval lappend l -vertex $vtx($edge($i,0)) -vertex $vtx($edge($i,1))
    }
    lappend l -end -initnames -pushname -1 -pointsize 5 
    for {set i 0} {$i < $nvtx} {incr i} {
	eval lappend l -loadname $i -begin points -vertex $vtx($i) -end
    }
    if [info exists picture] { .gl deletelist $picture }
    set picture [eval .gl newlist $l]
}
    
proc redraw {} {
    global picture xrot yrot
    .gl main \
	    -matrixmode projection \
	    -loadidentity \
	    -ortho -4 4 -4 4 -4 4 \
	    -matrixmode modelview \
	    -loadidentity \
	    -rotate $yrot 1 0 0\
	    -rotate $xrot 0 1 0\
	    -call $picture
}

proc pick_point { x y } {
    global picture vtx pickvtx pickz
    set l [eval .gl select 100 \
	    -matrixmode projection \
	    -pushmatrix\
	    -loadidentity \
	    -pickmatrix $x $y 4 4\
	    -ortho -4 4 -4 4 -4 4 \
            -matrixmode modelview \
            -call $picture \
	    -matrixmode projection \
	    -popmatrix ]
    set pickvtx {}
    puts $l
    foreach hit $l {
	set pickvtx [lindex $hit 3]
	if {$pickvtx=={}} continue
	set pickz [lindex $hit 1] 
	puts "pick point $x $y"
	puts "vtx $pickvtx"
	puts "world coords $vtx($pickvtx)"
	puts "window coords [eval .gl project $vtx($pickvtx)]"
	break
    }
}

proc move_point { x y } {
    global pickvtx pickz vtx
    if {$pickvtx=={}} return
    set vtx($pickvtx) [.gl unproject $x $y $pickz]
    compute_picture
    redraw
}


pack [OGLwin .gl] -expand yes -fill both

set nvtx 0
foreach x {-1 1} {
    foreach y {-1 1} {
	foreach z {-1 1} {
	    set vtx($nvtx) "$x $y $z"
	    incr nvtx
	}
    }
}

set nedge 0
for {set i 0} {$i < 8} { incr i} {
    for {set j [expr $i+1]} {$j < 8} {incr j} {
	set count 0 
	for {set k 0} {$k < 3} {incr k} {
	    if [lindex $vtx($i) $k]==[lindex $vtx($j) $k] { incr count } 
	}
	if $count==2 {
	    set edge($nedge,0) $i 
	    set edge($nedge,1) $j
	    incr nedge
	}
    }
}

compute_picture
	
set xrot 10 
set yrot 10

bind .gl <Button-1> { set x %x ; set y %y }
bind .gl <B1-Motion> { 
    incr xrot [expr %x - $x] 
    incr yrot [expr %y - $y] 
    set x %x
    set y %y
    redraw
}
bind .gl <Button-3> { pick_point %x %y }
bind .gl <B3-Motion> { move_point %x %y }
redraw


