#include "tkogl.h"
#include "example.h"

#ifdef DUMMY
static int
ExampleCmd(clientData, interp, argc, argv)
    ClientData clientData;
    Tcl_Interp *interp;
    int argc;
    char **argv;
{
    /*
     * Note that we must be very careful not to use TCL_DYNAMIC here
     * if we are compiling with a compiler other than Borland C++ 4.5
     * because the malloc/free routines are different.  Instead, we
     * should explicitly set the free proc to point to the free()
     * supplied with the run-time library used by the extension.
     */

    Tcl_SetResult(interp, "example is not implemented yet", TCL_STATIC);
    return TCL_OK;
}
#endif

static TkOGLExtProc Example_cmd;

/*
 *----------------------------------------------------------------------
 *
 * DllEntryPoint --
 *
 *      This wrapper function is used by Windows to invoke the
 *      initialization code for the DLL.  If we are compiling
 *      with Visual C++, this routine will be renamed to DllMain.
 *      routine.
 *
 * Results:
 *      Returns TRUE;
 *
 * Side effects:
 *      None.
 *
 *----------------------------------------------------------------------
 */

#ifdef __WIN32__
BOOL APIENTRY
DllEntryPoint(hInst, reason, reserved)
    HINSTANCE hInst;            /* Library instance handle. */
    DWORD reason;               /* Reason this function is being called. */
    LPVOID reserved;            /* Not used. */
{
    return TRUE;
}
#endif

/*
 *----------------------------------------------------------------------
 *
 * Example_Init --
 *
 *      This procedure initializes the example command.
 *
 * Results:
 *      A standard Tcl result.
 *
 * Side effects:
 *      None.
 *
 *----------------------------------------------------------------------
 */

EXPORT(int,Example_Init)(interp)
    Tcl_Interp *interp;
{
    if (RegisterTkOGLExtension (interp, "example", Example_cmd) != TCL_OK)
       return TCL_ERROR;

    return Tcl_PkgProvide(interp, "example", "1.0");
}

/*
 * The actual example procedure
 */
int Example_cmd (Tcl_Interp *interp, int argc, char* argv [])
{
    glBegin (GL_TRIANGLES);
    glVertex2f (-1.0, 0.0);
    glVertex2f (0.0, 1.0);
    glVertex2f (1.0, 0.0);
    glEnd ();

    return TCL_OK;
}
